/*	$Id: YSM.h,v 1.26 2002/04/08 01:05:25 rad2k Exp $	*/
/*
-======================== You Sick Me v7 ===========================-

                                   |                                           
           - ----------------------                                          
    _      |                       |             _________________/_     _    
   _\____________   ______         _ __________  |               /             
     \           | _)    /                     \ |              /              
      \          |_\_  _/_______________/_      \|            _/               
                 |) /______________    /         \            |pix.imp         
                   /   \         )/___/         \  /          |                
  _    _\______   /    /__  ____/       - -------\/___________|               
         ` |  /__/        \/                                                   
           |          _      _           _                  __ ________ _      
           |                  )) y( O u  (s(i  C k    m.( E))                  
           |                                                                  
          -- ---------------- ---- -----                                     
                                  |                                            
                                  |                                            
-============================ YSM.h =================================-


YSM (YouSickMe) ICQ Client. An Original Multi-Platform ICQ client.
Copyright (C) 2002 rad2k Argentina.

YSM is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

For Contact information read the AUTHORS file.


*/


/* Windows users uncomment the following line before compiling. */
/* #define WIN32 */

/* BeOS users uncomment the following line! */
/* #define BEOS */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
#include <assert.h>
#include <ctype.h>
#include <errno.h>
#ifdef WIN32
#include <winsock.h>
#else
#include <unistd.h>
#include <sys/time.h>
#include <sys/types.h>
#include <sys/stat.h>
#endif
#ifdef BEOS
#include <sys/select.h>
#endif

#ifdef WIN32
#define snprintf	_snprintf
#endif

/* Multi Language support! */
#include "YSM_Lang.h"

typedef unsigned int UDWORD;
typedef unsigned short UWORD;
typedef unsigned char  UBYTE;

#ifndef WIN32
typedef char BYTE;
typedef short int WORD;
typedef int DWORD;

#include <sys/types.h>
#include <sys/wait.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <netdb.h>
#endif

#include "YSM_ICQv7.h"

#define YSM_MSG_KIND_ONELINE 0
#define YSM_MSG_KIND_VERBOSE 1
#define YSM_MSG_KIND_IRC 2

#define YSM_DEFAULT_MSG_KIND	YSM_MSG_KIND_IRC

#define YSM_SILENT_SLAVES_STATUS
#if 0
#define YSM_SLAVE_SLASH_MESSAGE
#define YSM_SHOW_SENT_PACKETS
#define YSM_DEBUG
#endif

#if !defined(WIN32) && !defined(BEOS) 
#define FALSE 0
#define TRUE !FALSE 
#endif

#ifdef WIN32
#define SOCK_READ(x,y,z) recv(x,y,z,0)
#define SOCK_WRITE(x,y,z) send(x,y,z,0)
#define SOCK_CLOSE(x)  closesocket(x)
#else
#define SOCK_READ(x,y,z) read(x,y,z)
#define SOCK_WRITE(x,y,z) write(x,y,z)
#define SOCK_CLOSE(x,y,z) close(x,y,z)
#endif

/* Definition of User Config Parameters */

#define YSM_INFORMATION		"[ You_Sick_Me v7 ] - Public Release - "
#define YSM_INFORMATION2	"2.7.0"

#ifdef WIN32
#define YSM_CFGFILENAME		"YSM-cfg"
#define YSM_CFGDIRECTORY	"ysm"
#else
#define YSM_CFGFILENAME		".YSM-cfg"
#define YSM_CFGDIRECTORY	".ysm"
#endif
#define YSM_DEFAULTSRV		"login.icq.com"
#define YSM_DEFAULTPORT		5190
#define YSM_DEFAULT_IDLETIME	5
#define YSM_KEEPALIVETIME	90

#ifndef WIN32
#define MAX_PATH		256
#endif
#define MAX_SLAVE_NICK		30
#define MAX_SEQS_FILED		50
#define MAX_DATA_LEN		450
#define MAX_PWD_LEN		12
#define MAX_UIN_LEN		14
#define MAX_CMD_LEN		300
#define MAX_LINE_LEN		80
#define MAX_STATUS_LEN		15
#define MAX_ICQNUM_LEN		14
#define MAX_CHARSET		10
#define MAX_SAVE_COUNT		10
/* In Micro Seconds */
#define MAX_READ_TIMEOUT	3000
#define YSM_DUMP_FILE		"dump.log"


/* Version Checking definitions */
#define YSM_VERSIONCHECK_HOST	"ysmv7.sourceforge.net"
#define YSM_VERSIONCHECK_FILE	"lastversion.dat"

/* Message Text Color definition */

#define COLOR_MSGTEXT		GREEN

/* AFK definitions */

#define YSM_AFKFILENAME		"afk.log"
#define YSM_AFK_MESSAGE		"I'm AFK (away from keyboard) right now. \
Your message has been saved. I'll be back shortly! :)"

/* Authorization Request definitions */

#define YSM_DEFAULT_AUTHREQ_MESSAGE	"Hi. I require your authorization in order to add you to my contacts list."

/* End of Config Parameters */


/* YSM Buddy List Group */
#define YSM_BUDDY_GROUPNAME	"YSM"
#define YSM_BUDDY_GROUPID	0x1337

#define YSM_BUDDY_SLAVE		0x0000
#define YSM_BUDDY_GROUP		0x0001

/* ok! */


/* Debug Level Definitions! */
#define YSM_VERBOSE_BASE	0x00
#define YSM_VERBOSE_FUNCTIONAL	0x01
#define YSM_VERBOSE_EXTRA	0x02
#define YSM_VERBOSE_DEBUG_1	0x06
#define YSM_VERBOSE_DEBUG_2	0x07
#define YSM_VERBOSE_DEBUG_3	0x08
#define YSM_VERBOSE_DEBUG_4	0x09
/* finishes here */

/* Start of Client Fingerprinting Definitions */

#define FINGERPRINT_YSM_CLIENT			0x01
#define FINGERPRINT_YSM_WIN32_CLIENT		0x02
#define FINGERPRINT_MIRANDA_CLIENT		0x03
#define FINGERPRINT_TRILLIAN_CLIENT		0x04
#define FINGERPRINT_CENTERICQ_CLIENT		0x05
#define FINGERPRINT_MISC_CLIENT			0x00


#define SLAVES_TAG	"SLAVES"

/* Definition of YSM Status */

#define NUM_ELEM_STATUS_ARR(arr)	(sizeof((arr))/sizeof((arr)[0]))

#define YSM_ONLINE      0x0000
#define YSM_OFFLINE     (-1)
#define YSM_INVISIBLE   0x0100
#define YSM_NA          0x0005
#define YSM_DND         0x0013
#define YSM_OCCUPIED    0x0011
#define YSM_FREE_CHAT   0x0020
#define YSM_AWAY        0x0001
#define YSM_AFK		0xfed0

/* End of Status definition */


/* Definition of Setup Commands */

#define SETUP_HOME 0
#define SETUP_CONFIG 1
#define SETUP_SLAVES 2

/* End of Setup Commands definition */

/* Definition of Slave Queries */

#define SLAVE_NAME		0x01
#define SLAVE_UIN		0x02

/* End of Slave Queries	*/

/* Definition of Prompt Commands */

#define YSM_COMMAND_QUIT	0x01
#define YSM_COMMAND_HELP	0x02
#define YSM_COMMAND_INFO	0x03
#define YSM_COMMAND_SLAVES	0x04
#define YSM_COMMAND_ADDSLAVE	0x05
#define YSM_COMMAND_DELSLAVE	0x06
#define YSM_COMMAND_AUTH	0x07
#define YSM_COMMAND_MESG	0x08
#define YSM_COMMAND_STATUS	0x09
#define YSM_COMMAND_LASTSENT	0x0a
#define YSM_COMMAND_REPLY	0x0b
#define YSM_COMMAND_WHOIS	0x0c
#define YSM_COMMAND_WHOSON	0x0d
#define YSM_COMMAND_BEEP	0x0e
#define YSM_COMMAND_CLRSCR	0x0f
#define YSM_COMMAND_LOGALL	0x10
#define YSM_COMMAND_AFK		0x11
#define YSM_COMMAND_SEARCH	0x12
#define YSM_COMMAND_READAFK	0x13
#define YSM_COMMAND_NICK	0x14
#define YSM_COMMAND_SAVE	0x15
#define YSM_COMMAND_REQ		0x16
#define YSM_COMMAND_UNKNOWN	0x00

/* End of Prompt Commands definition */



/* Definition of Message Types for Displaying functions */

#define YSM_MESSAGE_NORMAL	0x01
#define YSM_MESSAGE_URL		0x04
#define YSM_MESSAGE_AUTH	0x06
#define YSM_MESSAGE_AUTHNOT	0x07
#define YSM_MESSAGE_AUTHOK	0x08
#define YSM_MESSAGE_ADDED	0x0c

/* End of Message Types definitions */


/* Definition of ERROR standards */

#define ERROR_CODE		0
#define ERROR_CODE_M		"There has been a code ERROR. You should Debug.\n"
#define ERROR_NETWORK		1
#define ERROR_NETWORK_M		"There has been a Network Error. May try again?\n"
#define ERROR_CRITICAL		2
#define ERROR_CRITICAL_M	"There has been a CRITICAL Error. Watch your Back!\n"

/* End of ERROR Standards definition */

/* Definition of YSM Main Structures */

struct YSM_MAIN_INFO 
{
	char	NickName[MAX_SLAVE_NICK+1];
	char	FirstName[MAX_SLAVE_NICK+1];
	char	LastName[MAX_SLAVE_NICK+1];
	char	email[MAX_SLAVE_NICK+1];
};

struct SLAVE 
{

        BYTE		NickName[MAX_SLAVE_NICK];
        unsigned int	Uin;
        unsigned int	Status;
        unsigned char	IP[4];
	unsigned char	fprint;
	short int	LogFlag;
	short int	DownloadedFlag;
	int		ReqID;
	struct SLAVE	*next;	
	struct SLAVE	*back;	

};

struct YSM_MODEL
{ 

        UBYTE SRV_HostName[MAX_PATH];
	UDWORD SRV_IP;
	UWORD SRV_Port;
        UDWORD YSM_Uin;
        UDWORD YSM_Status;
        UDWORD YSM_IP;
        UDWORD YSM_Port;
	UWORD  YSM_Paranoid;
        UBYTE YSM_Password[MAX_PWD_LEN];
	UBYTE Proxy_host[MAX_PATH];
	UWORD Proxy_port;
	UBYTE Proxy_https;
	struct YSM_MAIN_INFO	YSM_info;
	
};

typedef struct SLAVE YSM_SLAVE;

/* End of Main Structures Definition */


/* Start of Required Exported Variables */

extern UWORD YSM_TCPSock;
extern UWORD YSM_Redraw_Console;
extern UWORD YSM_Logged_In;

/* End of Exported List */

/* Prototype of global Functions */

void YSM_Start (void);

int YSM_WRITE  (int sock, void *data, int data_len);
int YSM_READ (int sock, void *buf, int read_len);

int PRINTF(int verbose_level,char *fmt,...);
char * YSM_fgets(char *, int);

void YSM_CheckSecurity (void);
void YSM_KeysSetup (void);
int YSM_CheckKeysSetup (char YSM_UserInput);
void YSM_Setup (void);
void YSM_Error(int LEVEL);
void YSM_Debug(char *str);
void YSM_PasswdCheck (void);
void YSM_Console_Prompt (void);
void YSM_Login_InitA ( UDWORD Uin, UBYTE *Password );

void YSM_Destructor (void);

int YSM_VersionCheck (void);
int YSM_Connect ( UBYTE *Srv_Hostname, UWORD Srv_Port, int USE_PROXY, int v );

void YSM_DisplayMsg (int MessageType, int UIN, int STATUS, int LEN, char *DATA, char *Nick, int LogFlag );

void YSM_Set_Buddy_Status (FLAP_Head *, SNAC_Head snac, char *data);
void YSM_Set_Buddy_StatusB (int NewStatus, char *Uin, unsigned char *rIP);

DWORD YSM_Send_SNAC (int Family , int Subtype, BYTE FlA, BYTE FlB, char *data, unsigned int size, int lseq, char * reqid);
void YSM_Send_Message(int UIN, char *data, char *Nick, int LogFlag);
void YSM_SendAuthOK (int UIN, char *Nick);
void YSM_SendAuthRequest (int UIN, char *Nick, char *Message);
void YSM_SendContacts (int NewSeq);
void YSM_RemoveContact (YSM_SLAVE *Contact, int NewSeq);

void YSM_RequestInfo (UDWORD ContactUin, int fl, int NewSeq);
void YSM_IncomingInfo (char *buf, int fl, int tsize);
void YSM_InfoChange (int desired, char *newsetting);

void YSM_IncomingSearch (char *buf, int tsize);

void YSM_SearchUINbyMail (char *ContactMail, int NewSeq);

void YSM_AFKMode (UWORD turnon);
void YSM_ReadAFK (char *FileName);

int YSM_ChangeStatus (int NewStatus, int Flags, int sequence);
void YSM_WriteStatus(int STATUS,char *buf);
void YSM_WriteFingerPrint(int client, char *buf);
int YSM_LookupStatus (char *name);

void YSM_Buddy_RequestModify (void);
void YSM_Buddy_RequestFinished (void);
void YSM_Buddy_Ack (FLAP_Head *, SNAC_Head thesnac, char *buf);

void YSM_Buddy_AddItem(YSM_SLAVE *Item, char *grpName, int grpID ,int budID, int type, int cmd, int authawait);

void YSM_Incoming_BuddyChange (FLAP_Head *head, SNAC_Head thesnac, char *buf);

int YSM_Buddy_ReadSlave (char *buf,int tsize);
void YSM_IncomingMultiUse (FLAP_Head *head, SNAC_Head *thesnac, char *buf);

void YSM_KeepAlive (void);
void YSM_SrvResponse ( void );
void YSM_ConsoleRead ( void );

void YSM_Registration_UIN (char *Password);

void YSM_DoHelp ( char *cmd );
void DumpFLAP (FLAP_Head *);
void DumpSNAC (SNAC_Head incoming);

int YSM_DumpLogFile (char *fname,char *data);

int InsertTLV (void *string, int type, void *memplace, int len);

YSM_SLAVE *	YSM_SlaveCompletition	(char *Name);
YSM_SLAVE * YSM_QuerySlaves ( UWORD TYPE, UBYTE *Extra , UDWORD Uin );

void YSM_AddSlave ( char *Name, int Uin );
void YSM_AddSlavetoDisk (char *name, int uin);
void YSM_DelSlave ( char *Name );
void YSM_ReadSlaves(FILE *YSM_CFGFD);
int YSM_ParseSlave (char *name);

void YSM_PrintSlaves (YSM_SLAVE *YSMSlavesList, int FilterStatus, char *FString);

void YSM_PrintOrganizedSlaves (YSM_SLAVE *YSMSlavesList, int FilterStatus, char *Fstring);


FILE * YSM_OpenCFG ( void );

UDWORD Chars_2_DW (UBYTE * buf);
UWORD Chars_2_Word (UBYTE * buf);
UWORD Chars_2_Wordb (UBYTE * buf);
void DW_2_Chars (UBYTE * buf, UDWORD num);
void Word_2_Chars (UBYTE * buf, UWORD num);
void Word_2_Charsb (UBYTE * buf, UWORD num);

void EncryptPassword (char *Password, char *output);

void YSM_FDSelect_init (void);
void YSM_FDSet_timeout (UDWORD sec, UDWORD usec);
void YSM_FDAdd_rsocket (int sok);
int YSM_FDIs_Set (int sok);
int YSM_FDSelect (void);

long	YSM_GetMicroTime (long input);

int YSM_CountSlavesList (YSM_SLAVE *SlavesList);
int YSM_AddSlavetoList (YSM_SLAVE **SlavesList, char *Nick, int Uin, int fl);
void YSM_DeleteSlavefromList (YSM_SLAVE **SlavesList, char *Nick, int Uin);
YSM_SLAVE * YSM_FindSlaveinList (YSM_SLAVE *SlavesList, char *Nick, int Uin, int fl);

#if defined (WIN32) || defined (BEOS)
char * getpass (const char *prompt);
#endif

void YSM_ConsoleSetup();


/* End of Functions Prototype */

/* Colors definition Area */

#define BLACK "\x1B[0;30m"
#define WHITE "\x1B[0;1;37m"
#define RED "\x1B[0;31m"
#define GREEN "\x1B[0;32m"
#define BROWN "\x1B[0;33m"
#define BLUE "\x1B[0;34m"
#define MAGENTA "\x1B[0;35m"
#define CYAN "\x1B[0;36m"
#define NORMAL "\x1B[0;37m"

#define BRIGHT_BLACK	"\x1B[0;1;30m"
#define BRIGHT_RED	"\x1B[0;1;31m"
#define BRIGHT_GREEN	"\x1B[0;1;32m"
#define BRIGHT_BROWN	"\x1B[0;1;33m"
#define BRIGHT_BLUE	"\x1B[0;1;34m"
#define BRIGHT_MAGENTA	"\x1B[0;1;35m"
#define BRIGHT_CYAN	"\x1B[0;1;36m"
#define BRIGHT_WHITE	"\x1B[0;1;37m"

#define CLRSCR		"\033[2J"
#define BOLD		"\x1B[1m"

/* End of Colors definition Area */
