/*	$Id: YSM_Help.c,v 1.9 2002/04/08 00:59:50 rad2k Exp $	*/
/*
-======================== You Sick Me v7 ===========================-

                                   |                                           
           - ----------------------                                          
    _      |                       |             _________________/_     _    
   _\____________   ______         _ __________  |               /             
     \           | _)    /                     \ |              /              
      \          |_\_  _/_______________/_      \|            _/               
                 |) /______________    /         \            |pix.imp         
                   /   \         )/___/         \  /          |                
  _    _\______   /    /__  ____/       - -------\/___________|               
         ` |  /__/        \/                                                   
           |          _      _           _                  __ ________ _      
           |                  )) y( O u  (s(i  C k    m.( E))                  
           |                                                                  
          -- ---------------- ---- -----                                     
                                  |                                            
                                  |                                            
-========================== YSM_Help.c ============================-


YSM (YouSickMe) ICQ Client. An Original Multi-Platform ICQ client.
Copyright (C) 2002 rad2k Argentina.

YSM is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

For Contact information read the AUTHORS file.

*/

#include "YSM.h"
#include "YSM_Help.h"

UWORD YSM_VerifyHELPType ( UBYTE *auxb )
{
	int x;

 	for( x=0 ; x<= strlen (auxb) ; x++ )
		 auxb[x] = toupper ( auxb[x] );
	
	if (!strcmp(auxb,"QUIT") || !strcmp(auxb,"BYE") 
					|| !strcmp(auxb,"LEAVE"))
		return YSM_COMMAND_QUIT;

	if (!strcmp(auxb,"Q"))
		return YSM_COMMAND_QUIT;
		
	if (!strcmp(auxb,"HELP") || !strcmp(auxb,"?"))
		return YSM_COMMAND_HELP;

	if (!strcmp(auxb,"INFO")) 
		return YSM_COMMAND_INFO;

	if (!strcmp(auxb,"SLAVES") || !strcmp(auxb,"W"))
		return YSM_COMMAND_SLAVES;

	if (!strcmp(auxb,"WO") || !strcmp(auxb,"SLAVESONLINE"))
		return YSM_COMMAND_WHOSON;

	if (!strcmp(auxb,"ADD") || !strcmp(auxb,"ADDSLAVE"))
		return YSM_COMMAND_ADDSLAVE;

	if (!strcmp(auxb,"DEL") || !strcmp(auxb,"DELSLAVE"))
		return YSM_COMMAND_DELSLAVE;

	if (!strcmp(auxb,"AUTH"))
		return YSM_COMMAND_AUTH;

	if (!strcmp(auxb,"MSG") || !strcmp(auxb,"M"))
		return YSM_COMMAND_MESG;

	if (!strcmp(auxb,"A"))
		return YSM_COMMAND_LASTSENT;
	
	if (!strcmp(auxb,"R"))
		return YSM_COMMAND_REPLY;
	
	if (!strcmp(auxb,"STATUS"))
		return YSM_COMMAND_STATUS;

	if (!strcmp(auxb,"WHOIS"))
		return YSM_COMMAND_WHOIS;

	if (!strcmp(auxb,"BEEP"))
		return YSM_COMMAND_BEEP;

	if (!strcmp(auxb,"AFK"))
		return YSM_COMMAND_AFK;

	if (!strcmp(auxb,"READAFK"))
		return YSM_COMMAND_READAFK;

	if (!strcmp(auxb,"LOG"))
		return YSM_COMMAND_LOGALL;

	if (!strcmp(auxb,"SEARCH"))
		return YSM_COMMAND_SEARCH;

	if (!strcmp(auxb,"NICK"))
		return YSM_COMMAND_NICK;
	
	if (!strcmp(auxb,"SAVE"))
		return YSM_COMMAND_SAVE;

	if (!strcmp(auxb,"REQ"))
		return YSM_COMMAND_REQ;

	if (!strcmp(auxb,"CLEAR") || !strcmp(auxb,"C"))
		return YSM_COMMAND_CLRSCR;

	return YSM_COMMAND_UNKNOWN;
}


void YSM_DoHelp ( char *cmd )
{
	char *aux,*auxb;
	UBYTE YSM_SecHELP[MAX_CMD_LEN + 1];

	if ( !strlen (cmd) ) return;

	strncpy (YSM_SecHELP, cmd, MAX_CMD_LEN);

	if ( (aux = strtok (YSM_SecHELP, " " )) == NULL)  return;
	
	if ((auxb = strtok(NULL, " ")) == NULL)
	{
	PRINTF(YSM_VERBOSE_BASE, " Usage: HELP <command>\n");
	PRINTF(YSM_VERBOSE_BASE, " Commands list:\n <a> <r> <add> <auth> <del> <msg or m> <quit or q> <r> <status> <w o slaves> <wo or slavesonline> <whois> <info> <beep> <log> <afk> <readafk> <search> <clear>\n");
	return;
	}	

	auxb = strtok(cmd, " ");
	auxb = strtok(NULL, " ");

	switch ( YSM_VerifyHELPType (auxb))
	{

		case YSM_COMMAND_QUIT:
			PRINTF(YSM_VERBOSE_BASE, YSM_COMMAND_QUIT_HELP);
			break;

		case YSM_COMMAND_HELP:
			PRINTF(YSM_VERBOSE_BASE, YSM_COMMAND_HELP_HELP);
			break;

		case YSM_COMMAND_LASTSENT:
			PRINTF(YSM_VERBOSE_BASE, YSM_COMMAND_LASTSENT_HELP);
			break;

		case YSM_COMMAND_REPLY:
			PRINTF(YSM_VERBOSE_BASE, YSM_COMMAND_REPLY_HELP);
			break;

		case YSM_COMMAND_MESG:
			PRINTF(YSM_VERBOSE_BASE, YSM_COMMAND_MESG_HELP);
			break;

		case YSM_COMMAND_AUTH:
			PRINTF(YSM_VERBOSE_BASE, YSM_COMMAND_AUTH_HELP);
			break;


		case YSM_COMMAND_WHOIS:
			PRINTF(YSM_VERBOSE_BASE, YSM_COMMAND_WHOIS_HELP);
			break;

		case YSM_COMMAND_STATUS:
			PRINTF(YSM_VERBOSE_BASE, YSM_COMMAND_STATUS_HELP);
			break;


		case YSM_COMMAND_SLAVES:	
			PRINTF(YSM_VERBOSE_BASE, YSM_COMMAND_SLAVES_HELP);
			break;

		case YSM_COMMAND_ADDSLAVE:
			PRINTF(YSM_VERBOSE_BASE, YSM_COMMAND_ADDSLAVE_HELP);
			break;

		case YSM_COMMAND_DELSLAVE:
			PRINTF(YSM_VERBOSE_BASE, YSM_COMMAND_DELSLAVE_HELP);
			break;

		case YSM_COMMAND_BEEP:
			PRINTF(YSM_VERBOSE_BASE, YSM_COMMAND_BEEP_HELP);
			break;
	
		case YSM_COMMAND_AFK:
			PRINTF(YSM_VERBOSE_BASE, YSM_COMMAND_AFK_HELP);
			break;
	
		case YSM_COMMAND_READAFK:
			PRINTF(YSM_VERBOSE_BASE, YSM_COMMAND_READAFK_HELP);
			break;

		case YSM_COMMAND_LOGALL:
			PRINTF(YSM_VERBOSE_BASE, YSM_COMMAND_LOGALL_HELP);
			break;

		case YSM_COMMAND_WHOSON:
			PRINTF(YSM_VERBOSE_BASE, YSM_COMMAND_SLAVESONLINE_HELP);
			break;

		case YSM_COMMAND_SEARCH:
			PRINTF(YSM_VERBOSE_BASE, YSM_COMMAND_SEARCH_HELP);
			break;

		case YSM_COMMAND_NICK:
			PRINTF(YSM_VERBOSE_BASE, YSM_COMMAND_NICK_HELP);
			break;
	
		case YSM_COMMAND_SAVE:
			PRINTF(YSM_VERBOSE_BASE, YSM_COMMAND_SAVE_HELP);
			break;
	
		case YSM_COMMAND_REQ:
			PRINTF(YSM_VERBOSE_BASE, YSM_COMMAND_REQ_HELP);
			break;

		case YSM_COMMAND_CLRSCR:
			PRINTF(YSM_VERBOSE_BASE, YSM_COMMAND_CLRSCR_HELP);
			break;

		default:
			PRINTF(YSM_VERBOSE_BASE, " Unknown command.\n\n");
			break;

	}	

	return;
}

