/*	$Id: YSM_Main.c,v 1.16 2002/04/08 00:51:51 rad2k Exp $	*/
/*
-======================== You Sick Me v7 ===========================-

                                   |                                           
           - ----------------------                                          
    _      |                       |             _________________/_     _    
   _\____________   ______         _ __________  |               /             
     \           | _)    /                     \ |              /              
      \          |_\_  _/_______________/_      \|            _/               
                 |) /______________    /         \            |pix.imp         
                   /   \         )/___/         \  /          |                
  _    _\______   /    /__  ____/       - -------\/___________|               
         ` |  /__/        \/                                                   
           |          _      _           _                  __ ________ _      
           |                  )) y( O u  (s(i  C k    m.( E))                  
           |                                                                  
          -- ---------------- ---- -----                                     
                                  |                                            
                                  |                                            
-========================== YSM_Main.c =============================-

YSM (YouSickMe) ICQ Client. An Original Multi-Platform ICQ client.
Copyright (C) 2002 rad2k Argentina.

YSM is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

For Contact information read the AUTHORS file.

*/

#include <sys/types.h>
#ifndef WIN32
#include <sys/wait.h>
#endif
#include <errno.h>
#include <string.h>

#include "YSM.h"

UWORD	YSM_Reason_To_Suicide = FALSE;
UWORD	YSM_Redraw_Console = FALSE;

UWORD	YSM_SETTING_MSG_KIND = YSM_DEFAULT_MSG_KIND;
UWORD	YSM_SETTING_VERBOSE = 2;
UWORD	YSM_SETTING_BEEP = TRUE;
UWORD	YSM_SETTING_LOGALL = FALSE;
UWORD	YSM_SETTING_AFK = FALSE;
UWORD	YSM_SETTING_AFKMAXSHOWN = 3;
/* Default IDLETIME timeout to set in AFK mode */
UWORD	YSM_SETTING_IDLETIME = YSM_DEFAULT_IDLETIME;

UWORD	YSM_SETTING_ASK_KEYMAP = 0;
UWORD	YSM_SETTING_ASK_DOWNLOAD = 1;

UWORD	YSM_SETTING_VERSION_CHECK = TRUE;

UBYTE	YSM_KEYMAP_HELP = '1';
UBYTE	YSM_KEYMAP_WHOSON = '2';
UBYTE	YSM_KEYMAP_SLAVES = '3';

extern UBYTE YSM_Command[MAX_CMD_LEN + 1];
extern UWORD YSM_Message_Arrived;
extern int Curr_CMDLEN;

YSM_SLAVE *YSMSlavesList, *YSMSlaves_First;
YSM_SLAVE *YSM_Query, *YSMSlaves_LastSent=0, *YSMSlaves_LastRead=0;

struct YSM_MODEL YSM_USER;

time_t	YSM_IdleTIME, YSM_LastKA;

int
main(int argc, char **argv)
{

#ifdef WIN32
	WSADATA wsaData;
#endif
	time_t YSM_StartTime = time(NULL);

#ifndef WIN32
	YSM_CheckSecurity();
#endif

	PRINTF(YSM_VERBOSE_FUNCTIONAL,
			"\n" CYAN "%s%s" NORMAL "\n%s\n", YSM_INFORMATION,
						 YSM_INFORMATION2,
						 MSG_STARTING_ONE);
#ifdef WIN32
	if (WSAStartup(0x0101, &wsaData ) != 0) {
		PRINTF(YSM_VERBOSE_BASE,
			"Can't open MS. Windows sockets, exiting..\n");
		exit(-1);
	}
#endif

	YSMSlavesList = (YSM_SLAVE *)malloc(sizeof(YSM_SLAVE));
	if (YSMSlavesList == NULL) 
	{
		fprintf(stderr, "Can't alloc memory: %s.\n", strerror(errno));
		YSM_Error(ERROR_CRITICAL);
		/* NOTREACHED */
	}
	memset(YSMSlavesList, '\0', sizeof(YSM_SLAVE));
	memset(&YSM_USER, '\0', sizeof(YSM_USER));
	YSMSlaves_First = YSMSlavesList;

	YSM_ConsoleSetup();
	YSM_Setup();

        PRINTF(YSM_VERBOSE_FUNCTIONAL,
			"\n%s %d ]\n",MSG_STARTING_TWO, YSM_USER.YSM_Uin);
	PRINTF(YSM_VERBOSE_FUNCTIONAL,
		"Cronica TV hora Actual : %s\n", ctime(&YSM_StartTime));

	YSM_PasswdCheck();

	if(YSM_SETTING_VERSION_CHECK)
		YSM_VersionCheck();

	if(YSM_SETTING_ASK_KEYMAP)
		YSM_KeysSetup();


	/* Initialize YSM */

	YSM_Start ();

	return (0);
}


void
YSM_Start (void)
{

	if (YSM_Connect(YSM_USER.SRV_HostName, YSM_USER.SRV_Port,
				atoi(YSM_USER.Proxy_host) ? 0x1 : 0x0, 1 ) < 0) 
		YSM_Error(ERROR_NETWORK);

	YSM_Login_InitA(YSM_USER.YSM_Uin, YSM_USER.YSM_Password);

	YSM_IdleTIME = YSM_LastKA = time(NULL);
	
	while (!YSM_Reason_To_Suicide) 
	{
		if (YSM_Redraw_Console) 
		{
			YSM_Console_Prompt();
			YSM_Redraw_Console = FALSE;

/* So we tell the Prompt to re-draw the command line in case
	we were typing anything, so we dont get confused and loose into
	insanity :) */

			if (Curr_CMDLEN && YSM_Message_Arrived)
			{
				YSM_Message_Arrived = FALSE;
				PRINTF(YSM_VERBOSE_BASE,"%s",YSM_Command);
			} 
			else YSM_Message_Arrived = FALSE;

		}
#ifdef WIN32
		YSM_FDSet_timeout(0, 100000);
#else
		YSM_FDSet_timeout(2, 500000);
#endif
		YSM_FDSelect_init();
		YSM_FDAdd_rsocket(YSM_TCPSock);

#ifndef WIN32
		YSM_FDAdd_rsocket(0);
#endif
		YSM_FDSelect();

		if (YSM_FDIs_Set(YSM_TCPSock))
			YSM_SrvResponse();

#ifdef WIN32
		YSM_ConsoleRead();
#else
                if (YSM_FDIs_Set(0))
			YSM_ConsoleRead();
#endif

		YSM_KeepAlive ();

		if ( (YSM_SETTING_IDLETIME)  && !(YSM_SETTING_AFK) &&
		( (time(NULL) - YSM_IdleTIME)/60 >= YSM_SETTING_IDLETIME) )
		{
			if(YSM_USER.YSM_Status != YSM_INVISIBLE &&
					!YSM_SETTING_AFK)
			{
				PRINTF(YSM_VERBOSE_BASE,
					"\n%s",MSG_IDLE_TIME_REACHED);
				YSM_AFKMode(TRUE);
				YSM_Redraw_Console = TRUE;
			}
		}

#ifndef WIN32
                while (waitpid(-1, NULL, WNOHANG) > 0);
#endif
	}

		return;
}
