/*	$Id: YSM_Network.c,v 1.27 2002/04/08 00:49:18 rad2k Exp $	*/
/*
-======================== You Sick Me v7 ===========================-

                                   |                                           
           - ----------------------                                          
    _      |                       |             _________________/_     _    
   _\____________   ______         _ __________  |               /             
     \           | _)    /                     \ |              /              
      \          |_\_  _/_______________/_      \|            _/               
                 |) /______________    /         \            |pix.imp         
                   /   \         )/___/         \  /          |                
  _    _\______   /    /__  ____/       - -------\/___________|               
         ` |  /__/        \/                                                   
           |          _      _           _                  __ ________ _      
           |                  )) y( O u  (s(i  C k    m.( E))                  
           |                                                                  
          -- ---------------- ---- -----                                     
                                  |                                            
                                  |                                            
-========================== YSM_Network.c ============================-

YSM (YouSickMe) ICQ Client. An Original Multi-Platform ICQ client.
Copyright (C) 2002 rad2k Argentina.

YSM is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

For Contact information read the AUTHORS file.

*/

#include "YSM.h"
/* International Languages Charset Convertion! */
#include "YSM_Iconv.h"

int YSM_Connect ( UBYTE *Srv_Hostname, UWORD Srv_Port, int USE_PROXY, int v );
int YSM_LookupHN ( UBYTE *Hostname); 
void YSM_Login_InitA ( UDWORD Uin, UBYTE *Password );
void YSM_Login_InitB ( FLAP_Head *, char *, int);
void YSM_Login_InitC ( TLV thetlv, char *buff);

void YSM_RequestContacts (int NewSeq);
void YSM_RequestOffline (int NewSeq);
void YSM_AckOffline (int NewSeq);
void YSM_RequestBuddyRights (int NewSeq);
void YSM_RequestRates (int NewSeq);

void YSM_Incoming_BuddyList (FLAP_Head *head, SNAC_Head thesnac, char *buf);
int YSM_Incoming_SNAC (FLAP_Head *, char *, int);
void YSM_ReceiveMessage (FLAP_Head *, SNAC_Head snac, char *data);
void YSM_Receive_Message_TypeA (int tsize, unsigned char *data, char *RemoteUIN, char *RemoteSTATUS, char *msgid);
void YSM_Receive_Message_TypeB (int tsize, unsigned char *data, char *RemoteUIN, char *RemoteSTATUS);
void YSM_Registration_Reply (FLAP_Head *head, SNAC_Head thesnac, char *buf);
void YSM_IncomingPersonal( FLAP_Head *head, SNAC_Head thesnac, char *buf);
void YSM_RequestPersonal(int NewSeq);

UWORD YSM_TCPSock;
UWORD YSM_Logged_In = FALSE;
UWORD YSM_SeqNum = 1;	

/*	GroupID_List will hold a list of the WORD ids of
	every group. GroupID_Users will hold a list of the
	WORD ids of every user in OUR group.  */

char *YSM_GroupID_List = NULL;
char *YSM_GroupID_Users = NULL;
int YSM_GroupID_Amount = 0;
int YSM_GroupID_Users_Amount = -1;

/*	For making any further changes to our Buddy list, we need to
	increment the counter for what we get in our incoming buddy list ! */

int YSM_Buddy_ChangeCount = 0;

/* Used for RequestInfo with OUR info */
DWORD YSM_personal_infoid = 0;
WORD DOWNLOADED_CONTACTS = FALSE;

/* Required for storing the reqid for the creation of the YSM group */
/* Since this is C language ;) and it would be the same to add it */
/* in the ysm USER structure. Don't cry! */
DWORD YSM_Group_ReqID = 0;

extern UWORD YSM_Redraw_Console;
extern UWORD AmountSlaves;
extern UWORD YSM_Message_Arrived;
extern UWORD YSM_SETTING_BEEP;
extern UWORD YSM_SETTING_AFK;
extern UWORD YSM_SETTING_ASK_DOWNLOAD;
extern UWORD YSM_SETTING_LOGALL;

extern UBYTE YSM_AFKMessage[MAX_DATA_LEN];

extern YSM_SLAVE *YSM_Query;
extern YSM_SLAVE *YSMSlaves_LastRead;
extern YSM_SLAVE *YSMSlavesList,*YSMSlaves_First;

extern struct YSM_MODEL YSM_USER;

extern time_t YSM_LastKA;

#ifdef YSM_USE_ICONV
extern UBYTE YSM_SETTING_CHARSET_TRANS[MAX_CHARSET + 4];
extern UBYTE YSM_SETTING_CHARSET_LOCAL[MAX_CHARSET + 4];
#endif

int YSM_Connect ( UBYTE *Srv_Hostname, UWORD Srv_Port, int USE_PROXY, int v ) 
{

	int YSMtmp;
	struct sockaddr_in YSMSRV;
	struct hostent *YSM_tmph;
	char proxy_string[512], *aux, q;


		YSM_TCPSock = socket (AF_INET, SOCK_STREAM, 0);
		memset(proxy_string, '\0', sizeof(proxy_string));

	if(USE_PROXY)
	{
		YSM_LookupHN ( YSM_USER.Proxy_host );
		YSMSRV.sin_addr.s_addr = YSM_USER.SRV_IP;
	}
	else
	{

		YSM_LookupHN ( Srv_Hostname );
		YSMSRV.sin_addr.s_addr = YSM_USER.SRV_IP;
	}
		
		if (YSMSRV.sin_addr.s_addr == -1) 
		{
	if(USE_PROXY)
			YSM_tmph = gethostbyname (YSM_USER.Proxy_host);
	else
			YSM_tmph = gethostbyname (Srv_Hostname);
			if (YSM_tmph == NULL) return -1;
			YSMSRV.sin_addr = *((struct in_addr *)YSM_tmph->h_addr);
		}

		YSMSRV.sin_family = AF_INET;
	if(USE_PROXY)
		YSMSRV.sin_port = htons (YSM_USER.Proxy_port);
	else
		YSMSRV.sin_port = htons (Srv_Port);

		if (connect (YSM_TCPSock, (struct sockaddr *)&YSMSRV,
						sizeof( YSMSRV )) < 0 )

			YSM_Error (ERROR_NETWORK);

	if(USE_PROXY)
	{
		if(v)
			PRINTF(YSM_VERBOSE_BASE ,
			"\nConnected to the PROXY!\n");

		snprintf(proxy_string, sizeof(proxy_string)-1, 
				"CONNECT %s:%d HTTP/1.0\n\n",
					Srv_Hostname,
					YSM_USER.Proxy_https ? 443 : 5190 );

		YSM_WRITE(YSM_TCPSock,proxy_string,sizeof(proxy_string));

		memset(proxy_string,'\0',sizeof(proxy_string));
		while(strlen(proxy_string) < 10)
			YSM_READ( YSM_TCPSock,&proxy_string,
						sizeof(proxy_string)-1);


		aux = strtok(proxy_string,"\n");
		if( !strstr(aux,"HTTP/1.0 200") )
		{
			PRINTF(YSM_VERBOSE_BASE,
			"\nProxy returned an ERROR!::");
			PRINTF(YSM_VERBOSE_BASE,
			"\ndump output to screen?[y/n]: ");

			q = getchar();
			if(toupper(q) == 'Y')
				PRINTF(YSM_VERBOSE_BASE,
				"\n%s",aux);

			exit(0);
		}

	}

		YSMtmp = sizeof (YSMSRV);
		getsockname (YSM_TCPSock, (struct sockaddr *)&YSMSRV, &YSMtmp);
		
		YSM_USER.YSM_IP = YSMSRV.sin_addr.s_addr;
		YSM_USER.YSM_Port = ntohs ( YSMSRV.sin_port );

		if(v)	
			PRINTF(YSM_VERBOSE_EXTRA,
			"\nTCP connection established with ICQ SERVER.\n");

		if(v)
	        	PRINTF(YSM_VERBOSE_FUNCTIONAL,
			"%s %d].\n",MSG_NETWORK_INFO, YSM_USER.YSM_Port);
		
		return 0;
}

int YSM_LookupHN ( UBYTE *Hostname ) {

        struct hostent *YSMhalf;

        if ( ( YSM_USER.SRV_IP = inet_addr ( Hostname ) ) == -1 ) 
	{
                if ( ( YSMhalf = gethostbyname ( Hostname ) ) == NULL ) 
				YSM_Error(ERROR_NETWORK);

                memcpy (&YSM_USER.SRV_IP, (YSMhalf->h_addr), 4);
        }
                return 0;
}


void
YSM_SrvResponse(void)
{
	char		*buf=0;
	FLAP_Head	head;
	int		r = 0;


	memset(&head,0,FLAP_HEAD_SIZE);

	YSM_READ(YSM_TCPSock,&head,FLAP_HEAD_SIZE);

	buf = malloc(Chars_2_Wordb(head.dlen));

	r = YSM_READ(YSM_TCPSock, buf, Chars_2_Wordb(head.dlen));

	switch(head.channelID)
	{ 

	case YSM_CHANNEL_NEWCON:
		break;

	case YSM_CHANNEL_SNACDATA:
		YSM_Incoming_SNAC(&head,buf,r);
		break;
		
	case YSM_CHANNEL_FLAPERR:
		break;

	case YSM_CHANNEL_CLOSECONN:
		if(!YSM_Logged_In)
			YSM_Login_InitB(&head, buf, r);
		else
		{
			PRINTF(YSM_VERBOSE_BASE,
			"\nGOT FUCKING Disconnected by the SERVER.\n");
			PRINTF(YSM_VERBOSE_EXTRA,
			"Arrgh, im quiting..");
			YSM_Error(ERROR_NETWORK);
		}
		break;

	default:

		PRINTF(YSM_VERBOSE_DEBUG_2,"\nEl channel ID es: %d\n",head.channelID);
		PRINTF (YSM_VERBOSE_DEBUG_2,
				 "[ERR] Inexisting channel ID received");
		PRINTF (YSM_VERBOSE_DEBUG_2,
				 "inside a FLAP structure.\n");
		PRINTF (YSM_VERBOSE_DEBUG_2,
				 "As I'm a paranoid one.. i'll disconnect.\n");

		break;
	}	

	free(buf);
	
}


int
YSM_Incoming_SNAC(FLAP_Head *head, char *buf, int buflen)
{
	SNAC_Head	 thesnac;
	int		 a = 0;
	int		 newseq;

	if (buflen < (SNAC_HEAD_SIZE) || Chars_2_Wordb(head->dlen) > buflen)
		return (-1);

	/* copy, and beware of padding of structs */
	memcpy (&thesnac, buf, SNAC_HEAD_SIZE);
	memcpy (&thesnac.ReqID, &buf[6], sizeof(DWORD));

	PRINTF(YSM_VERBOSE_DEBUG_1,"SNAC id %x and sub %x\n",Chars_2_Wordb(thesnac.familyID),
	Chars_2_Wordb(thesnac.SubTypeID)); 

	switch(Chars_2_Wordb(thesnac.familyID))
	{

		case YSM_BASIC_SERVICE_SNAC:

		PRINTF(YSM_VERBOSE_DEBUG_1, "Basic Service SNAC arrived!\n");

		switch(Chars_2_Wordb(thesnac.SubTypeID))
		{
			case YSM_SERVER_IS_READY:
				PRINTF(YSM_VERBOSE_DEBUG_1,
					"Server Ready. Notifying the\n");
				PRINTF(YSM_VERBOSE_DEBUG_1,
					"server that we are an ICQ client\n");

				a = YSM_Send_SNAC( 
						0x1,
						0x17,
						0x0,
						0x0,
						(char *)icqCloneIdent,
						sizeof(icqCloneIdent),
						Chars_2_Wordb(head->seq), NULL);
				break;

		
			case YSM_ACK_ICQ_CLIENT:
				a = YSM_Send_SNAC(
						0x1,
						0x2,
						0x0,
						0x0,
						(char *)icq2000vstring,
						sizeof(icq2000vstring),	
						Chars_2_Wordb(head->seq),NULL);

				newseq = Chars_2_Wordb(head->seq);
	

				 /* If we had no slaves at all,
				  * we were sending an empty packet. */

				if(AmountSlaves>0)
				{
					YSM_SendContacts(newseq);
					newseq +=2;	
				}
				else newseq++;
	
				YSM_RequestBuddyRights(newseq);

				newseq++;
				YSM_RequestContacts (newseq);

				newseq++;
				YSM_RequestOffline (newseq);

				newseq++;
				YSM_RequestRates (newseq);

				newseq++;
				YSM_RequestPersonal (newseq);

				newseq++;
				/* Save timE! we are online by default! */
				if(YSM_USER.YSM_Status != YSM_ONLINE)
				YSM_ChangeStatus(YSM_USER.YSM_Status,
							0x0,
							newseq);
				break;

			case YSM_STATUS_CHANGE_ACK:
				PRINTF(YSM_VERBOSE_DEBUG_1,"Status Changed\n");
				break;

			case YSM_RATE_INFO_RESP:
		/* Just an ACK that we received the rates */
				YSM_Send_SNAC(
					0x1,
					0x08,
					0x0,
					0x0,
					(char *)Rates_Acknowledge,
					sizeof(Rates_Acknowledge),
					YSM_SeqNum,NULL);	
				break;

			case YSM_SCREEN_INFO_RESP:
				YSM_IncomingPersonal ( head, thesnac,
				   		 &buf[SNAC_HEAD_SIZE]);
				break;
	
			default:
				break;

		}

		break;
				

		case YSM_MESSAGING_SNAC:

		switch(Chars_2_Wordb(thesnac.SubTypeID))
		{
			case YSM_MESSAGE_TO_CLIENT:
				YSM_ReceiveMessage (head, thesnac,
				    &buf[SNAC_HEAD_SIZE]);
				break;
		
			case YSM_MESSAGE_FROM_CLIENT:
				break;

			case YSM_HOST_ACK:	/* just a srv ack */
				break;
		
			case YSM_SRV_MISSED_CALLS:
				PRINTF(YSM_VERBOSE_EXTRA,"\nAOL Warning! msg lost! stop ");
				PRINTF(YSM_VERBOSE_EXTRA,"sending messages too fast!");
				break;

			case YSM_CLI_SRV_ERRORMSG:
	/* We used to have lots of 0x1 subtypes printf's on the screen
	big mistake! not all of the error-codes are known and
	they still are useless for us. Plus, no printf's of %s now.*/

	/* Most of these errors are caused by really sucking
	features of the new-era icq clients, such as plugins yuk! */
				break;

			default:
	/* Dont bother the user with new subtypes arriving */
				break;
		}	

		break;


		case YSM_BUDDY_LIST_SNAC:

		switch(Chars_2_Wordb(thesnac.SubTypeID))
		{
			case YSM_SRV_ONCOMING_BUD:
				YSM_Set_Buddy_Status (head, thesnac,
				    &buf[SNAC_HEAD_SIZE]);
				break;

			case YSM_SRV_OFFGOING_BUD:
				YSM_Set_Buddy_Status (head, thesnac,
				    &buf[SNAC_HEAD_SIZE]);
				break;
			
			case YSM_SRV_REJECT_NOTICE:
				/* woha this seems serious..mama mia. */
				break;

			case YSM_SRV_RIGHTS_INFO:
				/* reply to rights request, just */
				/* we wont care about the data */
				break;

			default:

				PRINTF(YSM_VERBOSE_DEBUG_1,
				"\n[ERR]:  Unknown subtype");
				PRINTF(YSM_VERBOSE_DEBUG_1,
				": %x - in Buddy List SNAC\n",
				Chars_2_Wordb(thesnac.SubTypeID));

				break;
		}


		break;


		case YSM_MULTIUSE_SNAC:

		switch(Chars_2_Wordb(thesnac.SubTypeID))
		{

			case YSM_SRV_SEND_RESP:
				YSM_IncomingMultiUse(head, &thesnac,
				    &buf[SNAC_HEAD_SIZE]);
				break;

			default:
				break;
		}

		break;

		case YSM_ICQV8FUNC_SNAC:

		switch(Chars_2_Wordb(thesnac.SubTypeID))
		{
			case YSM_SRV_SEND_ROSTER:
				YSM_Incoming_BuddyList(head, thesnac,
				&buf[SNAC_HEAD_SIZE]);
				break;
		
			case YSM_SRV_ROSTER_OK:
				break;

			case YSM_SRV_CHANGE_ACK:
				YSM_Incoming_BuddyChange(head, thesnac,
				&buf[SNAC_HEAD_SIZE]);
				break;
				
			default:
				break;
		}


		break;

		case YSM_REGISTRATION_SNAC:

		switch(Chars_2_Wordb(thesnac.SubTypeID))
		{
			case YSM_SRV_REPLY_REG:
				YSM_Registration_Reply(head, thesnac,
				&buf[SNAC_HEAD_SIZE]);
				break;

			default:
				break;
		}


		break;



		default:
			break;

	}

	return (Chars_2_Wordb(head->dlen) + FLAP_HEAD_SIZE);
}

void YSM_Set_Buddy_Status (FLAP_Head *flap, SNAC_Head snac, char *data)
{
	char *Uin,*buf,nStat[2];
	int Uinlen,x=0,len,notfound=FALSE;
	unsigned char rIP[4];

	if (data == NULL || data[0] == '\0')
		return;

	Uinlen = data[0];

	Uin = malloc(Uinlen+1);

	memset(Uin,'\0',Uinlen+1);
	memcpy(Uin,data+1,Uinlen);

/* We will use the variable x for going through all the TLV's */
/* Thats why we've got to start where the first TLV is. */

	x++;		
	x += Uinlen;
	x += 4;			/* Following 2 Words (2+2 = 4 bytes) */
	
	switch(Chars_2_Wordb(snac.SubTypeID))
	{
		case YSM_SRV_ONCOMING_BUD:

		while(x < (Chars_2_Wordb(flap->dlen) - SNAC_HEAD_SIZE))
		{

		/* *data should point to the TLV type field. */

			switch (Chars_2_Wordb(data+x))
			{

				case 0xA:
				{
				len = Chars_2_Wordb(data+x+2);
				x += sizeof(TLV);
				rIP[0] = data[x];
				rIP[1] = data[x+1];
				rIP[2] = data[x+2];
				rIP[3] = data[x+3];
				x += len;
				break;
				}

				case 0x6:
				{
				len = Chars_2_Wordb(data+x+2);
				buf = malloc(len);
				memcpy(buf,data+x+4,len);
				memset(nStat,'\0',sizeof(nStat));	
				nStat[0] = buf[2];
				nStat[1] = buf[3];
				free(buf);
				/*
				 * just cheat and quit, we only care
				 * about the STATUS by now.
				 */
				x = Chars_2_Wordb(flap->dlen)-SNAC_HEAD_SIZE;
				break;
				}

				case 0xf:
				{
				/*
				 * we use 0xf as a limit, since 0x6 (the status)
				 * must be before 0xf for sure. 
				 */
				notfound = TRUE;
				x = Chars_2_Wordb(flap->dlen)-sizeof(snac);
				break;
				}
			
				default:
				{
				/*data + 2 should contain
					the TLV len data field. */

				x += Chars_2_Wordb(data+x+2);
				x += sizeof(TLV);
				break;
				}
			
			}

		}					
				
		/*
		 * This is really raro, at a beginning I believe i was
		 * actually receiving the ONLINE status change, but it 
		 * now seems i'm not! Anyways, we know that if its an
		 * ONCOMING bud message and we dont find the status, 
		 * its online, smart, huh? =)
		 */
	
		if(notfound)
			YSM_Set_Buddy_StatusB(YSM_ONLINE,Uin,rIP);
		else
			YSM_Set_Buddy_StatusB(Chars_2_Wordb(nStat),Uin,rIP);
		break;

		case YSM_SRV_OFFGOING_BUD:
		YSM_Set_Buddy_StatusB(YSM_OFFLINE,Uin,rIP);
		break;
	}

	free(Uin);
	return;
}


void YSM_Set_Buddy_StatusB (int NewStatus, char *Uin, unsigned char *rIP)
{
	char StatusString[MAX_STATUS_LEN];
	time_t	timestamp;
	struct tm *time_stamp;
	/* no prob with this array, dont worry */
	char time_string[10];

	YSM_WriteStatus(NewStatus,StatusString);

	YSM_Query = NULL;

	YSM_Query = (YSM_SLAVE *) YSM_QuerySlaves (SLAVE_UIN,NULL,atol(Uin));
	
	timestamp = time(NULL);	

	if(YSM_Query)
	{

		YSM_Query->IP[0] = rIP[0];
		YSM_Query->IP[1] = rIP[1];
		YSM_Query->IP[2] = rIP[2];
		YSM_Query->IP[3] = rIP[3];

#ifdef YSM_SILENT_SLAVES_STATUS

	if (YSM_Query->Status != YSM_OFFLINE && NewStatus != YSM_OFFLINE)
	{
		YSM_Query->Status = NewStatus;
		return;
	}

#endif

/* Fix for a known bug where the server keeps re-sending us the status of 
	each slave even though its the very same unchanged */

	if (YSM_Query->Status == NewStatus)
			return;

	YSM_Message_Arrived = TRUE;

	time_stamp = localtime( &timestamp );
	strftime( time_string, 9, "%T", time_stamp );

	PRINTF(YSM_VERBOSE_FUNCTIONAL,
			"\r%s %s%s%s %s %s %s%s%s.]\n",time_string,
						MSG_STATUS_CHANGE1,
						Uin,
						MSG_STATUS_CHANGE2,
						YSM_Query->NickName,
						MSG_STATUS_CHANGE3,
						GREEN,
						StatusString,
						NORMAL);
										
	YSM_Query->Status = NewStatus;
	YSM_Redraw_Console = TRUE;
	return;

	}

	PRINTF(YSM_VERBOSE_DEBUG_1,
		"\n[ERR] BudyStatusB Code. Changing STATUS for a slave");
	PRINTF(YSM_VERBOSE_DEBUG_1,
		" that is NOT in our list.");

	PRINTF(YSM_VERBOSE_DEBUG_1,
		"\n\nPorque? el uin q me llego es para: %ld\n",atol(Uin));

	return;

}

void
YSM_TreatMessage (int type, int tsize, char *data, char *uin, char *status, char *msgid)
{

	switch(type)
	{

                case 0x01:      /* Normal Msg. */
				YSM_Receive_Message_TypeA(tsize,
				data,
				uin,
				status,
				msgid);
				break;

		case 0x04:	/* Utility Msg. */

			YSM_Receive_Message_TypeB(tsize,
				data,
				uin,
				status);
				break;
		default:
			PRINTF(YSM_VERBOSE_DEBUG_1,
			"#### Unsupported Message format Received.\n");
			PRINTF(YSM_VERBOSE_DEBUG_1,
			"### %x #\n",type); 
			break;

	}

	return;
}


void YSM_ReceiveMessage (FLAP_Head *flap, SNAC_Head snac, char *data)
{

        /* Estos valores estan documentados, por eso estan hardcodeados. */
        BYTE WarnLVL[2],TLVnum[2],RemoteSTATUSFlags[2],RemoteSTATUS[2];
        BYTE MsgID[8];
        BYTE MsgFormat[2];
        int tsize=0,uinsize=0,len=0,Last_Tlv_Found = FALSE;
        char *RemoteUIN;
        TLV thetlv;

        memcpy(&MsgID,data+tsize,sizeof(MsgID));

        tsize += sizeof(MsgID);

        memcpy(&MsgFormat,data+tsize,sizeof(MsgFormat));

        tsize += sizeof(MsgFormat);

        uinsize = data[tsize];

        tsize += 1;

        RemoteUIN = malloc(uinsize+1);

        if(!RemoteUIN || uinsize+1 < 1)
                return;

        memset(RemoteUIN,'\0',uinsize+1);
        memcpy(RemoteUIN,data+tsize,uinsize);

        tsize += uinsize;

        memcpy(&WarnLVL,data+tsize,sizeof(WarnLVL));

        tsize += sizeof(WarnLVL);

        memcpy(&TLVnum,data+tsize,sizeof(TLVnum));

        tsize += sizeof(TLVnum);

        /* When there is no data, we just get a single TLV
           to avoid any problems, we analyze the packet right now */

	/* btw, we cant use TreatMessage here since we handle it
	   in a pretty different way. */

        if ( Chars_2_Word(TLVnum) == 1 )
        {
                switch(Chars_2_Wordb(thetlv.type))
                {
                        case 0x3:       
			/* No data Message? No WAY! just break */
                                break;

                        case 0x4:       /* Could be an Auth Reply */
                                tsize += 4; /* skip head */
                                YSM_Receive_Message_TypeB(tsize,
                                                        data,
                                                        RemoteUIN,
                                                        RemoteSTATUS);
                                break;
                        default:
                                break;
                }

                free(RemoteUIN);
                return;
        }


        if (YSM_SETTING_BEEP)
                PRINTF(YSM_VERBOSE_BASE,"\a");

        while(!Last_Tlv_Found &&
		tsize <= (Chars_2_Wordb(flap->dlen) - SNAC_HEAD_SIZE))
        {
                memset(&thetlv,'\0',sizeof(TLV));
                memcpy(&thetlv,data+tsize,sizeof(TLV));

                tsize += sizeof(TLV);
                len = Chars_2_Wordb(thetlv.len);

                switch(Chars_2_Wordb(thetlv.type))
                {
                        case 0x03:      /* Last TLV found */
                                tsize += len;
                                tsize += 4;     /* skip next TLV head */
				YSM_TreatMessage(Chars_2_Wordb(MsgFormat),
						tsize,
						data,
						RemoteUIN,
						RemoteSTATUS,
						MsgID);

                                Last_Tlv_Found=TRUE;
                                break;

                        case 0x06:      /* senders status */
                                memcpy(&RemoteSTATUSFlags,data+tsize,2);
                                tsize += 2;
                                memcpy(&RemoteSTATUS,data+tsize,2);
                                tsize += 2;
                                break;

			case 0x05:	/* possibly strange utility msg. */
				YSM_TreatMessage(Chars_2_Wordb(MsgFormat),
							tsize,
							data,
							RemoteUIN,
							RemoteSTATUS,	
							MsgID);
                                Last_Tlv_Found=TRUE;
				break;
				
                        default:
                                tsize += len;
                                break;

                }

        }


        free(RemoteUIN);
        return;
}


void YSM_Receive_Message_TypeA (int tsize, unsigned char *data, char *RemoteUIN, char *RemoteSTATUS, char *msgid)
{
	/* Estos valores estan documentados, por eso estan hardcodeados. */
	BYTE MessageLen[2];
	int Msglen=0;
	char *Message = 0, *data_conv = 0;
	unsigned char fprint = 0x0;

	/* TLV type 2, we skip the TLV Header. */
	/*tsize += 4; */
	/* Estructura : 3 bytes (05 01 00) 1 byte (01) 1 byte (01)  */
	/* 2 bytes (0101) 1 Word (Msg len + 4) 4 bytes (00 00 00 00)  */
	/* 1 String (Msg) */

	/* CenterICQ sends msgid's as 0's ...thats the way of detecting it
		by now */
	if(!msgid[0] && !msgid[1] && !msgid[2] && !msgid[3] && !msgid[4]
					&& !msgid[5] && !msgid[7] )
			fprint = FINGERPRINT_CENTERICQ_CLIENT;

	if (data[tsize] == 0xde && data[tsize+1] == 0xad)
			fprint = FINGERPRINT_YSM_CLIENT;
	else if (data[tsize] == 0xbe && data[tsize+1] == 0xef)
			fprint = FINGERPRINT_YSM_WIN32_CLIENT;

	/* Some clients such as Trillian add 2 more bytes here, weird */
	if (data[tsize+5] == 0x01 && data[tsize+6] == 0x01)
		tsize += 7;		/* go get the MsgLen */
	else
	{
		fprint = FINGERPRINT_TRILLIAN_CLIENT;
		tsize += 9;
	}

	/* El largo del msg tiene 4 bytes de mas.  */
	memcpy(&MessageLen,data+tsize,2);

	Msglen = Chars_2_Wordb(MessageLen) - 4;

	Message = malloc(Msglen+1);
	if(!Message || Msglen+1 < 1) 
		return;

	memset(Message,'\0',Msglen+1);	/* so we leave it as a zstring */

	tsize += 6; 		/* Saltamos los siguientes bytes of crap */
	memcpy(Message,data+tsize,Msglen);

	YSM_Query = YSM_QuerySlaves(SLAVE_UIN,NULL,atoi(RemoteUIN));

	if (YSM_Query)
		YSMSlaves_LastRead = YSM_Query;

#ifdef YSM_USE_ICONV

	if( YSM_Iconv(	YSM_SETTING_CHARSET_TRANS,
			YSM_SETTING_CHARSET_LOCAL,
			Message,
			&data_conv,
			YSM_ICONV_MAXLEN) < 0 )
#endif
	{
		data_conv = strdup (Message);
	}

	if (YSM_Query)
		YSM_Query->fprint = fprint;

	YSM_DisplayMsg (YSM_MESSAGE_NORMAL, atoi(RemoteUIN),
			Chars_2_Wordb(RemoteSTATUS),Msglen, data_conv,
			YSM_Query->NickName,
			!YSM_Query ? 0x0 : YSM_Query->LogFlag);

	if (YSM_SETTING_AFK)
	YSM_Send_Message(atoi(RemoteUIN),YSM_AFKMessage,YSM_Query->NickName,0);

	free(Message);	

	free(data_conv);

	return;


}



void YSM_Receive_Message_TypeB (int tsize, unsigned char *data, char *RemoteUIN, char *RemoteSTATUS)
{
	/* Estos valores estan documentados, por eso estan hardcodeados. */
	BYTE MsgType,MsgFlags,MsgLength[2];
	int i=0,c=0,Msglen=0;
	char *Message=0, *data_conv = 0,*Reason=0;

	/* TLV type 5, we skip the TLV Header. */
#if 0
	tsize += 4;
#endif

	/* struct: */
	/* 4 byte Integer (UIN) - 1 (msg type) - 1(msg flags) -  1(LNTS) ... */
	tsize += 4;

	/* Msg type */
	memcpy(&MsgType,data+tsize,1);
	tsize ++;
	memcpy(&MsgFlags,data+tsize,1);
	tsize ++;
	memcpy(&MsgLength,data+tsize,2);
	tsize +=2;

	Msglen = Chars_2_Word(MsgLength);

	Message = malloc(Msglen+1);
	if(!Message || Msglen+1 < 1) 
		return;


	/* so we leave it as a zstring(aunque ya es creo) */
	memset(Message,'\0',Msglen+1);

	memcpy(Message,data+tsize,Msglen);


	YSM_Query = YSM_QuerySlaves(SLAVE_UIN,NULL,atoi(RemoteUIN));

	/* Message TypeB Can also be Contacts Sending and something else. */

	switch(MsgType)
	{

		case YSM_MESSAGE_NORMAL:

			if (YSM_Query)
				YSMSlaves_LastRead = YSM_Query;

#ifdef YSM_USE_ICONV
			if( YSM_Iconv(	YSM_SETTING_CHARSET_TRANS,
					YSM_SETTING_CHARSET_LOCAL,
					Message,
					&data_conv,
					YSM_ICONV_MAXLEN) < 0 )
#endif
			{
				data_conv = strdup (Message);
			}

			/* The miranda client seems to send TypeB Format 1
			Messages */
			if(YSM_Query)
				YSM_Query->fprint = FINGERPRINT_MIRANDA_CLIENT;
			YSM_DisplayMsg (YSM_MESSAGE_NORMAL, atoi(RemoteUIN),
				Chars_2_Wordb(RemoteSTATUS),
				Chars_2_Word(MsgLength), data_conv,
				YSM_Query->NickName,
				!YSM_Query ? 0x0 : YSM_Query->LogFlag);

				free(data_conv);

				break;

		case YSM_MESSAGE_AUTH:

			for(i=0;i<=Msglen;i++)
			{
				if((unsigned char)Message[i] == 0xfe) 
					c++;

				/* on the 5th 0xfe we have the Reason msg */
				if(c == 5)
				{
					Reason = strchr(Message+i,0xfe);
					Reason++;

				/* Break out of the for loop! */
				break;
				}

			}


			YSM_DisplayMsg(YSM_MESSAGE_AUTH,atoi(RemoteUIN),
			 	Chars_2_Wordb(RemoteSTATUS),Msglen,Reason,
		YSM_Query->NickName,!YSM_Query ? 0x0 : YSM_Query->LogFlag);


			break;

	case YSM_MESSAGE_ADDED:		/* added by user */

			YSM_DisplayMsg(YSM_MESSAGE_ADDED,atoi(RemoteUIN),
				Chars_2_Wordb(RemoteSTATUS),Msglen,NULL,
		YSM_Query->NickName,!YSM_Query ? 0x0 : YSM_Query->LogFlag);

			break;		

	case YSM_MESSAGE_AUTHOK:
	
			YSM_DisplayMsg(YSM_MESSAGE_AUTHOK,atoi(RemoteUIN),
				Chars_2_Wordb(RemoteSTATUS),Msglen,NULL,
		YSM_Query->NickName,!YSM_Query ? 0x0 : YSM_Query->LogFlag);

			break;

	case YSM_MESSAGE_AUTHNOT:
			YSM_DisplayMsg(YSM_MESSAGE_AUTHNOT,atoi(RemoteUIN),
				Chars_2_Wordb(RemoteSTATUS),Msglen,NULL,
		YSM_Query->NickName,!YSM_Query ? 0x0 : YSM_Query->LogFlag);

			break;

	case YSM_MESSAGE_URL:

			YSM_DisplayMsg(YSM_MESSAGE_URL,atoi(RemoteUIN),
				Chars_2_Wordb(RemoteSTATUS),Msglen,data+tsize+1,
		YSM_Query->NickName,!YSM_Query ? 0x0 : YSM_Query->LogFlag);


			break;
			
	default:
			PRINTF(YSM_VERBOSE_DEBUG_1,
				"Not supported type message was received.\n");
			PRINTF(YSM_VERBOSE_DEBUG_1,
				"Possible utilfunction not implemented.\n");
			break;

	}



	free(Message);	

	return;


}


DWORD
YSM_Send_SNAC (int Family , int Subtype, BYTE FlA, BYTE FlB, char *data,
    unsigned int size, int lseq, char *reqid)
{
	DWORD		ReqID;
	int		nseq=1,bsize=0,r=0;
	char		*buf=NULL;

	int x=0;

	bsize = SNAC_HEAD_SIZE + FLAP_HEAD_SIZE + size;
	if( (buf = malloc(bsize)) == NULL)
		return 0;
	/*
	 * create by hand the headers from definition, to avoid padding
	 * flap is BYTE + BYTE + BYTE[2] + BYTE[2] = 6
	 * snac is BYTE[2] + BYTE[2] + BYTE + BYTE + DWORD = 10
	 */
	memset(buf, 0, bsize);
	srand((unsigned int) time(NULL));
	Word_2_Charsb(&buf[FLAP_HEAD_SIZE], Family);
	Word_2_Charsb(&buf[FLAP_HEAD_SIZE + 2], Subtype);
	buf[FLAP_HEAD_SIZE + 4] = (BYTE) FlA;
	buf[FLAP_HEAD_SIZE + 5] = (BYTE) FlB;
	ReqID = rand() & 0xffffff7f;

	if(reqid == NULL)
		memcpy(&buf[FLAP_HEAD_SIZE + 6], &ReqID, sizeof(DWORD));
	else
		memcpy(&buf[FLAP_HEAD_SIZE + 6], &reqid[0], 4);

	/* copy the data */
	if(data != NULL)
	memcpy(&buf[FLAP_HEAD_SIZE + SNAC_HEAD_SIZE], data, (size_t) size);

	buf[0] = 0x2a;	/*siempre */
	buf[1] = 0x2;	/*los snacs solo van en channel 2 */
	nseq += lseq ; 	/* 1+= last seq == new seq */
	Word_2_Charsb(&buf[2], nseq);

	YSM_SeqNum = nseq;		/* Update the global SEQ trace! */

	Word_2_Charsb(&buf[4], bsize - FLAP_HEAD_SIZE);



	PRINTF(YSM_VERBOSE_DEBUG_2,"\n");
	for(x = 0; x < FLAP_HEAD_SIZE; x++)
		PRINTF(YSM_VERBOSE_DEBUG_2," %x", buf[x]);
	PRINTF(YSM_VERBOSE_DEBUG_2,"\n");
	for(x = FLAP_HEAD_SIZE; x < bsize; x++)
		PRINTF(YSM_VERBOSE_DEBUG_2," %x", buf[x]);

	r = YSM_WRITE(YSM_TCPSock, buf, bsize);
	if (r<1) perror("SOCK_WRITE");

	free(buf);

	return ReqID;
}


void YSM_Login_InitA ( UDWORD Uin, UBYTE *Password ) 
{
	FLAP_Head head;
	int tsize=0,ret;
	char buf[4];
	char UinStr[MAX_ICQNUM_LEN];
#ifdef WIN32
	char PasswdStr[MAX_PWD_LEN+1];
#else
	char PasswdStr[strlen(Password)];
#endif
	char *profile = "ICQ Inc. - Product of ICQ (TM).2020b.r.ad.2.k.r.u.la";
	int dwordver = 0x55000000;
	int unkdata = 0x0A01,majorver= 0x0500,minorver=0x3f00,lesserver=0x0100, paqsize,newseq;
	int buildver = 0xCF0C;
	char *paquete;
	

	memset(&head,'\0',sizeof(head));
	memset(buf,'\0',4);

	snprintf(UinStr,MAX_ICQNUM_LEN,"%d",Uin);
	
	if (YSM_READ(YSM_TCPSock, &head, FLAP_HEAD_SIZE) < FLAP_HEAD_SIZE
	|| YSM_READ(YSM_TCPSock, &buf, sizeof(buf)) < sizeof(buf))
		return;

	/* El server nos manda listo para login en la data 0001 */
	if( !buf[0] && !buf[1] && !buf[2] && buf[3] == 1)
	{

		/* En el paquete va el FLAPHead, 4 bytes de data, y 11 TLV's */
		paqsize = strlen(UinStr) + strlen(Password) + strlen(profile) + 18;
		paqsize += 11 * sizeof(TLV); 
		paqsize += FLAP_HEAD_SIZE + 4;

		paquete = malloc(paqsize);
		if(!paquete || paqsize < 1)
			return;

		memset(paquete,'\0',paqsize);

		/* We Leave space for the Flap Head */
		tsize += FLAP_HEAD_SIZE;

		/* We copy the 0001 as reply  */
		memcpy(paquete+tsize,&buf,4);
		tsize += 4;
		
		/* TLV type 1  */
		ret = InsertTLV(UinStr,0x1,paquete+tsize,strlen(UinStr));

		tsize += ret;

		memset(PasswdStr,'\0',sizeof(PasswdStr));
		EncryptPassword(Password,PasswdStr);

		/* TLV type 2 */
		ret = InsertTLV(PasswdStr,0x2,paquete+tsize,strlen(Password));
	
		tsize += ret;
	
		/* TLV type 3	 */
		ret = InsertTLV(profile,0x3,paquete+tsize,strlen(profile));

		tsize += ret;
	
		/* TLV type 16 */
		ret = InsertTLV(&unkdata,0x16,paquete+tsize,2);
		
		tsize += ret;

		/* TLV type 17 */
		/* major version 4 icq2000 5 icq2001 */
		ret = InsertTLV(&majorver,0x17,paquete+tsize,2);

		tsize += ret;

		/* Estos que siguen son valores que supongo que no importan  */
		/* que tienen, pero todos son WORD. */
		ret = InsertTLV(&minorver,0x18,paquete+tsize,2);
		tsize += ret;
		ret = InsertTLV(&lesserver,0x19,paquete+tsize,2);
		tsize += ret;
		ret = InsertTLV(&buildver,0x1A,paquete+tsize,2);
		tsize += ret;
		ret = InsertTLV(&dwordver,0x14,paquete+tsize,4);
		tsize += ret;

		/* and the final 4 bytes - Language and Country */

		/* TLV type 0F */
		ret = InsertTLV("en",0x0F,paquete+tsize,2);
		tsize += ret;

		/* TLV type 0E */
		ret = InsertTLV("us",0x0E,paquete+tsize,2);
		tsize += ret;

		/* Flap HEAD -- Replace the first sizeof(FLAP_Head) bytes */
		/* with the new Flap HEADER. */

		newseq = Chars_2_Wordb(head.seq);
		newseq++;
		Word_2_Chars(head.seq,newseq);

		tsize -= sizeof(FLAP_Head);
		/* Data Len means without the header file! */
		Word_2_Charsb(head.dlen,tsize-sizeof(FLAP_Head));
		memcpy(paquete,&head,sizeof(FLAP_Head));


		/* Cruzar dedos y mandar el paquete de Login -A- */
		YSM_WRITE(YSM_TCPSock,paquete,tsize);
	
		PRINTF ( YSM_VERBOSE_DEBUG_1, "Login A Sent to the Server\n" );

		free(paquete);

	}	

	else 
	{

		PRINTF (YSM_VERBOSE_DEBUG_1,
			 "Login Init A Failure, bad Server Response.\n" );
		PRINTF (YSM_VERBOSE_DEBUG_1,
			 "The reply should have been 0001. Exiting..\n");
		YSM_Error(ERROR_CRITICAL);
	}	
}

void YSM_Login_InitB (FLAP_Head *head, char *buf, int buflen)
{
	TLV	thetlv;
	int	len, x = 0;
	char	*a,*cookie = NULL;

	if (buflen < Chars_2_Wordb(head->dlen) ||
	    buflen <= sizeof(thetlv))
		return;

	while (x < Chars_2_Wordb(head->dlen))
	{
	memcpy(&thetlv, buf+x, sizeof(thetlv));
	x += sizeof(TLV);
	len = Chars_2_Wordb(thetlv.len);
	
		switch(Chars_2_Wordb(thetlv.type)) 
		{

		case 0x1:
			/* reply from srv. */
			break;
	
		case 0x5:
			if ((a = strchr(&buf[x], ':')) == NULL)
				return;
			*a++ = '\0';

			memset(YSM_USER.SRV_HostName, '\0', MAX_PATH);
			strncpy(YSM_USER.SRV_HostName,
			    &buf[x], MAX_PATH);
			/* 5190 is default */
	
			YSM_USER.SRV_Port = strtol(a, NULL, 10);
			PRINTF(YSM_VERBOSE_EXTRA,
				"\n%s (%s:%d)\n",MSG_NETWORK_INFO2,
						YSM_USER.SRV_HostName,
						YSM_USER.SRV_Port);
			break;
	
		case 0x6:	/* Cookie is here..hmmm ..comida ;) */
			cookie = &buf[x];
			break;
			
		case 0x8:
		case 0x4:
			PRINTF(YSM_VERBOSE_DEBUG_1,
				"\n%s\n",MSG_ERR_DISCONNECTED);
		case 0xC:
			YSM_Error(ERROR_NETWORK);
			return;
		default:
			PRINTF(YSM_VERBOSE_DEBUG_1,
			"\nWTF an unexpected TLV arrived..lets QUIT!\n");
			YSM_Error(ERROR_CRITICAL);
			break;
		}

		x += len;

	}

	PRINTF(YSM_VERBOSE_EXTRA,"\n%s\n",MSG_NETWORK_INFO3);

	if (YSM_Connect(YSM_USER.SRV_HostName, YSM_USER.SRV_Port,
				atoi(YSM_USER.Proxy_host) ? 0x1 : 0x0, 1 ) < 0) 
                YSM_Error(ERROR_NETWORK);


	/* Generemos nuestro Seq random primario */
	srand((unsigned int)time(NULL));
	YSM_SeqNum = rand () % 0xffff;

	/* buf should contain de cookie by now */
	YSM_Login_InitC (thetlv, cookie);

	YSM_Logged_In = TRUE;
	YSM_Redraw_Console = TRUE;

	PRINTF(YSM_VERBOSE_FUNCTIONAL,"\n%s\n\n",MSG_LOGIN_OK);

	return;

}


void YSM_Login_InitC ( TLV thetlv, char *buff)
{
	FLAP_Head head;
	char buf[4];
	char *paquete=0;
	int paqsize,newseq,tsize=0;


	memset(&head,'\0',sizeof(head));
	memset(buf,'\0',4);

	recv(YSM_TCPSock,&head,sizeof(head),0);
	recv(YSM_TCPSock,&buf,4,0);

	/* aca tambien el server nos manda el 0001 */
	if( !buf[0] && !buf[1] && !buf[2] && buf[3] == 1)
	{
		/* mandamos un solo TLV con la cookie */
		paqsize = sizeof(TLV) + 257; /* strlen(buff); DANGEROUS but neccesary. */
		paqsize += sizeof(FLAP_Head) + 4;

		paquete = malloc(paqsize);
		if(!paquete || paqsize < 1) 
			return;

		memset(paquete,'\0',paqsize);
		
		/* We Leave space for the Flap Head */
		tsize += sizeof(FLAP_Head);

		/* We copy the 0001 as reply  */
		memcpy(paquete+tsize,&buf,4);
		tsize += 4;
		
		/* TLV type 6 THE COOKIE! (we alrady have the tlv from InitB) =) */
		memcpy(paquete+tsize,&thetlv,sizeof(TLV));
		tsize += sizeof(TLV);
		/* data of tlv...the cookie! =) */

		memcpy(paquete+tsize,buff,Chars_2_Wordb(thetlv.len));
		tsize += Chars_2_Wordb(thetlv.len);

		/* Flap HEAD -- Replace the first sizeof(FLAP_Head) bytes */
		/* with the new Flap HEADER. */
		
		newseq = Chars_2_Wordb(head.seq);
		newseq++;
		Word_2_Charsb(head.seq,newseq);

		/* Data Len means without the header file! */
		Word_2_Charsb(head.dlen,tsize-sizeof(FLAP_Head));
		memcpy(paquete,&head,sizeof(FLAP_Head));

		/* Cruzar dedos y mandar el paquete de Login -B (la cookie)- */
		YSM_WRITE(YSM_TCPSock,paquete,tsize);


		free(paquete);
	
	}

	else
	{
		PRINTF(YSM_VERBOSE_DEBUG_1,
	"\nWeird, When we were going to send the cookie, we didnt receive\n");
		PRINTF(YSM_VERBOSE_DEBUG_1,
	"the 0001 from the server. So its an error, and we are quitting..\n");
		free(paquete);
		YSM_Error(ERROR_CRITICAL);
	}

	return;
}


int YSM_ChangeStatus (int NewStatus, int Flags, int sequence)
{
	TLV thetlv;
	int len=0,a=0;
	char *buf;


		len = sizeof(TLV) + 5;
		buf = malloc(len);

		memset(buf,'\0',len);

		if(!buf || len < 1) 
			return 0;

                Word_2_Charsb(thetlv.type,0x6);
                Word_2_Charsb(thetlv.len,0x4);

		memcpy(buf,&thetlv,sizeof(TLV));
                memcpy(buf+sizeof(TLV),&Flags,2);
                memcpy(buf+sizeof(TLV)+3,&NewStatus,2);

		/* reemplaze un insert tlv por lo de arriba para q la data qde bien */
		/* InsertTLV(&NewStatus,0x6,buf,4); */

		a = YSM_Send_SNAC( 0x1,
				0x1E,
				0x0,
				0x0,
				buf,
				len-1,		/* un ultimo 0 q molesta */
				sequence, NULL);

		YSM_USER.YSM_Status = NewStatus;	

		free (buf);

	return NewStatus;
}


void
YSM_Send_Message(int UIN, char *data, char *Nick, int LogFlag)
{
	int a=0,tsize=0,paqlen=0,tlvlen=0,myicqlen=0,ret=0;
	char *paquete=0, *tlvpack=0, *data_conv = 0;
	char MsgFormat[2],tlvnewdlen[2],ICQStr[MAX_ICQNUM_LEN];
	char log_name[MAX_PATH], *log_data;
	time_t	log_time;
	int log_len = 0;

#ifdef YSM_USE_ICONV
	if( YSM_Iconv(	YSM_SETTING_CHARSET_TRANS,
			YSM_SETTING_CHARSET_LOCAL,
			data,
			&data_conv,
			YSM_ICONV_MAXLEN) < 0 )
#endif	
	{
		data_conv = strdup (data);
	}

	/* los 13 son el header del msg-data-1 */
	tlvlen = 13 + strlen(data_conv);

	memset(ICQStr,'\0',MAX_ICQNUM_LEN);

	snprintf(ICQStr,MAX_ICQNUM_LEN,"%d",UIN);

	/* el paquete lleva unas cosas propias + 2 tlv, el ultimo, vacio de tipo 6. */
	/* lo que lleva es: 8 bytes + 1 word (2 bytes) + 1 byte de len + el string sin 0 del uin */
	paqlen = tlvlen + sizeof(TLV) + 8 + 2 + 1 + strlen(ICQStr) + sizeof(TLV);

	paquete = malloc(paqlen);

	if(!paquete || paqlen < 1) 
		return;

	memset(paquete,'\0',paqlen);

	memcpy(paquete,&SendMessageID,sizeof(SendMessageID));
	
	tsize += 8;		/* Message ID */

	Word_2_Charsb(MsgFormat,0x1);

	memcpy(paquete+tsize,&MsgFormat,sizeof(MsgFormat));

	tsize += sizeof(MsgFormat);

	myicqlen = strlen(ICQStr);

	memcpy(paquete+tsize,&myicqlen,1);

	tsize++;
	
	memcpy(paquete+tsize,&ICQStr,myicqlen);		/* Dont copy the ending 0! */

	tsize += myicqlen;

/* construimos el tlv magico */

	tlvpack = malloc(tlvlen);
	if(!tlvpack || tlvlen < 1) 
		return;

	Word_2_Charsb(tlvnewdlen,strlen(data_conv)+4);

	memset(tlvpack,'\0',tlvlen);
	memcpy(tlvpack,HeadMsgData1,sizeof(HeadMsgData1));
	memcpy(tlvpack+sizeof(HeadMsgData1),&tlvnewdlen,sizeof(tlvnewdlen));
	memcpy(tlvpack+sizeof(HeadMsgData1)+sizeof(tlvnewdlen)+4,data_conv,strlen(data_conv));


	ret = InsertTLV(tlvpack,0x2,paquete+tsize,tlvlen);

	tsize += ret;

	ret = InsertTLV(0x0,0x6,paquete+tsize,0x0);

	tsize += ret;

	a = YSM_Send_SNAC( 0x4, 0x6, 0x0, 0x0, paquete, tsize, YSM_SeqNum,
									 NULL);


	log_time = time(NULL);

	if ( YSM_SETTING_LOGALL ||  LogFlag )
	{
		log_len = MAX_DATA_LEN+MAX_SLAVE_NICK+MAX_UIN_LEN+2;
		log_data = malloc(log_len);
		memset(log_name,'\0',MAX_PATH);
		memset(log_data,'\0',log_len);
		snprintf(log_name, MAX_PATH-1, "%d", UIN);

		snprintf( log_data,log_len,
			"<YOU> %s <@#> %s", data, ctime(&log_time) );

		YSM_DumpLogFile(log_name,log_data);
		free(log_data);
	}
	

	if(Nick)
		PRINTF(YSM_VERBOSE_EXTRA,
			"%s %s%s. (%d).\n",MSG_MESSAGE_SENT1,Nick, NORMAL,UIN);
	else
		PRINTF(YSM_VERBOSE_EXTRA,
			"%s %d%s.\n",MSG_MESSAGE_SENT2,UIN,NORMAL);
	

	free(data_conv);			

	free(tlvpack);	

	free(paquete);


}


void
YSM_SendAuthRequest (int UIN, char *Nick, char *Message)
{

char	*paquete = NULL;
char	ICQStr[MAX_ICQNUM_LEN], MsgLen[2];
int	dlen = 0;

	memset(ICQStr,'\0',MAX_ICQNUM_LEN);
	snprintf(ICQStr,MAX_ICQNUM_LEN,"%d",UIN);

	if (Message == NULL)
		Message = YSM_DEFAULT_AUTHREQ_MESSAGE;

	dlen = 1;	/* Len of UIN */
	dlen += strlen(ICQStr);	/* UIN to Request */
	dlen += 2;	/* Len of Message (WORD) */
	dlen += strlen(Message);	/* Request Message */
	dlen += 2;	/* Extra Flags (Usually 0x0000) */

	paquete = malloc(dlen);
	memset(paquete, 0, dlen);

	paquete[0] = strlen(ICQStr);
	memcpy(paquete+1, &ICQStr, strlen(ICQStr));

	Word_2_Charsb(MsgLen, strlen(Message));
	memcpy(paquete+1+strlen(ICQStr),MsgLen,2);
	memcpy(paquete+1+strlen(ICQStr)+2,Message,strlen(Message));	

	YSM_Send_SNAC( 0x13, 0x18, 0x0, 0x0, paquete, dlen, YSM_SeqNum, NULL);

	if(Nick)
		PRINTF(YSM_VERBOSE_EXTRA,
		"YSM Request Sent to Slave called %s. (%d).\n",Nick,UIN);								
	else
		PRINTF(YSM_VERBOSE_EXTRA,
		"YSM Request Sent to %d.\n",UIN);

	free(paquete);

	return;
}


void
YSM_SendAuthOK (int UIN, char *Nick)
{

char	*paquete = NULL;
char	ICQStr[MAX_ICQNUM_LEN]; 
int	dlen = 0;

	memset(ICQStr,'\0',MAX_ICQNUM_LEN);
	snprintf(ICQStr,MAX_ICQNUM_LEN,"%d",UIN);

	dlen = 1;	/* Len of UIN */
	dlen += strlen(ICQStr);	/* UIN to Request */
	dlen ++;	/* Flag response, 0x01 accept, 0x00 decline */
	dlen += 2;	/* Len of Message (WORD) */
	dlen += 0;	/* decline message, nothing */
	dlen += 2;	/* Extra Flags (Usually 0x0000) */

	paquete = malloc(dlen);
	memset(paquete, 0, dlen);

	paquete[0] = strlen(ICQStr);
	memcpy(paquete+1, &ICQStr, strlen(ICQStr));
	/* Accept Auth Req */
	paquete[1+strlen(ICQStr)] = 0x01;
	/* Here should be the message len, but as its 0, leave zeros */
	/* same with message and Flags */
	YSM_Send_SNAC( 0x13, 0x1a, 0x0, 0x0, paquete, dlen, YSM_SeqNum, NULL);

	if (!YSM_SETTING_AFK)
	{
		if(Nick)
			PRINTF(YSM_VERBOSE_EXTRA,
		"YSM Authorization Sent to Slave called %s. (%d).\n",Nick,UIN);								
		else
			PRINTF(YSM_VERBOSE_EXTRA,
			"YSM Authorization Sent to %d.\n",UIN);
	}			


	free(paquete);

	return;
}

void YSM_SendContacts (int NewSeq)
{
	int x,usize=0,ulen;
	char *data=0,tmp[MAX_ICQNUM_LEN];
	YSM_SLAVE *Firstnode = YSMSlavesList;

		
	for ( x = 0; x < AmountSlaves ; x++ )
	{
		memset(tmp,'\0',sizeof(tmp));
		snprintf(tmp,sizeof(tmp)-1,"%d",YSMSlavesList->Uin);
		usize += strlen(tmp);
		usize++;		/* byte of len too */

		YSMSlavesList = YSMSlavesList->next;

	}

	YSMSlavesList = Firstnode;

	data = malloc(usize);
	
	for ( x = 0, usize=0; x < AmountSlaves ; x++ )
	{
		memset(tmp,'\0',sizeof(tmp));
		snprintf(tmp,sizeof(tmp)-1,"%d",YSMSlavesList->Uin);
		ulen = strlen(tmp);
		memcpy(data+usize,&ulen,1);
		usize++;
		memcpy(data+usize,&tmp,ulen);
		usize+=ulen;

		YSMSlavesList = YSMSlavesList->next;

	}
	
	NewSeq++;

	if (YSM_USER.YSM_Paranoid>2)			/* Don't send SHIT ;) */
	{
		memset(data,'\0',usize);
		usize=2;
	}

	YSM_Send_SNAC( 0x3,
			0x04,
			0x0,
			0x0,
			data,
			usize,
			NewSeq,
			NULL);

	free(data);


	return;
}



void YSM_RemoveContact (YSM_SLAVE *Contact, int NewSeq)
{
	char tmp[MAX_ICQNUM_LEN],*data;
	int dlen =0, ulen;
	
		snprintf(tmp,MAX_ICQNUM_LEN,"%d",Contact->Uin);

		ulen = strlen(tmp);
		dlen = ulen+2;
		data = malloc(dlen);
		memset(data,'\0',dlen);

		memcpy(data,&ulen,1);
		memcpy(data+1,&tmp,ulen);
	
		YSM_Send_SNAC( 0x3,
				0x05,
				0x0,
				0x0,
				data,
				strlen(data),
				NewSeq,
				NULL);


		free(data);

		return;

}

void YSM_Buddy_AddSlave (char *nick, char *uin, int fl)
{
	int uini;

	uini = atoi(uin);

#ifdef  YSM_DEBUG
	PRINTF(YSM_VERBOSE_DEBUG_2,"\n[2]-- inside Rost_AddSlave");
#endif

#ifdef YSM_DEBUG
	PRINTF(YSM_VERBOSE_DEBUG_2,"\n[2]-- about to add %s with %d",nick,uini);
#endif
	if(YSM_AddSlavetoList (&YSMSlavesList,nick,uini,fl))
	{
			AmountSlaves++;
#ifdef YSM_DEBUG
	PRINTF(YSM_VERBOSE_DEBUG_2,"\n[2]-- done.");

	PRINTF(YSM_VERBOSE_DEBUG_2,"\n[3]-- Saving slave to disk.");
#endif
	
	YSM_AddSlavetoDisk (nick, uini);

#ifdef YSM_DEBUG
	PRINTF(YSM_VERBOSE_DEBUG_2,"\n[4]-- done.");
#endif
	}

	return;
}

void YSM_Buddy_RequestModify (void)
{
	char reqid[4];

		memset(reqid,0,4);
		reqid[3] = 0x11;

		YSM_Send_SNAC( 0x13,
				0x11,
				0x0,
				0x0,
				NULL,
				0,
				YSM_SeqNum, reqid);
}

void YSM_Buddy_RequestFinished (void)
{

	char reqid[4];

		memset(reqid,0,4);
		reqid[3] = 0x12;


		YSM_Send_SNAC( 0x13,
				0x12,
				0x0,
				0x0,
				NULL,
				0,
				YSM_SeqNum, reqid);
	
}

void YSM_Buddy_Ack (FLAP_Head *head, SNAC_Head thesnac, char *buf)
{
		YSM_Send_SNAC( 0x13,
				0x07,
				0x0,
				0x0,
				NULL,
				0,
				YSM_SeqNum, NULL);
	return;
}

/*
 hehe nice function huh :) well use is this way:

	For adding a Group:
		Item = 0x0, grpName = groupname
		grpID = groupID, budID = 0x0, type = YSM_BUDDY_GROUP
	For adding a Buddy:
		Iteme= YSM_SLAVE*, grpName = groupname
		grpID = groupID, budID = UIN(int), type = YSM_BUDDY_SLAVE
*/
			

/* CMD if 0 means Add Item, if 1 means Notify Master. */

void
YSM_Buddy_AddItem(YSM_SLAVE *Item, char *grpName, int grpID ,int budID, int type, int cmd, int authawait)
{

int dlen=0, tsize =0;
char *data, *data2 = NULL, grp_len[2], item_type[2], YSMBuddyGroup_ID[2];
char YSMBuddy_ID[2], StringUIN[MAX_UIN_LEN+1];
char *data_list = NULL, *name = NULL;
int *data_list_ammount = NULL;
char reqid[4];


	/* We increment the change count on our buddy list for future chgs */
	YSM_Buddy_ChangeCount++;



	if( type == YSM_BUDDY_GROUP )	
	{
		/* For (notifying master) */
		data_list = YSM_GroupID_List;
		data_list_ammount = &YSM_GroupID_Amount;
		name = grpName;
	}
	else
	{
		memset(StringUIN,0,MAX_UIN_LEN+1);
		snprintf(StringUIN,MAX_UIN_LEN,"%d",Item->Uin);
		name = &StringUIN[0];

		/* For (notifying master) */
		data_list = YSM_GroupID_Users;
		data_list_ammount = &YSM_GroupID_Users_Amount;
	}

	Word_2_Charsb(grp_len, strlen(name));

	Word_2_Charsb(YSMBuddyGroup_ID, grpID);

	/* Patch for huge Buddy ids ;) */
	if (budID > 50000)
	{
		budID -= budID - 1000;
		budID += rand() % 1000;
	}

	/* Just used if adding a Buddy */
	Word_2_Charsb(YSMBuddy_ID, budID);

	switch(cmd)
	{
		case 0:		/* Called first time, add items */
		{

		dlen = 2; /* len WORD */
		dlen += strlen(name);

		dlen += 2 + 2; /* Group ID and Buddy ID */
		dlen += 2;	/* Type 0x0001 is Group */
		dlen += 2;	/* Extra len */

		if( type == YSM_BUDDY_SLAVE )
		{
			dlen += sizeof(TLV) + strlen(Item->NickName);
			if(authawait) dlen += sizeof(TLV);
		}

		data = malloc(dlen);
		memset(data,'\0',dlen);

		memcpy(data+tsize,&grp_len,2);
		tsize += 2;
		memcpy(data+tsize,name,strlen(name));
		tsize += strlen(name);
		
		memcpy(data+tsize,YSMBuddyGroup_ID,2);
		tsize += 2;

		switch(type)
		{
			case YSM_BUDDY_SLAVE:	/* Adding a Buddy */
				memcpy(data+tsize,&YSMBuddy_ID,2);	
				tsize += 2;
				break;
			case YSM_BUDDY_GROUP:
				tsize += 2;	 /* grp buddy ids are 0 */
				break;
			default:
				YSM_Error(ERROR_CODE);
				break;
		}

		Word_2_Charsb(item_type,type);
		memcpy(data+tsize,&item_type,2);
		tsize += 2;

		memset(reqid,0,4);

		reqid[1] = YSM_Buddy_ChangeCount;
		reqid[3] = 0x08;

		if( type == YSM_BUDDY_GROUP )
			memcpy(&YSM_Group_ReqID,reqid,4);

		else		/* which would be YSM_BUDDY_SLAVE */
		{	
			/* And now if we are adding a Buddy add on 
					Extra Data its Nickname */

			/* re using grp_len for xtra_len */
			if(!authawait)
				Word_2_Charsb(grp_len,
					strlen(Item->NickName)+sizeof(TLV));
			else
				Word_2_Charsb(grp_len,
				strlen(Item->NickName)+sizeof(TLV)+sizeof(TLV));
			

			memcpy(data+tsize,&grp_len,2);	/* Xtra len */
			tsize += 2;
			data2 = malloc(sizeof(TLV) + strlen(Item->NickName));

			InsertTLV(Item->NickName,0x131,data2,
						strlen(Item->NickName));

			memcpy(data+tsize,data2,
					 strlen(Item->NickName)+sizeof(TLV));

			tsize += strlen(Item->NickName) + sizeof(TLV);
			free(data2);

			if (authawait)
				InsertTLV(0,0x66,data+tsize,0);
			
			/* fill the slave's reqid, so we then know whos who */
			memcpy(&Item->ReqID,reqid,4);
		}


		YSM_Send_SNAC( 0x13,
				0x08,
				0x0,
				0x0,
				data,
				dlen,
				YSM_SeqNum, reqid);
		free(data);

		break;

		}

	case 0x1:
		{

		/* Generating change on Master Group */
		/* Either Master group of groups or Group of Buddys! */


		/*len(word) + string (0 bytes if GROUP or GrpName if BUDDY)*/
		dlen = 2;

		if(type == YSM_BUDDY_SLAVE) dlen += strlen(grpName);
		dlen += 2 + 2; /* Group ID and Buddy ID */
		dlen += 2;	/* Type 0x0001 is Group */
		dlen += 2;	/* Extra len (just leave 0, should do) */
		/* TLV containing all groups */
		(*data_list_ammount)++;	/* New GroupID ! */
		dlen += sizeof(TLV) + *(data_list_ammount)*2;

		data = malloc(dlen);
		memset(data,'\0',dlen);
		
		tsize = 0;


		switch(type)
		{
			case YSM_BUDDY_SLAVE:		/* Buddy */
				Word_2_Charsb(grp_len, strlen(grpName));
				memcpy(data+tsize,&grp_len,2);	
				tsize += 2;
				memcpy(data+tsize,grpName,strlen(grpName));
				tsize += strlen(grpName);
				memcpy(data+tsize,YSMBuddyGroup_ID,2);
				tsize += 2;
				tsize += 2;
				break;

			case YSM_BUDDY_GROUP:		/* Group! */
				tsize += 2;	/* len == 0 */
				tsize += 2;	/* GrpID == 0, Master Group! */
				tsize += 2;	/* Buddy ID == 0, Im a group! */
				break;

			default:
				YSM_Error(ERROR_CODE);
				break;
		}

		/*	For Both, a new Group or Buddy, the
			type must be 0001 since what we are
			changing here is in both cases a group		*/
				
		Word_2_Charsb(item_type,0x0001);
		memcpy(data+tsize,&item_type,2);	/* Type == 0x0001 */
		tsize += 2;


		/* re using grp_len for xtra_len */
		Word_2_Charsb(grp_len, *(data_list_ammount)*2+sizeof(TLV));

		memcpy(data+tsize,&grp_len,2);	/* Xtra len */
		tsize += 2;

		data2 = malloc(*(data_list_ammount)*2+sizeof(TLV));

		data_list = realloc(data_list, *(data_list_ammount)*2);

		memset(reqid,0,4);
		reqid[1] = YSM_Buddy_ChangeCount;
		reqid[3] = 0x09;



		/* add the new Group id if adding a group
				or user id if adding a user */

		if( type == YSM_BUDDY_GROUP )
			memcpy(data_list+((*(data_list_ammount)-1)*2),
						 &YSMBuddyGroup_ID, 2);
		else
		{
			memcpy(data_list+((*(data_list_ammount)-1)*2),
						 &YSMBuddy_ID, 2);
			/* fill the slave's reqid, so we then know whos who */
			memcpy(&Item->ReqID,reqid,4);
	
		}

		InsertTLV(data_list,0xc8,data2, *(data_list_ammount)*2);
		memcpy(data+tsize,data2, (*(data_list_ammount)*2)+sizeof(TLV));

		free(data2);

		YSM_Send_SNAC( 0x13,
				0x09,
				0x0,
				0x0,
				data,
				dlen,
				YSM_SeqNum, reqid);

		free(data);

		break;
		}

		default:
			YSM_Error(ERROR_CODE);
			break;

	}

	return;

}

int
YSM_Buddy_ReadSlave (char *buf,int tsize)
{
	int size=0,ulen=0,nlen=0;
	char *uin=0,*nick=0,Nlen[2],xtralen[2],xtratlvtype[2];

	/* actually its a word, but its always the first byte (a len)*/
	size++;			
	ulen = buf[tsize+size];
	if (ulen <= 0 || ulen > MAX_UIN_LEN)
		return 0x666;
	size++;

	uin = malloc(ulen+1);
	memset(uin,'\0',ulen+1);
	memcpy(uin,&buf[tsize+size],ulen);
	size += ulen;

	/* Group ID */
	size += 2;
	/* Buddy ID */
	size += 2;
	/* Type , we already know its a buddy duh!
				 (..and if its a monnster?) */
	size += 2;

	memset(&xtralen,0,2);
	memset(&xtratlvtype,0,2);
	memcpy(&xtralen,buf+size+tsize,2);

	/* We just care about the 0x131 which is the Nick of our slave. */
	/* 0x66 and other tlvs are ignored, why would we want em huh HUH =P */

	size += 2;

	if( Chars_2_Wordb(xtralen) != 0 )
	{
		memcpy(&xtratlvtype,buf+size+tsize,2);
	
		switch (Chars_2_Wordb(xtratlvtype))
		{
			/* Which means Extra Data Nick Incoming! */
			case 0x131:
					size += 2;
					memcpy(&Nlen,buf+size+tsize,2);
					size += 2;
					nlen = Chars_2_Wordb(Nlen);
					nick = malloc(nlen+1);
					memset(nick, '\0',nlen+1);
					memcpy(nick, &buf[tsize+size],nlen);
					size += Chars_2_Wordb(xtralen) - 4;
					
					break;
			default:
			/* Fine, no Nick found then */
					size += Chars_2_Wordb(xtralen) - 4;
					break;
		}
	}

	if( nlen != 0 )
	{
		if ( (nlen = YSM_ParseSlave (nick)) == 0)
			free(nick);
	}

	if( !nlen )
	{
		/* God Damn! No nick for this slave! What shall we use?! */
		/* Fine god dammit! Lets use its UIN # as his nickname! */

		nlen = strlen(uin);
		nick = malloc(nlen+1);
		memset(nick,'\0',nlen+1);
		memcpy(nick,uin,nlen);
	}


/*	debugging info  */
#ifdef YSM_DEBUG
	PRINTF(YSM_VERBOSE_DEBUG_2,"\nADDING %s with %s\n",nick,uin); 
#endif

	/* Last param , 1 == ONLINE slave (Stored on the srv) */
	YSM_Buddy_AddSlave (nick,uin,1);

	free (uin);	
	free (nick);

	return size;
}

void
YSM_Incoming_BuddyChange (FLAP_Head *head, SNAC_Head thesnac, char *buf)
{

YSM_SLAVE *SlavesList = YSMSlaves_First;
char incomingreq[2];
int i=0;

	memcpy(&incomingreq,buf,2);

	/* Maybe its the ack for our group creation..*/
	/* If so.. */
	if(thesnac.ReqID == YSM_Group_ReqID)
	{
		YSM_Buddy_AddItem (0x0, YSM_BUDDY_GROUPNAME,
			YSM_BUDDY_GROUPID, 0x0, YSM_BUDDY_GROUP, 1, 0);

		PRINTF(YSM_VERBOSE_EXTRA,"\nYSM Group Created.\n");
	
		/* Let it know it can close the contact list */
		YSM_Buddy_RequestFinished ();


		return;
	}

	
	for (i=1 ; SlavesList->next != 0; i++)
	{

		/* Part of the adding users who need authorization thing */
		/* this value is set while requesting auth from a slave */
		if(SlavesList->DownloadedFlag == 0x0b)	
		{
			YSM_Buddy_AddItem (SlavesList,
				YSM_BUDDY_GROUPNAME,
				YSM_BUDDY_GROUPID,
				SlavesList->Uin,
				YSM_BUDDY_SLAVE, 1, 0 );

			/* Means tell the user when an Auth comes from
				this slave ! */	
			SlavesList->DownloadedFlag = 0x0c;

			/* Let it know it can close the contact list */
			YSM_Buddy_RequestFinished ();


		}

		if(thesnac.ReqID == SlavesList->ReqID)
		{

			/* If its the Group added ack, just break */
				if(SlavesList->DownloadedFlag == TRUE)
						break;

			PRINTF(YSM_VERBOSE_FUNCTIONAL,
			BRIGHT_BLUE "\nSaving [%s]" WHITE " [%d]" NORMAL,
					SlavesList->NickName, 
					SlavesList->Uin);

			switch(Chars_2_Wordb(incomingreq))
			{

			case YSM_SRV_BUDDY_NOAUTH:
				
			/* Ok! Been acked. Notify the YSM group that 
			it's got a new user. */

				YSM_Buddy_AddItem (SlavesList,
						YSM_BUDDY_GROUPNAME,
						YSM_BUDDY_GROUPID,
						SlavesList->Uin,
						YSM_BUDDY_SLAVE, 1, 0);

			/* Set the -online- contact flag so we can then
				know who required auth and who did not */

				PRINTF(YSM_VERBOSE_FUNCTIONAL,
				 GREEN " [OK] SLAVE SAVED\n" NORMAL );

				SlavesList->DownloadedFlag = TRUE;

				break;

			case YSM_SRV_BUDDY_AUTH:
			/* This slave requires an online auth..ugh. */

			/* Let the user know he needs auth from the
				other part in order to add it in the list */

			PRINTF(YSM_VERBOSE_FUNCTIONAL,
				 RED " [ERROR]\n" NORMAL
				"Authorization from the user is required."
				" [use the 'req' command].");

			SlavesList->DownloadedFlag = 0x0a;

			break;

			case YSM_SRV_BUDDY_ERRADD:
	
			PRINTF(YSM_VERBOSE_FUNCTIONAL,
				 RED " [ERROR]\n" NORMAL
				"Maybe adding a disabled account?.");

				SlavesList->DownloadedFlag = TRUE;
				break;

			/*	Shouldn't happend. Take same action as if
				a reply for a non-slave arrives, ignore! */
			
			default:
				PRINTF(YSM_VERBOSE_FUNCTIONAL,
				 MAGENTA " [WARNING]\n" NORMAL
				"Try Again!.\n");
				break;
			}	
	
		/* Let it know it can close the contact list */
		YSM_Buddy_RequestFinished ();

		}

		SlavesList = SlavesList->next;
	}

	return;
}

void
YSM_Incoming_BuddyList (FLAP_Head *head, SNAC_Head thesnac, char *buf)
{
	char groupcheck[4],d_len[2],g_id[2],x;
	int tsize=0,len=0,GrpSlaves=0,y=0;
	int r=0,maxdlen=0,g_ammount=0;
	char *GrpIds=0, chgcount[2];
	TLV thetlv;

	/* User may disable prompting from the config file */
	if(YSM_SETTING_ASK_DOWNLOAD)
	{
	/* The new DOWNLOADED_CONTACTS flag is for the situations
	when the server sends us more than one Roster packet, so
	we dont prompt the user twice. */
	if(!DOWNLOADED_CONTACTS)
	{	
		PRINTF(YSM_VERBOSE_BASE,
			"\n%s\n%s",MSG_ASK_DOWNLOAD1,MSG_ASK_DOWNLOAD2);
		x = getchar();
	
		if(toupper(x) != 'Y')
		{
			DOWNLOADED_CONTACTS = TRUE;
			return;
		}

	}

	} 

	memset(&thetlv,'\0',sizeof(TLV));

	/* SSI protocol version (!?) */
	tsize++;

	/* Num of modifications by now (WE need this for future mods) */
	memset(chgcount,0,2);
	memcpy(chgcount,buf+tsize,2);
	YSM_Buddy_ChangeCount = Chars_2_Wordb(chgcount);
	tsize+=2;

	/* For future changes, we mark our next change already */
	YSM_Buddy_ChangeCount++;

	/* If there is now a 6 0 bytes field, then.. */
	/* (Usually comes with the first Roaster */

	if(!buf[tsize] && !buf[tsize+1] && !buf[tsize+2] &&
			!buf[tsize+3] && !buf[tsize+4] && !buf[tsize+5])
	{
		tsize+=6;

/* there is this first TLV(1) which we DONT want, so we will just */
/* skip its header and jump to its data where the tlv (c8) is (only one), */
/* then we read the len of the c8 tlv and begin from there. */
		tsize += sizeof(TLV);

	}	

	DOWNLOADED_CONTACTS = TRUE;

	maxdlen = Chars_2_Wordb(head->dlen) - SNAC_HEAD_SIZE;

	memset(&thetlv,'\0',sizeof(TLV));
	memcpy(&thetlv,buf+tsize,sizeof(TLV));
	len = Chars_2_Wordb(thetlv.len);

	/* The Groups listing did show up, skip it! dammit! */
	if(Chars_2_Wordb(thetlv.type) == 0xc8)
	{
		/*	Make a global allocated area where to store
			the existing GroupIDS */

			tsize += sizeof(TLV);

			YSM_GroupID_List = malloc(len);
			YSM_GroupID_Amount = len/2;

			memset(YSM_GroupID_List,'\0',len);
			for(y=0;y<len;y+=2)
				memcpy(YSM_GroupID_List+y,&buf[tsize+y],2);
				
			tsize += len;
	}
	
	/* DAMN! Parse the items and get to the GROUPS! */
	while( (tsize+4) < maxdlen )
	{
		memcpy(&d_len,buf+tsize,2);
		tsize += 2;
		tsize += Chars_2_Wordb(d_len);
		memcpy(g_id,buf+tsize,2);
		tsize += 2;	/* Group ID */

		/* Lets check if its a group what we found
		by copying the UserID (should be 0) and the type */
		memcpy(&groupcheck,buf+tsize,4);

		if(!groupcheck[0] && !groupcheck[1] &&
			!groupcheck[2] && groupcheck[3] == 1)
		{
			tsize += 4;

			/* We are now standing on the len of the
			following data */
			memcpy(&d_len,buf+tsize,2);
			tsize += 2;

			if(Chars_2_Wordb(d_len) == 0)
			{
				/* Empty group, but check if its is
				OUR group so we dont make the mistake
				of creating it twice! */
				if(Chars_2_Wordb(g_id) == YSM_BUDDY_GROUPID)
				{
					YSM_GroupID_Users_Amount = 0;
				}
					
				continue;
			}

			memcpy(&thetlv,buf+tsize,sizeof(TLV));
			len = Chars_2_Wordb(thetlv.len);
			tsize += sizeof(TLV);

			switch(Chars_2_Wordb(thetlv.type))
			{
				/* Users ID */
			/* Use the amm of IDS for knowing the amm */
			/* of slaves in the group */	
				case 0xc8:
				{

			/* If its the YSM Group, we need the list of Buddy */
			/* Ids stored in our users list. */
				if(Chars_2_Wordb(g_id) == YSM_BUDDY_GROUPID)
				{
					if(len != 0)
					{
					YSM_GroupID_Users = malloc(len);
					YSM_GroupID_Users_Amount = len/2;
					memset(YSM_GroupID_Users,'\0',len);
					for(y=0;y<len;y+=2)
						memcpy(YSM_GroupID_Users+y,
							&buf[tsize+y],2);
					}
					else
					{
					/* The Group exists, but its empty.
						Do NOT re-create the group! */
						YSM_GroupID_Users_Amount = 0;
					}
				}

					GrpSlaves = len/2;
					tsize += len;	
					break;
				}	
				default:
					GrpSlaves = 0;
					tsize += len;
					break;
			}

			g_ammount += GrpSlaves;
			
			for (y=0; y<GrpSlaves;y++)
			{
				r = YSM_Buddy_ReadSlave(buf,tsize);
				if(r == 0x666)
					break;
				
				else tsize +=r;

				PRINTF(YSM_VERBOSE_DEBUG_2,"%d",tsize);
			}

		}		
		else
		{

		tsize += 4;	/* User ID and Type */

		/* See if theres any Xtra data on this item */

		memcpy(&d_len,buf+tsize,2);
		tsize += 2;

		if(Chars_2_Wordb(d_len) != 0)
			tsize += Chars_2_Wordb(d_len);
		}
		
	}

/* Print some shocking message :) New slaves are always welcome. */
	PRINTF(YSM_VERBOSE_EXTRA,
		"\nd[O_o]b %d %s\n",g_ammount,MSG_DOWNLOADED_SLAVES); 

	YSM_Buddy_Ack (head,thesnac,buf);

	free(GrpIds);	

	return;

}


void YSM_IncomingMultiUse (FLAP_Head *head, SNAC_Head *thesnac, char *buf)
{
	int tsize=0;
	char BytesRem[2],Type[2],ReqID[2],SubID[2],Result;
	/* offline message variables */
	int uin,mlen;
	char *message,MsgType,MsgFlags,Msglen[2];

		/* its a TLV(1) at the very beggining, always. */
		tsize += 4;
		memcpy(&BytesRem,buf+tsize,2);
		tsize += 2;
		/* my UIN */
		tsize += 4;
		memcpy(&Type,buf+tsize,2);
		tsize += 2;
		memcpy(&ReqID,buf+tsize,2);
		tsize += 2;

		switch(Chars_2_Wordb(Type))
		{
			/* Information request response */
			case 0xda07:
				memcpy(&SubID,buf+tsize,2);
				tsize += 2;
				Result = (*buf+tsize);
				if(Result != 0x32 && Result != 0x14
							 && Result != 0x1E )
				{
					switch(Chars_2_Wordb(SubID))
					{
						case 0xC800:
						/* tsize points to Result */
							tsize++;
						/* Now it doesnt. */

						if( YSM_personal_infoid == thesnac->ReqID && YSM_personal_infoid != 0 ) 
						{
							YSM_IncomingInfo(buf,1,
									tsize);
						}
						else
						{
							YSM_IncomingInfo(buf,0,
									tsize);
						}
	
							break;

						case 0xA401:
						case 0xAE01:
							tsize++;
							YSM_IncomingSearch(buf,
									tsize);
							break;
						case 0x6400:

							PRINTF(
							YSM_VERBOSE_EXTRA,
							"\n"
							"Information Updated!"
							);

							break;
						default:
							break;
					}

				}

				else
					PRINTF(YSM_VERBOSE_FUNCTIONAL,
					"\nSearch Failed. valid UIN/Mail?");

				break;	
		
			case 0x4100:
				memcpy(&uin,buf+tsize,4);
				tsize+=4;

				/* we wont care about the date of the */
				/* offline message yet, doing this code */
				/* quickly. */

				tsize +=2; /* WORD (year) */
				tsize++;  /* Month */
				tsize++; /* Day */
				tsize++; /* Hour */
				tsize++; /* Minutes */
				MsgType = buf[tsize];
				tsize++;
				MsgFlags = buf[tsize];
				tsize++;
				memcpy(&Msglen,buf+tsize,2);
				tsize+=2;
				mlen = Chars_2_Word(Msglen);
				message = malloc(mlen+1);
	
				memcpy(message,buf+tsize,mlen);
				tsize += mlen;

				YSM_Query = YSM_QuerySlaves(SLAVE_UIN,
						NULL,uin);

				YSM_AckOffline (YSM_SeqNum);

				switch(MsgType)
				{
					case 0x01:

			PRINTF(YSM_VERBOSE_FUNCTIONAL,
			"\nMessage received when you were %soffline%s:\n",
								BRIGHT_BLUE,
								NORMAL);

					YSM_DisplayMsg (YSM_MESSAGE_NORMAL,
							uin,
							0x0,
							mlen, message,
							YSM_Query->NickName,
							!YSM_Query ? 0x0 : YSM_Query->LogFlag );

							break;
	
					case 0x04:	/* we wont yet */
							/* support this kind */
							/* of offline msg. */
							break;
		
					default:
							break;
				}	

				free(message);
				break;
			
			case 0x4200:		/* end of offline msgs */
				break;
	
			default:
		
				break;
		}	



	return;
}

void YSM_IncomingSearch (char *buf, int tsize)
{
	char Len[2],*data;
	int ruin=0,len2;

		tsize+=2;	/* record LEN */
		memcpy(&ruin,buf+tsize,4);
		tsize+=4;

		memcpy(&Len,buf+tsize,2);
		tsize+=2;
		len2 = Chars_2_Word(Len);
		data = malloc(len2+1);
		memset(data,'\0',len2+1);
		memcpy(data,buf+tsize,len2);

		PRINTF(YSM_VERBOSE_FUNCTIONAL,
			"\n%sUIN%s: %d",WHITE,NORMAL,ruin);
		PRINTF(YSM_VERBOSE_FUNCTIONAL,
			"\t%sNick%s: %s\n",WHITE,NORMAL,data);

		free(data);

	return;
}


void YSM_IncomingPersonal( FLAP_Head *head, SNAC_Head thesnac, char *buf)
{
	return;
}

/* if FL is TRUE then its our own info query, copy what we need */
/* by now its just our nickname */

void YSM_IncomingInfo (char *buf, int fl, int tsize)
{
	char Len[2],*data;
	int len2;

		memcpy(&Len,buf+tsize,2);
		tsize+=2;
		len2 = Chars_2_Word(Len);
		data = malloc(len2+1);
		memset(data,'\0',len2+1);
		memcpy(data,buf+tsize,len2);

/* Ok the order is: Nick First Last Email */

/* 	
	If the request was for OUR information, then just get our nick and
	go away. 
*/
		if(fl)
		{
			if(strlen(data) > 1)
			strncpy(YSM_USER.YSM_info.NickName,
					 data, MAX_SLAVE_NICK-1);
			else
				YSM_USER.YSM_info.NickName[0] = '%';

			YSM_personal_infoid = 0;
		}
		else
		{
/* Print the Nick! */
			PRINTF(YSM_VERBOSE_FUNCTIONAL,
				"\n%sNick%s: %s",WHITE,NORMAL,data);
		}

		free(data);

		tsize += len2;
		memcpy(&Len,buf+tsize,2);
		tsize+=2;
		len2 = Chars_2_Word(Len);
		data = malloc(len2+1);
		memset(data,'\0',len2+1);
		memcpy(data,buf+tsize,len2);

		if(fl)
			strncpy(YSM_USER.YSM_info.FirstName,
					 data, MAX_SLAVE_NICK-1);
		else
		{
/* Print the First! */
			PRINTF(YSM_VERBOSE_FUNCTIONAL,
				"\t%sFirst%s: %s",WHITE,NORMAL,data);
		}

		free(data);

		tsize += len2;
		memcpy(&Len,buf+tsize,2);
		tsize+=2;
		len2 = Chars_2_Word(Len);
		data = malloc(len2+1);
		memset(data,'\0',len2+1);
		memcpy(data,buf+tsize,len2);


		if(fl)
			strncpy(YSM_USER.YSM_info.LastName,
					 data, MAX_SLAVE_NICK-1);
		else
		{
/* Print the Last! */
			PRINTF(YSM_VERBOSE_FUNCTIONAL,
				"\t%sLast%s: %s",WHITE,NORMAL,data);
		}

		free(data);

		tsize += len2;
		memcpy(&Len,buf+tsize,2);
		tsize+=2;
		len2 = Chars_2_Word(Len);
		data = malloc(len2+1);
		memset(data,'\0',len2+1);
		memcpy(data,buf+tsize,len2);


		if(fl)
			strncpy(YSM_USER.YSM_info.email,
					 data, MAX_SLAVE_NICK-1);
		else
		{	
/* Print the email! */
			PRINTF(YSM_VERBOSE_FUNCTIONAL,
				"\n%sE-Mail%s: %s\n",WHITE,NORMAL,data);
		}

		free(data);

		YSM_Redraw_Console = TRUE;
	return;

} 

/* FL is a flag ment to be > 0 if we are requesting our personal info. */
/* If this is TRUE, then a global variable with the req id will be updated */
/* so that IncomingInfo functions know its our info requested */

void YSM_RequestInfo (UDWORD ContactUin, int fl, int NewSeq)
{

	char BytesRem[2],Type[2],ReqID[2],SubTypeID[2];
	char *data,*data2;
	int dlen =0;


		memset(BytesRem,'\0',2);	
		memset(Type,'\0',2);	
		memset(ReqID,'\0',2);	
		memset(SubTypeID,'\0',2);	

		Word_2_Charsb(BytesRem,0x0e00);
		Word_2_Charsb(Type,0xd007);
		if(fl)
			Word_2_Charsb(SubTypeID,0xd004);
		else
			Word_2_Charsb(SubTypeID,0xb204);
		
		dlen = 2 + 4 + 2 + 2 + 2 + 4 + 1;
		data = malloc(dlen);
		data2 = malloc(dlen + sizeof(TLV));
		memset(data,'\0',dlen);
		memset(data2,'\0',dlen+sizeof(TLV));

		memcpy(data,&BytesRem,2);
		memcpy(data+2,&YSM_USER.YSM_Uin,4);
		memcpy(data+2+4,&Type,2);
		memcpy(data+2+4+2,&ReqID,2);
		memcpy(data+2+4+2+2,&SubTypeID,2);
		memcpy(data+2+4+2+2+2,&ContactUin,4);
	
		/* I believe we had an extra byte for the ending 0	 */
		InsertTLV(data,0x1,data2,dlen-1);

		free(data);

		YSM_personal_infoid = YSM_Send_SNAC( 0x15,
							0x02,
							0x0,
							0x0,
							data2,
							dlen+sizeof(TLV),
							NewSeq,
							NULL);

		if(!fl) YSM_personal_infoid = 0;

		free(data2);

	return;
}



void YSM_RequestOffline (int NewSeq)
{
	char BytesRem[2],Type[2],ReqID[2];
	char *data,*data2;
	int dlen =0;


		memset(BytesRem,'\0',2);	
		memset(Type,'\0',2);	
		memset(ReqID,'\0',2);	
		data = malloc(dlen);

		Word_2_Charsb(BytesRem,0x0800);
		Word_2_Charsb(Type,0x3c00);
		
		dlen = 2 + 4 + 2 + 2 ;

		data = malloc(dlen);
		memset(data,'\0',dlen);

		data2 = malloc(dlen + sizeof(TLV));
		memset(data2,'\0',dlen+sizeof(TLV));
		
		memcpy(data,&BytesRem,2);
		memcpy(data+2,&YSM_USER.YSM_Uin,4);
		memcpy(data+2+4,&Type,2);
		memcpy(data+2+4+2,&ReqID,2);
	
		/* I believe we had an extra byte for the ending 0	 */
		InsertTLV(data,0x1,data2,dlen);

		free(data);

		YSM_Send_SNAC( 0x15,
				0x02,
				0x0,
				0x0,
				data2,
				dlen+sizeof(TLV),
				NewSeq,
				NULL);

		free(data2);

	return;
}

void YSM_AckOffline (int NewSeq)
{
	char BytesRem[2],Type[2],ReqID[2];
	char *data,*data2;
	int dlen =0;


		memset(BytesRem,'\0',2);	
		memset(Type,'\0',2);	
		memset(ReqID,'\0',2);	
		data = malloc(dlen);

		Word_2_Charsb(BytesRem,0x0800);
		Word_2_Charsb(Type,0x3E00);
		
		dlen = 2 + 4 + 2 + 2 ;

		data = malloc(dlen);
		memset(data,'\0',dlen);

		data2 = malloc(dlen + sizeof(TLV));
		memset(data2,'\0',dlen+sizeof(TLV));
		
		memcpy(data,&BytesRem,2);
		memcpy(data+2,&YSM_USER.YSM_Uin,4);
		memcpy(data+2+4,&Type,2);
		memcpy(data+2+4+2,&ReqID,2);
	
		/* I believe we had an extra byte for the ending 0	 */
		InsertTLV(data,0x1,data2,dlen);

		free(data);

		YSM_Send_SNAC( 0x15,
				0x02,
				0x0,
				0x0,
				data2,
				dlen+sizeof(TLV),
				NewSeq,
				NULL);

		free(data2);

	return;
}

void YSM_RequestBuddyRights (int NewSeq)
{
	int dlen = 1;
	char *data;

		data = malloc(dlen);

		YSM_Send_SNAC( 0x03,
				0x02,
				0x0,
				0x0,
				data,
				dlen,
				NewSeq,
				NULL);

		free(data);

	return;
}


void YSM_RequestContacts (int NewSeq)
{
	int dlen,last_time=0;
	char *data,records_num[2];

		dlen = sizeof(last_time) + sizeof(records_num);
		data = malloc(dlen);
		memset(data,'\0',dlen);
		memset(records_num,'\0',2);

		memcpy(data,&last_time,sizeof(last_time));
		memcpy(data+sizeof(last_time),&records_num,2);
	
		YSM_Send_SNAC( 0x13,
				0x05,
				0x0,
				0x0,
				data,
				dlen,
				NewSeq,
				NULL);

		free(data);

	return;
}

void YSM_RequestPersonal (int NewSeq)
{

		/* YSM_Send_SNAC( 0x01,
				0x0E,
				0x0,
				0x0,
				NULL,
				0,
				NewSeq,NULL);
		*/

	/* Not only send the damn 01 0E snac, get our info too! */

		YSM_RequestInfo(YSM_USER.YSM_Uin,1,NewSeq);

	return;
}

void YSM_RequestRates (int NewSeq)
{

		YSM_Send_SNAC( 0x01,
				0x06,
				0x0,
				0x0,
				NULL,
				0,
				NewSeq, NULL);

	return;
}



void YSM_SearchUINbyMail (char *ContactMail, int NewSeq)
{

	char BytesRem[2],Type[2],ReqID[2],SubTypeID[2];
	char ExtraBytes[2];
	char Mail_lena[2],Mail_lenb[2];
	char *data,*data2;
	int dlen =0;

		memset(BytesRem,'\0',2);	
		memset(ExtraBytes,'\0',2);	
		memset(Type,'\0',2);	
		memset(ReqID,'\0',2);	
		memset(SubTypeID,'\0',2);	
		memset(Mail_lena,'\0',2);	
		memset(Mail_lenb,'\0',2);	

		/* LNTS email (2+strlen mail)	*/
		/* two extra bytes before the lnts (5E 01) and 2 */
		/* more since its an LLNTS so a word before the LNTS */
		dlen = 2 + 4 + 2 + 2 + 2 + 2 + 2 + 2 + strlen(ContactMail) + 1;

		Word_2_Chars(BytesRem,dlen-2);	/* remove BytesRem (-2)*/
		Word_2_Charsb(Type,0xd007);
		Word_2_Charsb(SubTypeID,0x7305);
		Word_2_Charsb(ExtraBytes,0x5E01);
		Word_2_Chars(Mail_lena,strlen(ContactMail)+2+1);/*stringz*/
		Word_2_Chars(Mail_lenb,strlen(ContactMail)+1);/*+1 its stringz*/
	
		data = malloc(dlen);
		data2 = malloc(dlen+sizeof(TLV));
		memset(data,'\0',dlen);
		memset(data2,'\0',dlen+sizeof(TLV));

		memcpy(data,&BytesRem,2);
		memcpy(data+2,&YSM_USER.YSM_Uin,4);
		memcpy(data+2+4,&Type,2);
		memcpy(data+2+4+2,&ReqID,2);
		memcpy(data+2+4+2+2,&SubTypeID,2);
		memcpy(data+2+4+2+2+2,&ExtraBytes,2);
		memcpy(data+2+4+2+2+2+2,&Mail_lena,2);
		memcpy(data+2+4+2+2+2+2+2,&Mail_lenb,2);
		memcpy(data+2+4+2+2+2+2+2+2,ContactMail,strlen(ContactMail));
	
		/* I believe we had an extra byte for the ending 0	 */
		InsertTLV(data,0x1,data2,dlen);

		free(data);

		YSM_Send_SNAC( 0x15,
				0x02,
				0x0,
				0x0,
				data2,
				dlen+sizeof(TLV),
				NewSeq, NULL);

		free(data2);

	return;
}

void
YSM_Registration_UIN (char *Password)
{
	char buf2[4],Plen[2];
	char *buf;
	int buf_len = 0, tsize = 0, seq = 0, r = 0;
	FLAP_Head	head;

	if (YSM_Connect(YSM_DEFAULTSRV, YSM_DEFAULTPORT,
				atoi(YSM_USER.Proxy_host) ? 0x1 : 0x0, 0 ) < 0) 
                YSM_Error(ERROR_NETWORK);

	YSM_READ(YSM_TCPSock,&head,FLAP_HEAD_SIZE);
	YSM_READ(YSM_TCPSock, &buf2, sizeof(buf2));

	buf_len = 40; 	/* extra bytes */
	buf_len += 2 + strlen(Password) + 1;  /* LNTS (word + string + 0) */
	/* sizeof tlv because of the size of the first tlv */
	buf_len += 4 + 4 + sizeof(TLV);

	if( !buf2[0] && !buf2[1] && !buf2[2] && buf2[3] == 1)
	{
		buf = malloc(FLAP_HEAD_SIZE + 4);
		if(buf)
		{
			seq = rand () % 0xffff;
			seq++;
			Word_2_Charsb(head.seq,seq);
			memcpy(&buf[0],&head,FLAP_HEAD_SIZE);
			buf[FLAP_HEAD_SIZE] = 0x00;
			buf[FLAP_HEAD_SIZE+1] = 0x00;
			buf[FLAP_HEAD_SIZE+2] = 0x00;
			buf[FLAP_HEAD_SIZE+3] = 0x01;
			
			r = YSM_WRITE(YSM_TCPSock, &buf[0],FLAP_HEAD_SIZE+4);
			free(buf);
		}
		else 
		{
			YSM_Error(ERROR_CODE);
			exit(0);
		}
	}

	else
	{
		PRINTF(YSM_VERBOSE_BASE,
		"\nInvalid Server Response While Registering. Leaving.\n");
		exit(0);
	}

	buf = malloc(buf_len);
	memset(buf,'\0',buf_len);

	/* Instead of building a new TLV we do this by hand (*gulp*) */
	tsize++;
	buf[tsize] = 0x01;
	tsize+=2;
	buf[tsize] = buf_len - sizeof(TLV);
	tsize++;

	tsize += 4;
	buf[tsize] = 0x28;
	buf[tsize+2] = 0x03;
	tsize += 4;

	tsize += 8;
	buf[tsize] = 0x0a;
	buf[tsize+1] = 0x6a;
	tsize += 4;	
	buf[tsize] = 0x0a; /* 0x9d; */
	buf[tsize+1] = 0x6a; /* 0x08; */
	tsize += 4;
	
	tsize += 16;		/* 4 times 4 all blank */

	memset(Plen,0,2);
	Word_2_Chars(Plen,strlen(Password)+1);
	memcpy(buf+tsize,Plen,2);
	tsize += 2;
	memcpy(buf+tsize,Password,strlen(Password));
	tsize += strlen(Password);
	tsize ++; /* ending 0 */

	buf[tsize] = 0x0a;
	buf[tsize+1] = 0x6a;
	tsize += 2;

	tsize += 4;
	buf[tsize] = 0x06;
	buf[tsize+1] = 0x02;
	tsize += 2;


	YSM_Send_SNAC( 0x17,
			0x04,
			0x0,
			0x0,
			buf,
			tsize,
			seq, NULL);

	free(buf);

	/* Now we hang on SrvResponse until we receive
		the server snac 17,05 acking our registration :P */
	
	while(1) YSM_SrvResponse();

	return;
}


void
YSM_Registration_Reply (FLAP_Head *head, SNAC_Head thesnac, char *buf)
{

int tsize = 0;
int newUIN = 0;

	/* 17 bytes we don't care about :) */
	tsize += 17;

	/* 0x0f or 0x72 byte , extra :P */
	tsize ++;
	
	/* bleh i got tired of describing each byte, lets jump over */
	tsize += 28;

	memcpy(&newUIN,buf+tsize,4);

	if( newUIN != 0 )
	{
		/* Registration Succesfull (?)  */
		PRINTF(YSM_VERBOSE_BASE,
			"\nRegistration Succesfull. Your new UIN is %d\n",
								newUIN);
		exit(0);
	}


	return;
}

void
YSM_InfoChange( int desired, char *newsetting )
{
	char BytesRem[2],Type[2],ReqID[2],SubTypeID[2];
	char nick_len[2], First_len[2], Last_len[2], Mail_len[2];
	char *data,*data2,*nick, Publish_Mail = 0x1;
	int dlen =0, tsize=0;


		memset(BytesRem,'\0',2);	
		memset(Type,'\0',2);	
		memset(ReqID,'\0',2);	
		memset(SubTypeID,'\0',2);	
		memset(nick_len,'\0',2);	

		Word_2_Charsb(Type,0xd007);
		Word_2_Charsb(SubTypeID,0xEA03);
	
		/* Beginning Header */	
		dlen = 	2 + 4 + 2 + 2 + 2  ;
		nick = malloc(MAX_SLAVE_NICK);
		memset(nick,'\0',MAX_SLAVE_NICK);

		memcpy(nick,&YSM_USER.YSM_info.NickName,
				strlen(YSM_USER.YSM_info.NickName));

		Word_2_Chars(nick_len,
				 strlen(YSM_USER.YSM_info.NickName)+1);

	switch(desired)
	{	
		case YSM_COMMAND_NICK:
			dlen += 2 + strlen(newsetting) + 1;
			memcpy(nick,newsetting,MAX_SLAVE_NICK);
			Word_2_Chars(nick_len, strlen(newsetting)+1);

			strncpy(YSM_USER.YSM_info.NickName,
					nick, MAX_SLAVE_NICK-1);
			break;

		default:
			dlen += 2 + strlen(YSM_USER.YSM_info.NickName) + 1;
			return;
			break;
	}

	dlen += 2 + strlen(YSM_USER.YSM_info.FirstName) + 1;
	dlen += 2 + strlen(YSM_USER.YSM_info.LastName) + 1;
	dlen += 2 + strlen(YSM_USER.YSM_info.email) + 1;
	dlen += 3 ; /* 0 for city! */
	dlen += 3;  /* 0 for state! */
	dlen += 3;  /* 0 for phone! */
	dlen += 3;  /* 0 for fax! */
	dlen += 3;  /* 0 for street! */
	dlen += 3;  /* 0 for cellular! */
	dlen += 3;  /* 0 for zip! */
	dlen += 2;  /* 0 for country! (WORD) */
	dlen += 2;  /* 0 for gmt (BYTE) and will be 1 for Publish (BYTE) */
	/* Btw, 1 because if we put 1 on Publish Mail, it WONT publish it */
		
	data = malloc(dlen);
	data2 = malloc(dlen + sizeof(TLV));
	memset(data,'\0',dlen);
	memset(data2,'\0',dlen+sizeof(TLV));

	tsize = 2;
	memcpy(data+tsize,&YSM_USER.YSM_Uin,4);
	tsize += 4;
	memcpy(data+tsize,&Type,2);
	tsize += 2;
	memcpy(data+tsize,&ReqID,2);
	tsize += 2;
	memcpy(data+tsize,&SubTypeID,2);
	tsize += 2;
	memcpy(data+tsize,nick_len,2);
	tsize += 2;
	memcpy(data+tsize,nick,strlen(nick));

	tsize += strlen(nick) + 1;	/* ending 0 */

	Word_2_Chars(First_len,strlen(YSM_USER.YSM_info.FirstName)+1);

	memcpy(data+tsize, First_len ,2);
	tsize += 2;

	memcpy(data+tsize,YSM_USER.YSM_info.FirstName,
					strlen(YSM_USER.YSM_info.FirstName));

	tsize += strlen(YSM_USER.YSM_info.FirstName) + 1;	/* ending 0 */

	Word_2_Chars(Last_len,strlen(YSM_USER.YSM_info.LastName)+1);

	memcpy(data+tsize,Last_len,2);
	tsize += 2;

	memcpy(data+tsize,YSM_USER.YSM_info.LastName,
					strlen(YSM_USER.YSM_info.LastName));

	tsize += strlen(YSM_USER.YSM_info.LastName) + 1;	/* ending 0 */

	Word_2_Chars(Mail_len,strlen(YSM_USER.YSM_info.email)+1);

	memcpy(data+tsize,Mail_len ,2);
	tsize += 2;

	memcpy(data+tsize,YSM_USER.YSM_info.email,
					strlen(YSM_USER.YSM_info.email));

	tsize += strlen(YSM_USER.YSM_info.email) + 1;	/* ending 0 */

	tsize += 3 ; /* 0 for city! */
	tsize += 3;  /* 0 for state! */
	tsize += 3;  /* 0 for phone! */
	tsize += 3;  /* 0 for fax! */
	tsize += 3;  /* 0 for street! */
	tsize += 3;  /* 0 for cellular! */
	tsize += 3;  /* 0 for zip! */
	tsize += 2;  /* 0 for country! (WORD) */
	tsize += 1;  /* 0 for gmt (BYTE) */

	memcpy(data+tsize,&Publish_Mail,1); /* (1 = DONT PUBLISH) */

	Word_2_Chars(BytesRem,dlen-2);
	memcpy(data,&BytesRem,2);

	InsertTLV(data,0x1,data2,dlen);

	free(data);

	YSM_Send_SNAC( 0x15,
			0x02,
			0x0,
			0x0,
			data2,
			dlen+sizeof(TLV),
			YSM_SeqNum++,NULL);

	free(data2);



	return;
}


void
YSM_KeepAlive (void)
{

time_t		rightnow = time(NULL);
char		*data, *data2,  BytesRem[2], Type[2], ReqID[2], SubTypeID[2] ;
int		dlen = 0;

	if ( (rightnow - YSM_LastKA) > 58 )
	{
		PRINTF(YSM_VERBOSE_DEBUG_2,"Sending KEEP Alive Packet.\n");

		YSM_LastKA = time(NULL);

		memset(BytesRem,'\0',2);	
		memset(Type,'\0',2);	
		memset(ReqID,'\0',2);	
		memset(SubTypeID,'\0',2);	

		Word_2_Charsb(BytesRem,0x0800);
		Word_2_Charsb(Type,0xd007);
		
		Word_2_Charsb(SubTypeID,0x0e00);
		
		dlen = 2 + 4 + 2 + 2 ;
		data = malloc(dlen);
		data2 = malloc(dlen + sizeof(TLV));
		memset(data,'\0',dlen);
		memset(data2,'\0',dlen+sizeof(TLV));

		memcpy(data,&BytesRem,2);
		memcpy(data+2,&YSM_USER.YSM_Uin,4);
		memcpy(data+2+4,&Type,2);
		memcpy(data+2+4+2,&ReqID,2);

		InsertTLV(data,0x1,data2,dlen);

		free(data);

		YSM_Send_SNAC( 0x15,
				0x02,
				0x0,
				0x0,
				data2,
				dlen+sizeof(TLV),
				YSM_SeqNum, NULL);

		free(data2);

	}

	return;
}

int YSM_WRITE  (int sock, void *data, int data_len)
{

int	r = 0;

	r = SOCK_WRITE(sock , data, data_len);

	if( r < 0 )
	{
		/* RECONNECT DAMMIT ! */
		close(sock);
		PRINTF(YSM_VERBOSE_FUNCTIONAL,
			"\n" RED "Disconnection detected. Re-launching...\n"
								NORMAL );
		/* pop ip? */
		YSM_Start();
	}

	return r;
}

int YSM_READ (int sock, void *buf, int read_len)
{

	int		r=0, rlen = 0, x = 0;
#if !defined (WIN32) && !defined (BEOS)
	long		e = 0;
	int		t = 0;
#else	
	int		n = 0;
#endif


		rlen = read_len;

#if !defined(WIN32) && !defined(BEOS)

		/* We Check in MicroSeconds our Timeout. */

		for( r = 0, t = rlen,
		e = YSM_GetMicroTime(0) + MAX_READ_TIMEOUT; r < t &&
		YSM_GetMicroTime(e) > 0;)
		{
			x = SOCK_READ( sock, buf+r, rlen);
			if(x > 0)
			{
				r += x;
				rlen -= x;
			}
			else
			{
				perror("Disconnected! Pipe: ");	
				exit(-1);
			}
		}
#else

		while(read_len > r)
		{
			if(YSM_Logged_In)
			{
				n = YSM_FDIs_Set(sock);
				if(n == 0) return r;
			}

			x = SOCK_READ(sock, buf+r, rlen);
			if(x > 0) 
			{
				r += x;
				rlen -= x;
			}
			else
			{
				/* READ ERROR! */
				perror("Disconnected! Pipe: ");
				exit(-1);
			}
		}
#endif

	return r;
}
