/*	$Id: YSM_Prompt.c,v 1.24 2002/04/08 00:36:27 rad2k Exp $	*/
/*
-======================== You Sick Me v7 ===========================-

                                   |                                           
           - ----------------------                                          
    _      |                       |             _________________/_     _    
   _\____________   ______         _ __________  |               /             
     \           | _)    /                     \ |              /              
      \          |_\_  _/_______________/_      \|            _/               
                 |) /______________    /         \            |pix.imp         
                   /   \         )/___/         \  /          |                
  _    _\______   /    /__  ____/       - -------\/___________|               
         ` |  /__/        \/                                                   
           |          _      _           _                  __ ________ _      
           |                  )) y( O u  (s(i  C k    m.( E))                  
           |                                                                  
          -- ---------------- ---- -----                                     
                                  |                                            
                                  |                                            
-========================== YSM_Prompt.c ============================-


YSM (YouSickMe) ICQ Client. An Original Multi-Platform ICQ client.
Copyright (C) 2002 rad2k Argentina.

YSM is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

For Contact information read the AUTHORS file.

*/

#include <errno.h>
#include <string.h>
#include <stdlib.h>
#ifndef WIN32
#include <termios.h>
#endif

#include "YSM.h"

void	 YSM_PasswdCheck();
void	 YSM_DoCommand(char *);
char	*YSM_ReadLongMessage();
int	 getkey();
int	 putch(int);
void	 do_backspace();
void	 YSM_ParseMessageData(char *);
void	 YSM_Upload_BuddyList(void);


UBYTE YSM_Command[MAX_CMD_LEN + 1];
UBYTE YSM_CommandBkp[MAX_CMD_LEN + 1];
UBYTE YSM_MsgData[MAX_DATA_LEN];
UWORD YSM_Message_Arrived = FALSE;
WORD YSM_AFK_Count = 0;
time_t YSM_AFK_Time = 0;
int Curr_CMDLEN = 0;
#ifndef WIN32
static struct termios console_attrs;
#endif

extern char *YSM_GroupID_List;
extern int YSM_GroupID_Users_Amount;

extern UWORD YSM_Redraw_Console;
extern UWORD YSM_SeqNum;
extern UWORD YSM_SETTING_MSG_KIND;
extern UWORD YSM_SETTING_BEEP;
extern UWORD YSM_SETTING_LOGALL;
extern UWORD YSM_SETTING_AFK;
extern UWORD YSM_SETTING_MAXAFKSHOWN;
extern UBYTE YSM_KEYMAP_HELP;
extern UBYTE YSM_KEYMAP_WHOSON;
extern UBYTE YSM_KEYMAP_SLAVES;
extern UBYTE YSM_AFKMessage[MAX_DATA_LEN];
extern UWORD AmountSlaves;
extern YSM_SLAVE *YSM_Query;
extern YSM_SLAVE *YSMSlaves_LastSent, *YSMSlaves_LastRead;
extern YSM_SLAVE *YSMSlavesList,*YSMSlaves_First;

extern time_t	YSM_IdleTIME;

extern struct YSM_MODEL YSM_USER;

UWORD YSM_TabCount = 1;
YSM_SLAVE *nexttabslave = NULL, *prevtabslave = NULL;

void
YSM_ConsoleRestore()
{
#ifndef WIN32
	tcsetattr(STDIN_FILENO, TCSANOW, &console_attrs);
#endif
}


void
YSM_ConsoleSetup()
{
#ifndef WIN32
	struct termios t;

	if (tcgetattr(STDIN_FILENO, &t)) {
		fprintf(stderr, "Can't get standard input attributes: %s.\n",
		    strerror(errno));
		YSM_Error(ERROR_CRITICAL);
		/* NOTREACHED */
	}

	console_attrs = t;
	t.c_lflag &= ~(ICANON | ECHO);

	if (tcsetattr(STDIN_FILENO, TCSANOW, &t)) {
		fprintf(stderr, "Can't set standard input attributes: %s.\n",
		    strerror(errno));
		YSM_Error(ERROR_CRITICAL);
		/* NOTREACHED */
	}

	atexit(YSM_ConsoleRestore);
#endif
}


void
YSM_PasswdCheck()
{
	char *p;

	if (!strcmp(YSM_USER.YSM_Password, "SECURE")) {
		PRINTF(YSM_VERBOSE_BASE, "%s\n",MSG_FOUND_SECPASS);
		p = getpass("Password: ");
		if (p != NULL) {
			snprintf(YSM_USER.YSM_Password,
			    sizeof(YSM_USER.YSM_Password), "%s", p);
			p = getpass(MSG_FOUND_SECPASS2);
			if (p != NULL) {
				if (!strcmp(YSM_USER.YSM_Password, p))
					return;
				else
					PRINTF(YSM_VERBOSE_BASE, "\n%s\n",
						MSG_ERR_PASSMATCH);
			}
		}

		if (p == NULL)
			fprintf(stderr, "Can't get password from standard "
			    "input: %s.\n", strerror(errno));

		YSM_Error(ERROR_CRITICAL);
		/* NOTREACHED */
	}

}


void
YSM_Console_Prompt()
{
	PRINTF(YSM_VERBOSE_BASE,
		"\r| " RED "Y" BLUE "S" GREEN "M" NORMAL " |%s=-> ",
	    (YSM_SETTING_AFK) ? " " BRIGHT_BLUE "AFK" NORMAL " ": "");
        fflush(stdout);
}


void
YSM_ConsoleRead()
{
        char YSM_UserInput,*aux=NULL;
	YSM_SLAVE *auxb=NULL;
	int x;

	if (!(YSM_UserInput = getkey()))
		return;

	YSM_IdleTIME = time(NULL);

	if(!Curr_CMDLEN)
		if(YSM_CheckKeysSetup(YSM_UserInput)) return;

	switch (YSM_UserInput) {

	case '\t':
		if (Curr_CMDLEN)
		{
			nexttabslave = YSMSlaves_First;

			YSM_TabCount++;

			if(YSM_TabCount > AmountSlaves)
				YSM_TabCount = 1;

			for(x=1; nexttabslave->next != 0 ; x++)
			{
				if (x == YSM_TabCount)
				{
					if (nexttabslave->Status == YSM_OFFLINE)
						YSM_TabCount++;

					else
						break;
				}


				nexttabslave = nexttabslave->next;

				if(!nexttabslave->next) 
				{
					YSM_TabCount++;
					nexttabslave = YSMSlaves_First;	
				}

			}

			strncpy(YSM_CommandBkp,YSM_Command,MAX_CMD_LEN);
			memset(&YSM_CommandBkp[Curr_CMDLEN],
				0,MAX_CMD_LEN-Curr_CMDLEN);

			/* Parse out the <msg nick> words */
			if( (YSM_CommandBkp[0] == 'm' &&
				YSM_CommandBkp[1] == 's' &&
				YSM_CommandBkp[2] == 'g' &&
				YSM_CommandBkp[3] == ' ') ||
				(YSM_CommandBkp[0] == 'm' &&
				YSM_CommandBkp[1] == ' ')) 
			{

				/* Nick completition! (Suicide mission) :P*/
				if ( ((YSM_CommandBkp[4] != ' ' &&
				YSM_CommandBkp[1] != ' ') ||
			 	(YSM_CommandBkp[2] != ' ' &&
				YSM_CommandBkp[1] == ' ')) &&
				YSM_CommandBkp[strlen(YSM_CommandBkp)-1] != ' ')
				{

				strtok(YSM_CommandBkp," ");
				aux = strtok(NULL, " ");

				/* in case we have to keep shifting */
				
				if(strtok(NULL," ") != NULL) 
					memset(YSM_CommandBkp,0,MAX_CMD_LEN);

				else if((auxb=YSM_SlaveCompletition(aux))!=NULL)
				{
					/* Set nexttabslave to our finding! */
					YSM_TabCount++;
					nexttabslave = auxb;
					memset(YSM_CommandBkp,0,MAX_CMD_LEN);
				}
				else
					memset(YSM_CommandBkp,0,MAX_CMD_LEN);

				}
				else
					memset(YSM_CommandBkp,0,MAX_CMD_LEN);
						
			}


			if(nexttabslave != 0 )
			{			

				prevtabslave = nexttabslave;
	
				memset(YSM_Command, '\0', MAX_CMD_LEN);
#ifdef YSM_SLAVE_SLASH_MESSAGE
				snprintf(YSM_Command,MAX_CMD_LEN,"msg %s",
						nexttabslave->NickName);
				for(x=Curr_CMDLEN;x>0 ;x--)
					PRINTF(YSM_VERBOSE_BASE, "\b");
			
				Curr_CMDLEN = 0;

				PRINTF(YSM_VERBOSE_BASE,"\n");
				PRINTF(YSM_VERBOSE_BASE,
					"msg %s %s",nexttabslave->NickName,
							YSM_CommandBkp);
#else
				snprintf(YSM_Command,MAX_CMD_LEN,"msg %s ",
						nexttabslave->NickName);

				for(x=Curr_CMDLEN;x>0 ;x--)
					PRINTF(YSM_VERBOSE_BASE, "\b");

				Curr_CMDLEN = 0;

				PRINTF(YSM_VERBOSE_BASE,
					 "msg %s %s",nexttabslave->NickName,
							YSM_CommandBkp);
#endif

				/* "msg%20nick%20" */
				Curr_CMDLEN = 5 + strlen(nexttabslave->NickName) + strlen(YSM_CommandBkp);
				 
			}



		}

		else		
		{

			if(YSMSlaves_LastSent)
			{
			memset(YSM_Command, '\0', MAX_CMD_LEN);
#ifdef YSM_SLAVE_SLASH_MESSAGE
			snprintf(YSM_Command,MAX_CMD_LEN,"msg %s",
					YSMSlaves_LastSent->NickName);
			PRINTF(YSM_VERBOSE_BASE,
				"msg %s ",YSMSlaves_LastSent->NickName);
#else
			snprintf(YSM_Command,MAX_CMD_LEN,"msg %s ",
					YSMSlaves_LastSent->NickName);
			PRINTF(YSM_VERBOSE_BASE,
				"msg %s ",YSMSlaves_LastSent->NickName);
#endif
			Curr_CMDLEN = strlen(YSMSlaves_LastSent->NickName);
			Curr_CMDLEN += 5;	/* "msg%20nick%20" */

			}

		}
		break;

	case '\r':
	case '\n':
#ifdef WIN32
		putch('\r');
#endif
		putch('\n');
		YSM_Command[Curr_CMDLEN] = '\0';
		YSM_DoCommand(YSM_Command);
		memset(YSM_Command, '\0', MAX_CMD_LEN);
		Curr_CMDLEN = 0;
		YSM_Redraw_Console = TRUE;
		break;

	case 8:
	case 0x7f:
		if (Curr_CMDLEN) {
			Curr_CMDLEN--;
			YSM_Command[Curr_CMDLEN] = '\0';
			do_backspace();
		}
		break;

	default:
		if (Curr_CMDLEN == MAX_CMD_LEN - 1) {
			PRINTF(YSM_VERBOSE_BASE,"\a");
			break;
		}

                YSM_Command[Curr_CMDLEN] = YSM_UserInput;
                Curr_CMDLEN++;
		putch(YSM_UserInput);
                break;
	}
}


UWORD
YSM_VerifyCMDType(UBYTE *Explore)
{
	int x;

 	for (x = 0; x <= strlen(Explore); x++)
		Explore[x] = toupper(Explore[x]);
	
	if (!strcmp(Explore, "QUIT") || !strcmp(Explore, "BYE") ||
	    !strcmp(Explore, "LEAVE"))
		return (YSM_COMMAND_QUIT);

	if (!strcmp(Explore, "Q"))
		return (YSM_COMMAND_QUIT);
		
	if (!strcmp(Explore, "HELP") || !strcmp(Explore, "?"))
		return (YSM_COMMAND_HELP);

	if (!strcmp(Explore, "INFO")) 
		return (YSM_COMMAND_INFO);

	if (!strcmp(Explore, "SLAVES") || !strcmp(Explore, "W"))
		return (YSM_COMMAND_SLAVES);

	if (!strcmp(Explore, "ADD") || !strcmp(Explore, "ADDSLAVE"))
		return (YSM_COMMAND_ADDSLAVE);

	if (!strcmp(Explore, "DEL") || !strcmp(Explore, "DELSLAVE"))
		return (YSM_COMMAND_DELSLAVE);

	if (!strcmp(Explore, "AUTH"))
		return (YSM_COMMAND_AUTH);

	if (!strcmp(Explore, "MSG") || !strcmp(Explore, "M"))
		return (YSM_COMMAND_MESG);

	if (!strcmp(Explore, "A"))
		return (YSM_COMMAND_LASTSENT);
	
	if (!strcmp(Explore, "R"))
		return (YSM_COMMAND_REPLY);
	
	if (!strcmp(Explore, "STATUS"))
		return (YSM_COMMAND_STATUS);

	if (!strcmp(Explore, "WHOIS"))
		return (YSM_COMMAND_WHOIS);

	if (!strcmp(Explore, "WO") || !strcmp(Explore, "SLAVESONLINE"))
		return (YSM_COMMAND_WHOSON);

	if (!strcmp(Explore, "BEEP"))
		return (YSM_COMMAND_BEEP);

	if (!strcmp(Explore, "LOG"))
		return (YSM_COMMAND_LOGALL);

	if (!strcmp(Explore, "AFK"))
		return (YSM_COMMAND_AFK);

	if (!strcmp(Explore, "READAFK"))
		return (YSM_COMMAND_READAFK);

	if (!strcmp(Explore, "SEARCH"))
		return (YSM_COMMAND_SEARCH);

	if (!strcmp(Explore, "NICK"))
		return (YSM_COMMAND_NICK);

	if (!strcmp(Explore, "SAVE"))
		return (YSM_COMMAND_SAVE);

	if (!strcmp(Explore, "REQ"))
		return (YSM_COMMAND_REQ);

	if (!strcmp(Explore, "C") || !strcmp(Explore, "CLEAR"))
		return (YSM_COMMAND_CLRSCR);

	return (YSM_COMMAND_UNKNOWN);
}


void
YSM_DoCommand(char *cmd)
{
	char *aux, *auxb, *auxc = 0, UserStatus[MAX_STATUS_LEN];
	UBYTE YSM_SecCMD[MAX_CMD_LEN + 1];
	int x, Uin;
	struct in_addr ysmaddr;
	char fprint_msg[MAX_CMD_LEN];

	if (!strlen(cmd))
		return;

	strcpy(YSM_SecCMD, cmd);

	if ((aux = strtok(YSM_SecCMD, " ")) == NULL)
		return;

	switch (YSM_VerifyCMDType(aux)) {
	case YSM_COMMAND_QUIT:
		close(YSM_TCPSock);
		YSM_Destructor();
		exit(0);
		break;

	case YSM_COMMAND_HELP:
		YSM_DoHelp(cmd);
		return;
		break;

	case YSM_COMMAND_LASTSENT:
		if (YSMSlaves_LastSent) {
			if ((auxc = strtok(NULL, "" )) == NULL ||
			    strlen(auxc) < 1 || *auxc == ' ' ) {
				PRINTF(YSM_VERBOSE_BASE,
					"Switching to -comfortable- message "
				    "Mode. (sending to %s)",
				    YSMSlaves_LastSent->NickName);
				PRINTF(YSM_VERBOSE_BASE,
					"\nUse '.' in an empty line to end "
				    "Message or '#' ");
				PRINTF(YSM_VERBOSE_BASE,
					"to cancel the whole Message.\n");
				auxc = YSM_ReadLongMessage();
				if (auxc == NULL) {
					PRINTF(YSM_VERBOSE_BASE,
					"Comfortable Msg. cancelled.\n");
					return;
				}

				YSM_Send_Message(YSMSlaves_LastSent->Uin, auxc,
				    YSMSlaves_LastSent->NickName,
					YSMSlaves_LastSent->LogFlag);
			}
			else 
			{
				YSM_Send_Message(YSMSlaves_LastSent->Uin, auxc,
				    YSMSlaves_LastSent->NickName,
					YSMSlaves_LastSent->LogFlag );
			}	
		} else {
				PRINTF(YSM_VERBOSE_BASE,
					"Unable to find the last Slave "
				    "you messaged.\n");
				return;
		}

		break;

	case YSM_COMMAND_REPLY:
		if (YSMSlaves_LastRead) {
			if ((auxc = strtok(NULL, "")) == NULL || 
			    strlen(auxc) < 1 || *auxc == ' ') {
				PRINTF(YSM_VERBOSE_BASE,
				"Switching to -comfortable- message "
				    "Mode. (sending to %s)",
				    YSMSlaves_LastRead->NickName);
				PRINTF(YSM_VERBOSE_BASE,
				"\nUse '.' in an empty line to end "
				    "Message or '#' ");
				PRINTF(YSM_VERBOSE_BASE,
				"to cancel the whole Message.\n");
				auxc = YSM_ReadLongMessage();
				if (auxc == NULL) {
					PRINTF(YSM_VERBOSE_BASE,
					"Comfortable Msg. cancelled.\n");
					return;
				}

				YSMSlaves_LastSent = YSMSlaves_LastRead;

				YSM_Send_Message(YSMSlaves_LastRead->Uin, auxc,
				    YSMSlaves_LastRead->NickName,
					YSMSlaves_LastRead->LogFlag);
			} else {
				YSMSlaves_LastSent = YSMSlaves_LastRead;

				YSM_Send_Message(YSMSlaves_LastRead->Uin, auxc,
				    YSMSlaves_LastRead->NickName,
					YSMSlaves_LastRead->LogFlag );
			}
		} else {
				PRINTF(YSM_VERBOSE_BASE,
				"Unable to find the last Slave who "
				   "messaged you.\n");
				return;
		}

		break;

	case YSM_COMMAND_MESG:
		if (strlen(cmd) == strlen("m") ||
		    strlen(cmd) == strlen("msg")) {
			PRINTF(YSM_VERBOSE_BASE,
				"YSM Send Message to SLAVE or UIN.\n");
			return;
		}

		strtok(cmd, " ");

#ifdef YSM_SLAVE_SLASH_MESSAGE 
		if ((auxb = strtok(NULL, "/")) == NULL || *auxb == ' ')
#else
		if ((auxb = strtok(NULL, " ")) == NULL || *auxb == ' ')
#endif
		    {
			PRINTF(YSM_VERBOSE_BASE,
				"YSM ..Msg WHO?! HUH? WHO!.\n");
			return;
		}
		
		if ((auxc = strtok(NULL, "")) == NULL || strlen(auxc) < 1 ||
		    *auxc == ' ') {
			PRINTF(YSM_VERBOSE_BASE,
				"Switching to -comfortable- message Mode.\n"
			    "Use '.' in an empty line to end Message or '#'"
			    "to cancel the whole Message.\n");
			auxc = YSM_ReadLongMessage();
			if(auxc == NULL) {
				PRINTF(YSM_VERBOSE_BASE,
					"Comfortable Msg. cancelled.\n");
				return;
			}
		}
	
		if (isalpha(auxb[0])) {
			YSM_Query = YSM_QuerySlaves(SLAVE_NAME, auxb, 0);
			if (YSM_Query) {
				YSMSlaves_LastSent = YSM_Query;
				YSM_Send_Message(YSM_Query->Uin, auxc,
				    YSM_Query->NickName,
					!YSM_Query ? 0x0 : YSM_Query->LogFlag);
			} else 
				PRINTF(YSM_VERBOSE_BASE,
					"SLAVE Unknown. Message has been "
				    "cancelled.\n");
		} else
			YSM_Send_Message(atoi(auxb), auxc, NULL,0);

		YSM_Query = NULL;
		return;

	case YSM_COMMAND_AUTH:
		if (strlen(cmd) == strlen("auth")) { 
			PRINTF(YSM_VERBOSE_BASE,
					"YSM Authorize a SLAVE Name or UIN.\n");
			return;
		}

		strtok(cmd, " ");

		if ((auxb = strtok(NULL, " ")) == NULL || *auxb == ' ') {
			PRINTF(YSM_VERBOSE_BASE,
					"YSM ..AUTHORIZE WHO?! HUH? WHO!.\n");
			return;
		}

		if (isalpha(auxb[0])) {
			YSM_Query = YSM_QuerySlaves(SLAVE_NAME, auxb, 0);
			if(YSM_Query) {
				YSM_SendAuthOK(YSM_Query->Uin,
				    YSM_Query->NickName);
			} else 
				PRINTF(YSM_VERBOSE_BASE,
					"SLAVE Unknown. Authorization "
				    "cancelled.\n");
		} else
			YSM_SendAuthOK ( atoi (auxb), NULL);

		YSM_Query = NULL;
		return;

	case YSM_COMMAND_WHOIS:
		if (strlen(cmd) == strlen("whois")) 
		{
			PRINTF(YSM_VERBOSE_BASE,
				"YSM whois command requires an UIN or a SLAVE "
			    "Name.\n");
			return;
		}
			
		strtok(cmd, " ");

		if ((auxb = strtok(NULL, " ")) == NULL || *auxb == ' ') {
			PRINTF(YSM_VERBOSE_BASE,
					"YSM ..WHOS WHO?! HUH? WHO!.\n");
			return;
		}
		
		if (isalpha(auxb[0])) 
		{
			YSM_Query = YSM_QuerySlaves(SLAVE_NAME, auxb, 0);
			if (YSM_Query)
			{
				YSM_WriteFingerPrint(YSM_Query->fprint, 
								fprint_msg);
		
				PRINTF(YSM_VERBOSE_BASE, "ICQ #: %d\n",
						YSM_Query->Uin);

				PRINTF(YSM_VERBOSE_BASE,
				 "IP Address: %ld.%ld.%ld.%ld\n",
						YSM_Query->IP[0],
						YSM_Query->IP[1],
						YSM_Query->IP[2],
						YSM_Query->IP[3]);

				PRINTF(YSM_VERBOSE_BASE,
					"Client Fingerprint: %s\n",
							fprint_msg);
						
				YSM_RequestInfo(YSM_Query->Uin,0,YSM_SeqNum);
			}
			
			else
				PRINTF(YSM_VERBOSE_BASE,
					"Unknown SLAVE Name. Request "
				    "Cancelled.\n");	
		} else
			YSM_RequestInfo(atoi(auxb),0,YSM_SeqNum);

		YSM_Query = NULL;
		return;

	case YSM_COMMAND_STATUS:
		if (strlen(cmd) == strlen("status")) {
			YSM_WriteStatus(YSM_USER.YSM_Status,UserStatus);
			PRINTF(YSM_VERBOSE_BASE,
				"Current status: %s.\n",UserStatus); 
			return;
		}
			
		strtok (cmd, " ");

		if ((auxb = strtok(NULL, " ")) == NULL || *auxb == ' ') {
			PRINTF(YSM_VERBOSE_BASE,
				"Dont you want to CHANGE your status? FAG!\n");
			return;
		}
		
		YSM_USER.YSM_Status = YSM_LookupStatus(auxb);
		YSM_WriteStatus(YSM_USER.YSM_Status,UserStatus);	
		PRINTF(YSM_VERBOSE_BASE,
				"Switching to: %s\n",UserStatus);
		YSM_ChangeStatus(YSM_USER.YSM_Status,0x0,YSM_SeqNum);
		break;
		
	case YSM_COMMAND_LOGALL:
		if (strlen(cmd) == strlen("log")) {
			if (YSM_SETTING_LOGALL)
				PRINTF(YSM_VERBOSE_BASE,
						"LOG_ALL is ON\n");
			else
				PRINTF(YSM_VERBOSE_BASE,
						"LOG_ALL is OFF\n");
					
			PRINTF(YSM_VERBOSE_BASE,
				"Log ON|OFF (Global) or Log SLAVE_NAME\n");
			return;
		}
	
		strtok (cmd, " ");

		if ((auxb = strtok(NULL, " ")) == NULL || *auxb == ' ') {
			PRINTF(YSM_VERBOSE_BASE,
				"Log ON|OFF (Global) or Log SLAVE_NAME\n");
			return;
		}

		if (!strcmp(auxb,"ON") || !strcmp(auxb,"on"))
			YSM_SETTING_LOGALL = TRUE;
		else if (!strcmp(auxb,"OFF") || !strcmp(auxb,"off"))
			YSM_SETTING_LOGALL = FALSE;
		else {
			YSM_Query = YSM_QuerySlaves(SLAVE_NAME, auxb, 0);
			if (!YSM_Query) {
       				PRINTF(YSM_VERBOSE_BASE,
					"Unknown SLAVE Name. I wont log!\n");
				return;
			}
		
			if (!YSM_Query->LogFlag)
				YSM_Query->LogFlag = 1;
			else
				YSM_Query->LogFlag = 0;

			PRINTF(YSM_VERBOSE_BASE,
				"LogFlag to %s for Slave %s - UIN %d\n",
			    YSM_Query->LogFlag ? "ON" : "OFF",
			    YSM_Query->NickName, YSM_Query->Uin);
		}

		break;

	case YSM_COMMAND_BEEP:
		if (strlen(cmd) == strlen("beep")) {
			PRINTF(YSM_VERBOSE_BASE,
					"BEEP is %s\n",
			    (YSM_SETTING_BEEP) ? "ON" : "OFF");
			return;
		}
			
		strtok(cmd, " ");

		if ((auxb = strtok(NULL, " ")) == NULL || *auxb == ' ') {
			PRINTF(YSM_VERBOSE_BASE,
				"Learn to use the BEEP command FAG!\n");
			return;
		}

		YSM_SETTING_BEEP =
		    (!strcmp(auxb, "ON") || !strcmp(auxb, "on")) ? TRUE : FALSE;
		break;

	case YSM_COMMAND_CLRSCR:
#ifndef WIN32
		PRINTF(YSM_VERBOSE_BASE,CLRSCR);
#else
		system("cls");
#endif
		YSM_Redraw_Console = TRUE;
		return;

	case YSM_COMMAND_AFK:
		if (strlen(cmd) != strlen("afk"))
		{
			strtok(cmd, " ");
			if ((auxb = strtok(NULL, "")) != NULL && *auxb != ' ')
				strncpy(YSM_AFKMessage, auxb, MAX_DATA_LEN);
			else
			strncpy(YSM_AFKMessage, YSM_AFK_MESSAGE, MAX_DATA_LEN);
		}
		else
			strncpy(YSM_AFKMessage, YSM_AFK_MESSAGE, MAX_DATA_LEN);
			
		
		YSM_AFKMode(!YSM_SETTING_AFK);

		break;

	case YSM_COMMAND_READAFK:
		YSM_ReadAFK(YSM_AFKFILENAME);
		break;

	case YSM_COMMAND_NICK:
		if (strlen(cmd) == strlen("nick"))
		{
			PRINTF(YSM_VERBOSE_BASE, "Your nick is: ");
			if(strlen(YSM_USER.YSM_info.NickName) < 2)
			{
				if( YSM_USER.YSM_info.NickName[0] == '%' )
					PRINTF(YSM_VERBOSE_BASE,
							"none specified\n");
				else
					PRINTF(YSM_VERBOSE_BASE,
						"Server hasn't replied yet.\n");
			}
			else
				PRINTF(YSM_VERBOSE_BASE,
					"%s\n",YSM_USER.YSM_info.NickName);
		}

		else
		{
			strtok(cmd, " ");
			auxb = strtok(NULL, " ");
			if(auxb)
				YSM_InfoChange(YSM_COMMAND_NICK,auxb);
		}
		break;

	case YSM_COMMAND_SAVE:
		PRINTF(YSM_VERBOSE_BASE,
		"\n" CYAN "YSM POLITICAL ASYLUM " NORMAL "FOR SLAVES\n");
		YSM_Upload_BuddyList ();
		break;

	case YSM_COMMAND_REQ:
		if (strlen(cmd) == strlen("req")) { 
			PRINTF(YSM_VERBOSE_BASE,
				"YSM Request Auth from a SLAVE Name or UIN.\n");
			PRINTF(YSM_VERBOSE_BASE,
			"Usage: req <nick | uin> [optional: req msg]\n");
			return;
		}

		strtok(cmd, " ");

		if ((auxb = strtok(NULL, " ")) == NULL || *auxb == ' ') 
		{
			PRINTF(YSM_VERBOSE_BASE,
				"YSM ..REQUEST TO WHOM?! HUH? WHO!.\n");
			return;
		}

		/* Get the message if any */
		if ((auxc = strtok(NULL, "")) == NULL || *auxc == ' ')
			auxc = NULL;
	
		if (isalpha(auxb[0])) 
		{
			YSM_Query = YSM_QuerySlaves(SLAVE_NAME, auxb, 0);
			if(YSM_Query) 
			{
				YSM_SendAuthRequest(YSM_Query->Uin,
				    YSM_Query->NickName, auxc);

				if(YSM_Query->DownloadedFlag == 0x0a)
				{
					/* Request Modify Access ! */
					YSM_Buddy_RequestModify ();

					YSM_Buddy_AddItem (YSM_Query,
						YSM_BUDDY_GROUPNAME,
						YSM_BUDDY_GROUPID,
						YSM_Query->Uin,
						YSM_BUDDY_SLAVE, 0, 1);

					YSM_Query->DownloadedFlag = 0x0b;
				}

			} 
			else 
				PRINTF(YSM_VERBOSE_BASE,
				"SLAVE Unknown. Authorization Request "
				    "cancelled.\n");
		} else
			YSM_SendAuthRequest ( atoi (auxb), NULL, auxc);

		YSM_Query = NULL;
		return;



		break;

	case YSM_COMMAND_SEARCH:

		if (strlen(cmd) == strlen("search")) {
			PRINTF(YSM_VERBOSE_BASE,
				"usage: search <mail>\n");
			PRINTF(YSM_VERBOSE_BASE,
				"example -> search rad2k@mail.ru\n");
			return;
		}
			
		strtok(cmd, " ");
		auxb = strtok(NULL, " ");

		if (strchr(auxb,'@'))		
			YSM_SearchUINbyMail(auxb,YSM_SeqNum);
		else
			PRINTF(YSM_VERBOSE_BASE,
				"Invalid e-mail address specified.\n");

		return;

		break;

	case YSM_COMMAND_SLAVES:	

		if (strlen(cmd) != strlen("w") &&
				 strlen(cmd) != strlen("slaves"))
		{
			strtok(cmd, " ");
			if ((auxb = strtok(NULL, "")) != NULL && *auxb != ' ')
			YSM_PrintOrganizedSlaves(YSMSlavesList, -1, auxb);
		}
		else
			YSM_PrintOrganizedSlaves(YSMSlavesList, -1, NULL);

		return;

	case YSM_COMMAND_WHOSON:

		if (strlen(cmd) != strlen("wo"))
		{
			strtok(cmd, " ");
			if ((auxb = strtok(NULL, "")) != NULL && *auxb != ' ')
			YSM_PrintOrganizedSlaves(YSMSlavesList, YSM_ONLINE,
									auxb);
			

		}
		else
			YSM_PrintOrganizedSlaves(YSMSlavesList, YSM_ONLINE,
									NULL);

		return;

	case YSM_COMMAND_ADDSLAVE:
		if (strlen(cmd) == strlen("add") || 
		    strlen(cmd) == strlen("addslave")) {
			PRINTF(YSM_VERBOSE_BASE,
			"Adding a Slave requires a SLAVE Name and a "
			    "UIN. Ex. addslave Cacho 9249249\n");
			return;
		}
			
		strtok(cmd, " ");

		if ((auxb = strtok(NULL, " ")) == NULL || *auxb == ' ') {
			PRINTF(YSM_VERBOSE_BASE,
				"YSM add WHO?! HUH? WHO!.\n");
			return;
		}
		
		if ((auxc = strtok(NULL, "" )) == NULL || strlen(auxc) < 1 ||
		    *auxc == ' ' ) {
			PRINTF(YSM_VERBOSE_BASE,
				"You are missing the UIN #.\n");
			return;
		}
			
		Uin = atoi(auxc);
		if (isalpha(auxb[0])) {
			auxb[strlen(auxb)+1] = '\0';
			YSM_AddSlave(auxb, Uin);
			YSM_SeqNum--;	
			YSM_SendContacts(YSM_SeqNum);
		} else
			PRINTF(YSM_VERBOSE_BASE,
				"Stupid Syntax Mistake. Use: addslave "
			    "SLAVENAME UIN\n");

		return;

	case YSM_COMMAND_DELSLAVE:
		if (strlen(cmd) == strlen("del"))
		{
			PRINTF (YSM_VERBOSE_BASE,
				"Deleting a Slave requires a SLAVE NAME."
			    "Ex. delslave marioneta\n");
			return;
		}

		strtok(cmd, " ");
	
		if ((auxb = strtok(NULL, " ")) == NULL || auxb[0] == ' ' ||
		    strlen(auxb) < 1) {
			PRINTF(YSM_VERBOSE_BASE,
				"YSM ..del WHO?! HUH? WHO!.\n");
			return;
		}

		if (isalpha(auxb[0])) {
			YSM_Query = YSM_QuerySlaves(SLAVE_NAME, auxb, 0);
			if (YSM_Query) {
				PRINTF(YSM_VERBOSE_BASE,
					"Are you sure? [Y/N] : ");
				x = getchar();
				PRINTF(YSM_VERBOSE_BASE,"\n");
				if (toupper(x) == 'Y') {
					YSM_RemoveContact(YSM_Query,YSM_SeqNum);
					YSM_DelSlave(auxb);
				}
			} else
				PRINTF(YSM_VERBOSE_BASE,
					"Unknown SLAVE Name. Wont delete a "
				    "ghost!.\n");
		} else {
			PRINTF(YSM_VERBOSE_BASE,
				"Stupid and Incorrect Use Detected. Use: "
			    "delslave SLAVENAME\n");
		}
	
		YSM_Query = NULL;
		return;

	case YSM_COMMAND_INFO:	
		YSM_WriteStatus(YSM_USER.YSM_Status,UserStatus);
		PRINTF(YSM_VERBOSE_BASE,
			"If you want info on a slave use the \"whois\" command."
		    "\nClient Version: %s%s\n"
		    "Available information:\n"
		    "UIN: %d\tCURRENT STATUS: %s\n"
		    "Amount of Slaves: %d\tSeqNum: %d\n",
			YSM_INFORMATION, YSM_INFORMATION2,
			YSM_USER.YSM_Uin, UserStatus,
		    AmountSlaves, YSM_SeqNum);
		if (YSM_SETTING_BEEP)
			PRINTF(YSM_VERBOSE_BASE,
					"Beeping is ON.\n");
		if (YSM_SETTING_LOGALL)
			PRINTF(YSM_VERBOSE_BASE,
					"LogAll is ON.\n");

		ysmaddr.s_addr = YSM_USER.YSM_IP;

		PRINTF(YSM_VERBOSE_BASE,
				"Ip address: %s\n", inet_ntoa(ysmaddr));
		PRINTF(YSM_VERBOSE_BASE, "Nickname: %s\tFirstname: %s\tLastname: %s\n"
		"E-Mail: %s\n", YSM_USER.YSM_info.NickName ,
				YSM_USER.YSM_info.FirstName ,
				YSM_USER.YSM_info.LastName ,
				YSM_USER.YSM_info.email );


						
		return;

	default:
		PRINTF(YSM_VERBOSE_BASE, "Unknown Command.\n\n");
	}
}


char *
YSM_ReadLongMessage()
{
	char *tmp = &YSM_MsgData[0];
	char line[MAX_LINE_LEN+1];
	int x=0,y;

	memset(YSM_MsgData,'\0',MAX_DATA_LEN);
	memset(line,'\0',MAX_LINE_LEN+1);

	while (YSM_fgets(line, sizeof(line)) != NULL) 
	{
		y = strlen(line);

		if ( (x+y) > MAX_DATA_LEN) 
			y = MAX_DATA_LEN - x;

		x+=y;

		if (y <= 0)
		{
			PRINTF(YSM_VERBOSE_BASE,
					"\nMaximum Data Reached. \a!\n");
			return (tmp);
		}

		
		if (strlen(line) == 2) 
		{
			if (line[0] == '.')		/* end Message */
				return (tmp);
			else if (line[0] == '#')
				return (NULL);

		}

		strncat(YSM_MsgData, line, y);
	}

	return (tmp);
}


void
YSM_DisplayMsg(int MessageType, int UIN, int STATUS, int LEN, char *DATA,
	       char *Nick, int log_flag)
{
	char buf[MAX_STATUS_LEN];
	char log_name[MAX_PATH];
	/* the 10 is fine..we control this below */
	char time_string[10];
	char *log_data;
	time_t log_time;
	struct tm *time_stamp;
	int log_len=0;
	int NotSlave;
	
	YSM_WriteStatus(STATUS,buf);

	if (!Nick)
	{
		Nick = "NOT a SLAVE";
		NotSlave = TRUE;
	} 

	else 
		NotSlave = FALSE;

	log_time = time(NULL);

	if (log_flag || YSM_SETTING_LOGALL || YSM_SETTING_AFK) {
		log_len = MAX_DATA_LEN+MAX_SLAVE_NICK+MAX_UIN_LEN+2;
		log_data = malloc(log_len);
		memset(log_name,'\0',MAX_PATH);
		memset(log_data,'\0',log_len);

		if (YSM_SETTING_AFK)
		{	
			YSM_AFK_Count++;
			snprintf(log_name, MAX_PATH-1, "%s", YSM_AFKFILENAME);
		}
		else	
			snprintf(log_name, MAX_PATH-1, "%d", UIN);

		snprintf(log_data,log_len,"<%s|%d> %s <@#> %s", Nick, UIN,DATA,
		    ctime(&log_time));

		YSM_DumpLogFile(log_name,log_data);
		free(log_data);
	}

	YSM_Message_Arrived = TRUE;

	switch (MessageType)
	{

	case YSM_MESSAGE_NORMAL:
	
		YSM_ParseMessageData( DATA );

		switch( YSM_SETTING_MSG_KIND )
		{
		
		case YSM_MSG_KIND_ONELINE:

		PRINTF(YSM_VERBOSE_FUNCTIONAL,"\r--> %s",ctime(&log_time));
		PRINTF(YSM_VERBOSE_BASE,
			"%s<%s%s | %d | %s%s>%s[len:%d] %s%s%s\n", BLUE,
		    NORMAL, Nick, UIN, buf, BLUE, NORMAL, LEN, COLOR_MSGTEXT,
	 	    DATA, NORMAL);
		
			break;

		case YSM_MSG_KIND_VERBOSE:

		PRINTF(YSM_VERBOSE_FUNCTIONAL,"\r--> %s",ctime(&log_time));
		PRINTF(YSM_VERBOSE_BASE,
			"%s - SLAVE NAME: %s - UIN: %d\n"
		    "<DATA [%d]>: %s\n", MSG_INCOMING_MESSAGE,
					 Nick, UIN, LEN, DATA);
			break;

		case YSM_MSG_KIND_IRC:
		{
				time_stamp = localtime( &log_time );

				strftime( time_string, 9, "%T", time_stamp );

				if (!NotSlave)
				{
				PRINTF( YSM_VERBOSE_BASE,
				NORMAL "\r%s " BRIGHT_BLUE "<" NORMAL
				"%s" BRIGHT_BLUE "> " NORMAL  COLOR_MSGTEXT
				"%s\n" NORMAL, time_string, Nick, DATA);
				}
				else
				{
				PRINTF( YSM_VERBOSE_BASE,
				 NORMAL "\r%s " BRIGHT_BLUE "<" NORMAL
				"%d" BRIGHT_BLUE "> " NORMAL  COLOR_MSGTEXT
				"%s\n" NORMAL, time_string, UIN, DATA);
				}

				break;
		}

		default:
				break;

		}

		break;

	case YSM_MESSAGE_URL:
		PRINTF(YSM_VERBOSE_BASE ,"\r%s - SLAVE NAME: %s - UIN: %d\n"
		    "< url: %s >\n", MSG_INCOMING_URL, Nick, UIN, DATA);
		break;	

	case YSM_MESSAGE_AUTH:
		PRINTF(YSM_VERBOSE_BASE ,"\r%s UIN #%d "
		    "(Slave: %s).\nThe following Message arrived with the"
		    "request: %s\n", MSG_INCOMING_AUTHR, UIN, Nick, DATA);
		break;

	case YSM_MESSAGE_ADDED:
		PRINTF(YSM_VERBOSE_BASE ,"\r%s ICQ #%d just added You to the list."
		    " (Slave: %s).\n", MSG_WARN_ADDED, UIN, Nick);
		break;

	case YSM_MESSAGE_AUTHOK:
		PRINTF(YSM_VERBOSE_BASE ,"\r%s #%d .\n",MSG_WARN_AUTHOK, UIN);
		break;

	case YSM_MESSAGE_AUTHNOT:
		PRINTF(YSM_VERBOSE_BASE ,"\r%s ICQ #%d "
		    "KILL HIM!\n",MSG_WARN_AUTHDENY, UIN);
		break;

	default:
		YSM_Error(ERROR_CODE);
		break;
	}

	YSM_Redraw_Console = TRUE;
}

int YSM_CheckKeysSetup (char YSM_UserInput)
{

	if (YSM_KEYMAP_HELP == YSM_UserInput)
	{
		PRINTF(YSM_VERBOSE_BASE,"\n");
		YSM_DoHelp("help ");
		YSM_Redraw_Console = TRUE;
		return TRUE;
	}

	else if (YSM_KEYMAP_WHOSON == YSM_UserInput)
	{
			PRINTF(YSM_VERBOSE_BASE,"\n");
			YSM_PrintOrganizedSlaves(YSMSlavesList, YSM_ONLINE,
									NULL);
			YSM_Redraw_Console = TRUE;
			return TRUE;
	}
	
	else if (YSM_KEYMAP_SLAVES == YSM_UserInput)
	{
			PRINTF(YSM_VERBOSE_BASE,"\n");
			YSM_PrintOrganizedSlaves(YSMSlavesList, -1, NULL);
			YSM_Redraw_Console = TRUE;
			return TRUE;
	}

	return FALSE;
}

void
YSM_ParseMessageData ( char *data )
{
int x;

	for(x=0; x <= strlen(data) ; x++)
	{
		/* Mainly ment for removing the hability of 
		beeping with ansi between ansi supported clients,
		YSM on win32 for example */

		if(data[x] == '\a') data[x] = ' ';
	}

	return;
}


void
YSM_Buddy_CreateGroup (void)
{
	/*	We initialized the Amount variable to -1, if the group
		existed while we read the Buddy List but it was empty, 
		we sat 0x0 as its value. (which means no need to create) */
	
	if (YSM_GroupID_Users_Amount < 0)
	{
		PRINTF(YSM_VERBOSE_EXTRA,
			"CREATING YSM Group, doesn't exist!..\n");
		YSM_Buddy_AddItem (0x0, YSM_BUDDY_GROUPNAME,
				YSM_BUDDY_GROUPID, 0x0, YSM_BUDDY_GROUP, 0, 0);
		YSM_GroupID_Users_Amount = 0;
	}
	return;
}


void
YSM_Upload_BuddyList (void)
{

YSM_SLAVE *SlavesList = YSMSlaves_First;
int i=0, count=0;

	/* Request Modify Access ! */
	YSM_Buddy_RequestModify ();

	YSM_Buddy_CreateGroup ();

	for (i=1 ; SlavesList->next != 0; i++)
	{
		if(count >= MAX_SAVE_COUNT)
			break;
	
		if(!SlavesList->DownloadedFlag)
		{
			YSM_Buddy_AddItem (SlavesList,YSM_BUDDY_GROUPNAME,
			YSM_BUDDY_GROUPID, SlavesList->Uin, YSM_BUDDY_SLAVE,
								 0, 0);
			count++;
		}

		SlavesList = SlavesList->next;
	}

	PRINTF(YSM_VERBOSE_FUNCTIONAL,
		"Please wait until %d results show up" "(or the few left).\n",
							 MAX_SAVE_COUNT);
	PRINTF(YSM_VERBOSE_FUNCTIONAL,
		"Use 'save' again to upload the missing slaves");
	PRINTF(YSM_VERBOSE_FUNCTIONAL,
		" in groups of %d.\n", MAX_SAVE_COUNT);


}
