/*	$Id: YSM_Setup.c,v 1.18 2002/04/08 00:25:40 rad2k Exp $	*/
/*
-======================== You Sick Me v7 ===========================-

                                   |                                           
           - ----------------------                                          
    _      |                       |             _________________/_     _    
   _\____________   ______         _ __________  |               /             
     \           | _)    /                     \ |              /              
      \          |_\_  _/_______________/_      \|            _/               
                 |) /______________    /         \            |pix.imp         
                   /   \         )/___/         \  /          |                
  _    _\______   /    /__  ____/       - -------\/___________|               
         ` |  /__/        \/                                                   
           |          _      _           _                  __ ________ _      
           |                  )) y( O u  (s(i  C k    m.( E))                  
           |                                                                  
          -- ---------------- ---- -----                                     
                                  |                                            
                                  |                                            
-========================== YSM_Setup.c ============================-


YSM (YouSickMe) ICQ Client. An Original Multi-Platform ICQ client.
Copyright (C) 2002 rad2k Argentina.

YSM is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

For Contact information read the AUTHORS file.

*/

#include "YSM.h"
/* International Languages Charset Convertion! */
#include "YSM_Iconv.h"

int YSM_PreSetup(int COMMAND);
void YSM_ReadConfig(FILE *YSM_CFGFD);
void YSM_CreateConfig(void);
void YSM_SaveConfig(void);
void YSM_CFGStatus ( char *validate );

UBYTE YSM_ConfigFile[MAX_PATH];
UBYTE YSM_ConfigDir[MAX_PATH];
UBYTE YSM_AFKMessage[MAX_DATA_LEN];
void YSM_AskProxyConfiguration	(void);
UWORD AmountSlaves;


extern UBYTE YSM_KEYMAP_HELP;
extern UBYTE YSM_KEYMAP_WHOSON;
extern UBYTE YSM_KEYMAP_SLAVES;
extern UWORD YSM_SETTING_MSG_KIND;
extern UWORD YSM_SETTING_LOGALL;
extern UWORD YSM_SETTING_VERBOSE;
extern UWORD YSM_SETTING_VERSION_CHECK;
extern UWORD YSM_SETTING_BEEP;
extern UWORD YSM_SETTING_AFK;
extern UWORD YSM_SETTING_AFKMAXSHOWN;
extern UWORD YSM_SETTING_IDLETIME;
extern UWORD YSM_SETTING_ASK_KEYMAP;
extern UWORD YSM_SETTING_ASK_DOWNLOAD;
extern UWORD YSM_SeqNum;
extern UWORD YSM_TCPSock;
extern WORD YSM_AFK_Count;
extern time_t YSM_AFK_Time;
extern YSM_SLAVE *YSMSlavesList,*YSMSlaves_First;
extern struct YSM_MODEL YSM_USER;

void YSM_Setup(void) {

	PRINTF(YSM_VERBOSE_DEBUG_2, "Setting up Config. file Path.");	
	YSM_PreSetup(SETUP_HOME);
	PRINTF(YSM_VERBOSE_DEBUG_2, "Reading or Creating Config file.");
	YSM_PreSetup(SETUP_CONFIG);
	PRINTF(YSM_VERBOSE_DEBUG_2, "Retrieving Slave DATA from Config.");
	YSM_PreSetup(SETUP_SLAVES);

}

int YSM_PreSetup(int COMMAND)  {

	FILE *YSM_CFGFD;	
	char *homep=0;
	char *homep2=0;

	switch(COMMAND) {

		case SETUP_HOME:
			homep = malloc(MAX_PATH);
			memset(homep,'\0',MAX_PATH);

#ifdef WIN32
			if(getenv("USERPROFILE") != NULL)
				strncpy(homep,getenv("USERPROFILE"),MAX_PATH);
			else
				strcpy(homep,"C:");
#else
			strncpy(homep,getenv("HOME"),MAX_PATH);
#endif

			homep2 = malloc(strlen(homep)+2);
			strncpy(homep2,homep,strlen(homep)+2);
			strcat(homep2,"/");
			strncpy(YSM_ConfigFile,homep2,MAX_PATH);
			strcat(YSM_ConfigFile,YSM_CFGDIRECTORY);
			strncpy(YSM_ConfigDir,YSM_ConfigFile,MAX_PATH);
			strcat(YSM_ConfigFile,"/");
			strcat(YSM_ConfigFile,YSM_CFGFILENAME);
			free(homep);
			free(homep2);

		break;

		case SETUP_CONFIG:

			if ((YSM_CFGFD = fopen(YSM_ConfigFile,"r")) != NULL) {

					YSM_ReadConfig(YSM_CFGFD);
					fclose(YSM_CFGFD);
			}

			else {

		        PRINTF(YSM_VERBOSE_BASE,
	"\n%sWelcome to the Configuration Wizard!%s <<.\n",BROWN,NORMAL);
                        PRINTF(YSM_VERBOSE_BASE,
	"As this is your first time running YSM, you will be\n");
			PRINTF(YSM_VERBOSE_BASE,
	"prompted to fill some information required to create your\n");
			PRINTF(YSM_VERBOSE_BASE,
	"configuration file. This file will be stored in your home\n");
			PRINTF(YSM_VERBOSE_BASE,
	"directory at %s[%s]%s\n",BROWN,YSM_ConfigFile,NORMAL);
			PRINTF(YSM_VERBOSE_BASE,
	"In case you may want to change/update any of this information\n");
			PRINTF(YSM_VERBOSE_BASE,
	"just do it directly in the Configuration file.\n\n");

			PRINTF(YSM_VERBOSE_BASE,
				"So, lets start!:\n");

			YSM_CreateConfig();
			
			}
			
		break;

		case SETUP_SLAVES:

			if ((YSM_CFGFD = fopen(YSM_ConfigFile,"r")) != NULL) {
	
				YSM_ReadSlaves(YSM_CFGFD);
				fclose(YSM_CFGFD);

			}

			else {
		
			PRINTF (YSM_VERBOSE_BASE,
			"Contact list couldn't be read!. File not found.\n");
			YSM_Error (ERROR_CRITICAL);

			}
		break;

		default:
		
		YSM_Error(ERROR_CRITICAL);
		break;
	}

	return 0;
}

void YSM_ReadConfig (FILE *YSM_CFGFD) {

	int YSM_CFGEND = FALSE;
	char YSM_Buff[MAX_PATH];
	char *aux,*auxb;


		memset(&YSM_AFKMessage,0,MAX_DATA_LEN);
#ifdef YSM_USE_ICONV
		memset(YSM_SETTING_CHARSET_TRANS,0,MAX_DATA_LEN+4);
		memset(YSM_SETTING_CHARSET_LOCAL,0,MAX_DATA_LEN+4);
#endif

		while(!YSM_CFGEND) {
		
			memset(YSM_Buff,'\0',MAX_PATH);
			fgets(YSM_Buff,sizeof(YSM_Buff),YSM_CFGFD);

			if ((YSM_Buff[0] != '#') && (YSM_Buff[0] != 0)) {

				aux = strtok(YSM_Buff,">");
				if ((auxb = strchr(aux,'\n'))) *auxb = '\0';
				
				if(!strcmp(aux,"SERVER"))
	                        strncpy(YSM_USER.SRV_HostName,strtok(NULL," \n\t"),MAX_PATH);

				else if(!strcmp(aux,"SERVERPORT"))
                       		YSM_USER.SRV_Port=atoi(strtok(NULL," \n\t"));

               			else if(!strcmp(aux,"PASSWORD"))
                        	strncpy(YSM_USER.YSM_Password,strtok(NULL," \n\t"),MAX_PWD_LEN);

                		else if(!strcmp(aux,"STATUS"))
				YSM_CFGStatus (strtok (NULL," \n\t"));

                		else if(!strcmp(aux,"UIN"))
                        	YSM_USER.YSM_Uin = atoi(strtok(NULL," \n\t"));

		       		else if(!strcmp(aux,"PARANOID"))
                        	YSM_USER.YSM_Paranoid = atoi(strtok(NULL," \n\t"));	
				else if(!strcmp(aux,"VERBOSE"))
				YSM_SETTING_VERBOSE = atoi(strtok(NULL," \n\t"));
				else if(!strcmp(aux,"BEEP"))
				YSM_SETTING_BEEP = atoi(strtok(NULL," \n\t"));

				else if(!strcmp(aux,"LOGALL"))
				YSM_SETTING_LOGALL = atoi(strtok(NULL," \n\t"));

				else if(!strcmp(aux,"IDLETIME"))
				YSM_SETTING_IDLETIME = atoi(strtok(NULL," \n\t"));				

				else if(!strcmp(aux,"AFKMESSAGE"))
				strncpy(YSM_AFKMessage,strtok(NULL,"\n\t"),
							MAX_DATA_LEN);

				else if(!strcmp(aux,"AFKMAXSHOWN"))
				YSM_SETTING_AFKMAXSHOWN = atoi(strtok(NULL," \n\t"));

				else if(!strcmp(aux,"PROXY"))
	                        strncpy(YSM_USER.Proxy_host,strtok(NULL," \n\t"),MAX_PATH);
                       		
				else if(!strcmp(aux,"PROXY_PORT"))
				YSM_USER.Proxy_port=atoi(strtok(NULL," \n\t"));

				else if(!strcmp(aux,"PROXY_HTTPS"))
				YSM_USER.Proxy_https=atoi(strtok(NULL," \n\t"));
				

				else if(!strcmp(aux,"ASK_KEYMAP"))
				YSM_SETTING_ASK_KEYMAP = atoi(strtok(NULL," \n\t"));
		
				else if(!strcmp(aux,"ASK_DOWNLOAD"))
				YSM_SETTING_ASK_DOWNLOAD = atoi(strtok(NULL," \n\t"));

				else if(!strcmp(aux,"MSG_KIND"))
				YSM_SETTING_MSG_KIND = atoi(strtok(NULL," \n\t"));

				else if(!strcmp(aux,"VERBOSE"))
				YSM_SETTING_VERBOSE = atoi(strtok(NULL," \n\t"));

				else if(!strcmp(aux,"VERSION_CHECK"))
				YSM_SETTING_VERSION_CHECK = atoi(strtok(NULL," \n\t"));


	
#ifdef YSM_USE_ICONV
				else if(!strcmp(aux,"CHARSET_TRANS"))
				strncpy(YSM_SETTING_CHARSET_TRANS,
						strtok(NULL," \n\t"),
						MAX_CHARSET);

				else if(!strcmp(aux,"CHARSET_LOCAL"))
				strncpy(YSM_SETTING_CHARSET_LOCAL,
						strtok(NULL," \n\t"),
						MAX_CHARSET);
#endif

                		else if(!strcmp(aux,SLAVES_TAG))
                        	YSM_CFGEND=TRUE;

				else if( *aux )
				PRINTF(YSM_VERBOSE_BASE,
		RED "UNKNOWN cfg directive '%s' , ignoring...\n" NORMAL,aux);
				
			}

		}	
}



void
YSM_CreateConfig(void) 
{


	char YSM_tmpa[MAX_PWD_LEN+1],YSM_tmpb[MAX_UIN_LEN+1];
	char *p_passwd;
	
		strncpy (YSM_USER.SRV_HostName,YSM_DEFAULTSRV,MAX_PATH);
		YSM_USER.SRV_Port = YSM_DEFAULTPORT;
		YSM_USER.YSM_Uin = 0;

	        PRINTF(YSM_VERBOSE_BASE,
			"\nYour %sUIN%s [use 0 for new]#: ",RED,NORMAL);
     		YSM_fgets(YSM_tmpb, MAX_UIN_LEN);

		YSM_USER.YSM_Uin = atoi(YSM_tmpb);


		if( YSM_USER.YSM_Uin == 0 )
		{

		YSM_AskProxyConfiguration();


		PRINTF(YSM_VERBOSE_BASE,
			"\nRegister a new ICQ Number.\n");
		PRINTF(YSM_VERBOSE_BASE,
			"You will be asked for your desired password twice.\n");
		PRINTF(YSM_VERBOSE_BASE,
			"The Password must be 8 chars max.\n");

		}
		else	
		PRINTF(YSM_VERBOSE_BASE,
			"\nMaximum Password Len is set to %d.\n",MAX_PWD_LEN);

		p_passwd = getpass("Password: ");
        	strncpy(YSM_USER.YSM_Password,p_passwd,MAX_PWD_LEN-1);

		p_passwd = getpass("Again?[verify]: ");
        	strncpy(YSM_tmpa,p_passwd,MAX_PWD_LEN-1);
       
		if( !strcmp( YSM_USER.YSM_Password , YSM_tmpa ) ) 
		{
			if( YSM_USER.YSM_Uin == 0 )
				YSM_Registration_UIN (YSM_USER.YSM_Password);

                	YSM_SaveConfig();
                	PRINTF(YSM_VERBOSE_BASE,
				"\nConfiguration file created.\n");
                	return;
        	}

		PRINTF(YSM_VERBOSE_BASE,
		"\n%s<WRONG>%s - Passwords did not match.\n",RED,NORMAL);
		YSM_Error(ERROR_CRITICAL);
        	exit(-1);
}


void YSM_SaveConfig(void) {

        time_t YSM_tmpdate;
	FILE *YSM_CFGFD;

	/* mkdir returns 0 if success */
	if (mkdir(YSM_ConfigDir,0700))
	{
		if (errno != EEXIST)
		{
			PRINTF(YSM_VERBOSE_BASE,
				"\nmkdir() directory %s error",YSM_ConfigDir);
			YSM_Error(ERROR_CRITICAL);
		}
	}

        if( ( YSM_CFGFD = fopen(YSM_ConfigFile,"w") ) != NULL) {

                YSM_tmpdate=time(NULL);

                fprintf(YSM_CFGFD,"# %s%s . \n",
					YSM_INFORMATION,YSM_INFORMATION2);

                fprintf(YSM_CFGFD,
		"# YSM <Configuration file> Created-> %s\n",
						 ctime(&YSM_tmpdate));

                fprintf(YSM_CFGFD,
		"# Critical Consequences might show up if you make any\n");

                fprintf(YSM_CFGFD,"# mistakes in this file. \n");
                fprintf(YSM_CFGFD,"\n");
		fprintf(YSM_CFGFD, "# This Status specifies the status you will have by default\n");
		fprintf(YSM_CFGFD,"# once you log in. Options are ONLINE, AWAY, DND, CHAT, NA,\n");
		fprintf(YSM_CFGFD,"# OCCUPIED and INVISIBLE.\n");
                fprintf(YSM_CFGFD,"STATUS>ONLINE\n");
                fprintf(YSM_CFGFD,"\nUIN>%d\n",YSM_USER.YSM_Uin);
                fprintf(YSM_CFGFD,"# You may replace your password with the word \"SECURE\"\n");
                fprintf(YSM_CFGFD,"# in order to be prompted for a password when logging in.\n");
                fprintf(YSM_CFGFD,"PASSWORD>%s\n",YSM_USER.YSM_Password);
                fprintf(YSM_CFGFD,"\nSERVER>%s\n",YSM_USER.SRV_HostName);
                fprintf(YSM_CFGFD,"SERVERPORT>%i\n",YSM_USER.SRV_Port);
		fprintf(YSM_CFGFD,"# Amount of minutes to wait with no keyboard input before going\n# automatically into AFK mode.");
		fprintf(YSM_CFGFD,"\nIDLETIME>%d\n",YSM_SETTING_IDLETIME);
		fprintf(YSM_CFGFD,"\n# The Auto-Reply Message of the AFK mode");
		fprintf(YSM_CFGFD,"\nAFKMESSAGE>%s\n",YSM_AFK_MESSAGE);
		fprintf(YSM_CFGFD,"\n# Amount of messages to show each time in 'readafk'");
		fprintf(YSM_CFGFD,"\nAFKMAXSHOWN>%d\n",YSM_SETTING_AFKMAXSHOWN);

/* Proxy Stuff */
		fprintf(YSM_CFGFD,"\n# Proxy Configuration. For HTTPS use 1 on PROXY_HTTPS.");
		fprintf(YSM_CFGFD,"\nPROXY>0\n");
		fprintf(YSM_CFGFD,"PROXY_PORT>0\n");
		fprintf(YSM_CFGFD,"PROXY_HTTPS>0\n");

/* end of Proxy Stuff */

		fprintf(YSM_CFGFD,"\n# Set to 0 or 1 the following FLAGS to avoid");
		fprintf(YSM_CFGFD," being prompted everytime or not\n# when starting ysm");
		fprintf(YSM_CFGFD,"\nASK_KEYMAP>%d\n",
					YSM_SETTING_ASK_KEYMAP);
		fprintf(YSM_CFGFD,"ASK_DOWNLOAD>%d\n",
					YSM_SETTING_ASK_DOWNLOAD);

		fprintf(YSM_CFGFD,"\n# Set GLOBAL Logging ON(1) or OFF(0) automatically");
		fprintf(YSM_CFGFD,"\nLOGALL>0\n");

		fprintf(YSM_CFGFD,"\n# Msg Kind types are 0(ONELINE) 1(VERBOSE) 2(IRC)");
		fprintf(YSM_CFGFD,"\nMSG_KIND>%d\n",
					YSM_SETTING_MSG_KIND);

		fprintf(YSM_CFGFD,"\n# VERBOSE Level. Default is 2. Higher means more output.");
		fprintf(YSM_CFGFD,"\nVERBOSE>%d\n",
					YSM_SETTING_VERBOSE);

		fprintf(YSM_CFGFD,"\n# VERSION CHECK. Specify 0 if you want to disable it.");
		fprintf(YSM_CFGFD,"\nVERSION_CHECK>%d\n",
					YSM_SETTING_VERSION_CHECK);


#ifdef YSM_USE_ICONV

		fprintf(YSM_CFGFD,"\n# TRANS_CHARSET is charset for transfering/receiving of messages");
		fprintf(YSM_CFGFD,"\n# LOCAL_CHARSET is charset for displaying/inputting of messages");
		fprintf(YSM_CFGFD,"\n# Russian Generic are TRANS: CP1251 LOCAL: KOI8R\n");
		fprintf(YSM_CFGFD,"\nCHARSET_TRANS>0");
		fprintf(YSM_CFGFD,"\nCHARSET_LOCAL>0");
#endif

                fprintf(YSM_CFGFD,"\n\n# your ICQ slaves.\n");
                fprintf(YSM_CFGFD,"%s\n",SLAVES_TAG);
                fprintf(YSM_CFGFD,"\n\n\n# <EOF>");

                fclose(YSM_CFGFD);

        }

        else 
	{
                PRINTF(YSM_VERBOSE_BASE,
			"\nERROR creating cfg file.\n");
		YSM_Error(ERROR_CRITICAL);
	}
}	
	


	
void YSM_ReadSlaves(FILE *YSM_CFGFD) {

        UBYTE YSM_tmpbuf[MAX_PATH];
        char *auxnick,*auxuin=0;
        UWORD YSM_MORESLAVES=TRUE;
	

	while(YSM_MORESLAVES) 
	{

        AmountSlaves = 0;
        memset(YSM_tmpbuf,'\0',MAX_PATH);

	if(fgets(YSM_tmpbuf,sizeof(YSM_tmpbuf)-1,YSM_CFGFD)==NULL) 
	{
		YSM_MORESLAVES = FALSE;
		continue;
        }

	if ((YSM_tmpbuf[0]!='#') && (YSM_tmpbuf[0] != 0) && (YSM_tmpbuf[0] != '\n')) 
	{

        auxnick = strtok(YSM_tmpbuf,"\n");

        if(!strcmp(auxnick,SLAVES_TAG)) 
	{

                memset(YSM_tmpbuf,'\0',MAX_PATH);

                while(YSM_MORESLAVES) 
		{

                if (fgets(YSM_tmpbuf,sizeof(YSM_tmpbuf)-1,YSM_CFGFD)==NULL) {
                        YSM_MORESLAVES=FALSE;
                        continue;
                        }

                if ((YSM_tmpbuf[0] != '#') && (YSM_tmpbuf[0] != 0) &&
		(YSM_tmpbuf[0] != '\n'))
		{
			
                        auxnick = strtok(YSM_tmpbuf,":");
                        if(auxnick) auxuin = strtok(NULL," \n\t");

			/* AddSlavetoList returns FALSE if the SLAVE
			is repeated. */

			if(YSM_AddSlavetoList (&YSMSlavesList,
						auxnick, atoi(auxuin),0))
			{
                      		  AmountSlaves++;
			}
			

               	}

                } 
	
	}

        } 


	}

PRINTF(YSM_VERBOSE_EXTRA,"%s%d]%s\n",MSG_READ_SLAVES,AmountSlaves,NORMAL);

}


YSM_SLAVE * YSM_QuerySlaves ( UWORD TYPE, UBYTE *Extra , UDWORD Uin ) {
		
	int x;

	YSMSlavesList = YSMSlaves_First;

	switch (TYPE) {

		case SLAVE_NAME:

			for (x=0;x<strlen(Extra);x++)
					Extra[x] = tolower(Extra[x]);
			
			for ( x = 0; x < AmountSlaves; x++ ) 
			{
				if(!strcmp(YSMSlavesList->NickName,Extra))
						return YSMSlavesList;

				YSMSlavesList = YSMSlavesList->next;
			}
						
			return NULL;

			break;

		case SLAVE_UIN:

			for ( x = 0; x < AmountSlaves; x++ ) 
			{

				if (YSMSlavesList->Uin == Uin)
					return YSMSlavesList;

				YSMSlavesList = YSMSlavesList->next;
			}
			
			return NULL;

			break;

		default:

			YSM_Error (ERROR_CODE);
			break;

			}

	return 0;
}


void YSM_AddSlave ( char *Name, int Uin ) 
{
	if(YSM_AddSlavetoList (&YSMSlavesList,Name,Uin,0))
		AmountSlaves++;
	else
	{
		PRINTF(YSM_VERBOSE_FUNCTIONAL,
			"NO! Illegal Slave Clonning detected..perv!.");
		PRINTF(YSM_VERBOSE_FUNCTIONAL,
			"\n%sSLAVE ALREADY%s exists in your list!.\n",
								BRIGHT_CYAN,
								NORMAL);
		return;
	}

	PRINTF(YSM_VERBOSE_FUNCTIONAL,
		"Adding a SLAVE with #%d. Call him %s from now on.\n",Uin,Name);

	YSM_AddSlavetoDisk (Name,Uin);

        return;
}


void
YSM_AddSlavetoDisk (char *name, int uin)
{

	FILE *YSM_CFGFD,*YSM_tmp;
	char YSMBuff[MAX_PATH];

 	YSM_CFGFD = fopen(YSM_ConfigFile,"r");

	YSM_tmp = tmpfile();

        while(!feof(YSM_CFGFD)) {

            memset(YSMBuff,'\0',MAX_PATH);
            fgets(YSMBuff,sizeof(YSMBuff)-1,YSM_CFGFD);

                if(strstr(YSMBuff,SLAVES_TAG)) 
		{
			fprintf(YSM_tmp,"%s",YSMBuff);	
			fprintf(YSM_tmp,"%s:%d\n",name,uin);	

 		}

            else fprintf(YSM_tmp,"%s",YSMBuff);

        }

        fclose(YSM_CFGFD);

	rewind(YSM_tmp);

        YSM_CFGFD = fopen(YSM_ConfigFile,"w");

        while(!feof(YSM_tmp)) 
	{
                memset(YSMBuff,'\0',MAX_PATH);
                fgets(YSMBuff,sizeof(YSMBuff),YSM_tmp);
                fprintf(YSM_CFGFD,"%s",YSMBuff);
        }

         fclose(YSM_CFGFD);
         fclose(YSM_tmp);



	return;
}


void YSM_DelSlave ( char *Name ) {

        FILE *YSM_CFGFD,*YSM_tmp;
        char YSMBuff[MAX_PATH],*auxnick=0,*therest=0;
	int YSM_SLAVEDELETED=FALSE;


                YSM_CFGFD = fopen(YSM_ConfigFile,"r");

                YSM_tmp = tmpfile();

                while(!feof(YSM_CFGFD)) 
		{
                        memset(YSMBuff,'\0',MAX_PATH);
                        fgets(YSMBuff,sizeof(YSMBuff),YSM_CFGFD);

			if(strstr(YSMBuff,SLAVES_TAG))
			{
				/* Cant forget about the SLAVES TAG! */
                       		fprintf(YSM_tmp,"%s",YSMBuff);

       				memset(YSMBuff,'\0',MAX_PATH);

				while(!YSM_SLAVEDELETED)
				{
                			if (fgets(YSMBuff,sizeof(YSMBuff)-1,
							YSM_CFGFD)==NULL) 
					{
                        			YSM_SLAVEDELETED = TRUE;
                    				 continue;
                        		}

	
				        if ((YSMBuff[0]!='#') &&
						(YSMBuff[0] != 0) && 
						(YSMBuff[0] != '\n'))
					{ 
					
                        			auxnick = strtok(YSMBuff,":");
					if(auxnick) 
						therest = strtok(NULL,"");

                        		if(auxnick)
					{
						if(!strcmp(auxnick,Name)) 
						{
						
						YSM_DeleteSlavefromList (
							&YSMSlavesList,
							auxnick, atoi(therest));
							AmountSlaves--;
						}
						else
						fprintf(YSM_tmp,"%s:%s",auxnick,therest);
					}
                       			else if(strlen(YSMBuff)>2)
						fprintf(YSM_tmp,"%s",YSMBuff);
				
					}
                       			else if(strlen(YSMBuff)>2)
                       				fprintf(YSM_tmp,"%s",YSMBuff);
				}

			break;


			}
			else fprintf(YSM_tmp,"%s",YSMBuff);

                }

                fclose(YSM_CFGFD);

                YSM_CFGFD = fopen(YSM_ConfigFile,"w");

		rewind(YSM_tmp);
		
                memset(YSMBuff,'\0',MAX_PATH);

                while(!feof(YSM_tmp)) 
		{
                        memset(YSMBuff,'\0',MAX_PATH);
                        fgets(YSMBuff,sizeof(YSMBuff)-1,YSM_tmp);
                        fprintf(YSM_CFGFD,"%s",YSMBuff);

                }

                fclose(YSM_CFGFD);
                fclose(YSM_tmp);
	

	return;
}


FILE * YSM_OpenCFG ( void ) 
{
	FILE *YSM_CFGFD;
	
	if ((YSM_CFGFD = fopen(YSM_ConfigFile,"r")) != NULL) 
		return YSM_CFGFD;
	else 
		return NULL;

}

void YSM_CFGStatus ( char *validate ) 
{
	int x;

	for ( x=0;x<=strlen(validate);x++)
		validate[x] = toupper(validate[x]);

	if (!strcmp(validate,"ONLINE"))
		YSM_USER.YSM_Status = YSM_ONLINE;

	else if (!strcmp(validate,"OFFLINE"))	
		YSM_USER.YSM_Status = YSM_OFFLINE;
	
	else if (!strcmp(validate,"AWAY"))
		YSM_USER.YSM_Status = YSM_AWAY;

	else if (!strcmp(validate,"NA"))
		YSM_USER.YSM_Status = YSM_NA;
	
	else if (!strcmp(validate,"DND"))
		YSM_USER.YSM_Status = YSM_DND;

	else if (!strcmp(validate,"OCCUPIED"))
		YSM_USER.YSM_Status = YSM_OCCUPIED;

	else if (!strcmp(validate,"CHAT"))
		YSM_USER.YSM_Status = YSM_FREE_CHAT;
	
	else if (!strcmp(validate,"INVISIBLE"))
		YSM_USER.YSM_Status = YSM_INVISIBLE;

	else
		YSM_USER.YSM_Status = YSM_ONLINE;

}

void YSM_KeysSetup (void)
{
	char x;

	PRINTF(YSM_VERBOSE_BASE,
		"\n%s'help': %c 'wo': %c 'w': %c", MSG_ASK_KEYMAP1,
					YSM_KEYMAP_HELP,
					YSM_KEYMAP_WHOSON,
					YSM_KEYMAP_SLAVES);
	PRINTF(YSM_VERBOSE_BASE, "\n%s ",MSG_ASK_KEYMAP2);
	x = getchar();

	if (toupper(x) != 'Y')
	{
		PRINTF(YSM_VERBOSE_BASE,"\n");
		return;
	}

	PRINTF(YSM_VERBOSE_BASE,
		"\nWhat shortcut-key for the 'help' command? [usually 1]: "); 
	YSM_KEYMAP_HELP=getchar();

	PRINTF(YSM_VERBOSE_BASE,
		"\nWhat shortcut-key for the 'wo' command? [usually 2]: "); 
	YSM_KEYMAP_WHOSON=getchar();

	PRINTF(YSM_VERBOSE_BASE,
		"\nWhat shortcut-key for the 'w' command? [usually 3]: "); 
	YSM_KEYMAP_SLAVES=getchar();

	PRINTF(YSM_VERBOSE_BASE,
		"\nAll set, thank you.\n");
	
}

void YSM_AFKMode (UWORD turnon)
{
	time_t time_now;

	if(!turnon)
	{
		time(&time_now);

		PRINTF(YSM_VERBOSE_BASE,
			"%s %s%d%s %s",	MSG_AFK_MODE_OFF1,
					BRIGHT_BLACK,
					((time_now-YSM_AFK_Time)/60), 
					NORMAL,
					MSG_AFK_MODE_OFF2);

		PRINTF(YSM_VERBOSE_BASE,
			"%s%d%s %s %s %s",
					BRIGHT_BLACK,
					YSM_AFK_Count,
					NORMAL,
					MSG_AFK_MODE_OFF3,
					YSM_AFKFILENAME,
					MSG_AFK_MODE_OFF4);

		YSM_SETTING_AFK = FALSE;
	
		YSM_ChangeStatus (YSM_ONLINE,0x0,YSM_SeqNum);

		return;
	}

	PRINTF(YSM_VERBOSE_BASE,"%s\n",MSG_AFK_MODE_ON);

	time(&YSM_AFK_Time);

	YSM_AFK_Count = 0;
	YSM_SETTING_AFK = TRUE;

	if(!(strlen(YSM_AFKMessage)))
		strncpy(YSM_AFKMessage,YSM_AFK_MESSAGE,MAX_DATA_LEN);

	YSM_ChangeStatus (YSM_AWAY,0x0,YSM_SeqNum);

	return;

}

void YSM_ReadAFK (char *FileName)
{
	FILE *afkfile;
	char *rfilename, *rwho = NULL, *rmsg = NULL, *rtime = NULL;
	int mnum = 1, tnum = 1, size;
	char q;
	char buff[ MAX_DATA_LEN+MAX_SLAVE_NICK+MAX_UIN_LEN+2 ];

	size = strlen(FileName)+strlen(YSM_ConfigDir)+2;
	rfilename = malloc(size);
	memset(rfilename,'\0',size);
	snprintf(rfilename,size,"%s/%s",YSM_ConfigDir,FileName);

	if( (afkfile = fopen(rfilename,"r")) == NULL)
	{
		PRINTF(YSM_VERBOSE_FUNCTIONAL,
			"\nNo Messages Found :: afkfilename not found.\n");
		free (rfilename);
		return;
	}

	PRINTF(YSM_VERBOSE_FUNCTIONAL, "%s\n",MSG_AFK_READ_MSG);

	memset( buff, '\0', sizeof(buff) );

	while( !feof(afkfile) )
	{
		/* we use mnum > YSM.. since it starts as 1 already */
		if( (fgets(buff, sizeof(buff), afkfile)) == NULL ||
				mnum > YSM_SETTING_AFKMAXSHOWN)
		{

		PRINTF(YSM_VERBOSE_BASE,
			"\n" BRIGHT_BLUE "[N]ext %i  [C]lear all  [Q]uit "
						NORMAL, 
						YSM_SETTING_AFKMAXSHOWN);
				
			q = getchar();
			switch(toupper(q))
			{
				case 'C':
					PRINTF(YSM_VERBOSE_FUNCTIONAL,
							"\nClearing..\n");
					fclose(afkfile);
					afkfile = fopen(rfilename, "w");
					fprintf(afkfile," ");
					fclose(afkfile);
					free (rfilename);
					return;
	
					break;

				case 'N':
					mnum = 1;
					break;

				default :
					PRINTF(YSM_VERBOSE_BASE,"\n");
					fclose(afkfile);
					free (rfilename);
					return;
					break;
			}

		}

		if(strlen(buff) < 2)
			continue;

		rwho = strtok(buff," ");
		if (rwho)
		{	
			rmsg = strtok(NULL,"<@#>");
			if (rmsg)
				rtime = strtok(NULL, "");
		}
		else
		{
			PRINTF(YSM_VERBOSE_BASE,"\nreadafk :: parsing error.");
			free (rfilename);
			fclose (afkfile);
			return;
		}
	
		if(rwho)
		{
			PRINTF(YSM_VERBOSE_BASE,
				"\n"WHITE"Msg #%i:" NORMAL" - From: %s",
							tnum, rwho );
		}
		if(rtime)
			PRINTF(YSM_VERBOSE_BASE, "\nTime: %s", rtime );
		if(rmsg)
			PRINTF(YSM_VERBOSE_BASE, "Data: %s\n", rmsg );

		mnum ++;
		tnum ++;

		memset( buff, '\0', sizeof(buff) );

	}

	PRINTF(YSM_VERBOSE_FUNCTIONAL, "\nEnd of Messages\n");

	fclose( afkfile );
	free (rfilename);

	return;
}

int
YSM_VersionCheck (void)
{

char get_string[512], *aux, *auxb;


	PRINTF(YSM_VERBOSE_BASE,
		"\n" BLUE"YSM UP-TO-DATE Version Checking.."NORMAL);

	if(YSM_Connect(YSM_VERSIONCHECK_HOST, 0x50, 
				atoi(YSM_USER.Proxy_host) ? 0x1 : 0x0, 0) < 0)
	{
		PRINTF(YSM_VERBOSE_BASE,
			"\nVersion Check failed. Connection refused.\n\n");
		return 0;
	}

	memset(get_string,'\0',sizeof(get_string));

	snprintf(get_string, sizeof(get_string)-1,
			"GET http://%s/%s HTTP/1.0\n\n",
			YSM_VERSIONCHECK_HOST,
			YSM_VERSIONCHECK_FILE );

	SOCK_WRITE (YSM_TCPSock, get_string, sizeof(get_string));
	memset(get_string,'\0',sizeof(get_string));

	SOCK_READ (YSM_TCPSock, &get_string, sizeof(get_string)-1);

	if (strstr(get_string,"200 OK"))
	{

	if ( (aux = strstr(get_string,"YSM_LAST_VERSION")) != NULL)
	{
		auxb = strtok(aux, "YSM_LAST_VERSION ");
		if(auxb)
		{
			aux = strchr(auxb,'\n');
			if(aux) *aux = '\0';

			if(!strcmp(auxb, YSM_INFORMATION2))
				PRINTF(YSM_VERBOSE_BASE,
				GREEN"Version is up-to-date!\n\n"NORMAL);
			else
				PRINTF(YSM_VERBOSE_BASE,
				RED "Version isn't last! Go get %s!\n\n"
								NORMAL, auxb);
		}
		else
			PRINTF( YSM_VERBOSE_BASE,
			"\nVersion Check Failed. Data file corrupted.\n\n");
	}

	else
		PRINTF( YSM_VERBOSE_BASE,
			"\nVersion Check Failed. Data file corrupted.\n\n");
	}

	else
		PRINTF( YSM_VERBOSE_BASE,"
		\nVersion Check failed. Data file not found on host!.\n\n");

	close(YSM_TCPSock);
	return 0;
}

void YSM_AskProxyConfiguration	(void)
{

char buf[MAX_PATH];

	PRINTF(YSM_VERBOSE_BASE,
		"\nIf you need to connect to the Internet through a Proxy.");
	PRINTF(YSM_VERBOSE_BASE,
		"\nPlease specify the address below, or just press ");
	PRINTF(YSM_VERBOSE_BASE,
		"the <enter> key.\n");

	memset(buf,0,sizeof(buf));
	PRINTF(YSM_VERBOSE_BASE,
			"\nProxy Host/IP: ");
	YSM_fgets(buf,MAX_PATH-1);

	if(strlen(buf) < 2)
		return;

	strncpy(YSM_USER.Proxy_host,buf,MAX_PATH-1);

	PRINTF(YSM_VERBOSE_BASE,
			"\nProxy Port?: ");
	memset(buf,0,sizeof(buf));
	YSM_fgets(buf,MAX_PATH-1);
	YSM_USER.Proxy_port = atoi(buf);

	PRINTF(YSM_VERBOSE_BASE,
			"\nUse https? [1/0]: ");
	memset(buf,0,sizeof(buf));
	YSM_fgets(buf,MAX_PATH-1);
	YSM_USER.Proxy_https = atoi(&buf[0]);
	
	return;
}
