/*	$Id: YSM_Slaves.c,v 1.13 2002/04/08 00:17:27 rad2k Exp $	*/
/*
-======================== You Sick Me v7 ===========================-

                                   |                                           
           - ----------------------                                          
    _      |                       |             _________________/_     _    
   _\____________   ______         _ __________  |               /             
     \           | _)    /                     \ |              /              
      \          |_\_  _/_______________/_      \|            _/               
                 |) /______________    /         \            |pix.imp         
                   /   \         )/___/         \  /          |                
  _    _\______   /    /__  ____/       - -------\/___________|               
         ` |  /__/        \/                                                   
           |          _      _           _                  __ ________ _      
           |                  )) y( O u  (s(i  C k    m.( E))                  
           |                                                                  
          -- ---------------- ---- -----                                     
                                  |                                            
                                  |                                            
-========================= YSM_Slaves.c ===============================-


YSM (YouSickMe) ICQ Client. An Original Multi-Platform ICQ client.
Copyright (C) 2002 rad2k Argentina.

YSM is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

For Contact information read the AUTHORS file.


*/

#include "YSM.h"

extern YSM_SLAVE *YSMSlaves_First,*YSMSlaves_LastRead,*YSMSlaves_LastSent;
extern UWORD AmountSlaves;

int arr_status[] = {	YSM_OFFLINE, YSM_ONLINE, YSM_INVISIBLE, YSM_NA,
			YSM_DND, YSM_OCCUPIED, YSM_FREE_CHAT, YSM_AWAY	};
	

int YSM_CountSlavesList (YSM_SLAVE *SlavesList)
{
	int i;

	for (i=1 ; SlavesList->next != 0; i++)
		SlavesList = SlavesList->next;

	return i;
}

/* 	Instead of behaving the very same way that YSM_PrintSlaves,
	when supplied with -1 (print them all) the output is still
	organized :) 						*/

void
YSM_PrintOrganizedSlaves ( YSM_SLAVE *YSMSlavesList, int FilterStatus,
							char *Fstring)
{

	int x = 0;

	/* We increase x so we skip the first array member (offline) */
	if (FilterStatus != YSM_OFFLINE)
		x++;

	if (FilterStatus == -1 && (Fstring == NULL))
		PRINTF (YSM_VERBOSE_BASE,
			"%s %d SLAVES:\n",MSG_SLAVES_LIST,AmountSlaves);

	else if (Fstring != NULL);

	else
		PRINTF (YSM_VERBOSE_BASE,
			"%s\n",MSG_SLAVES_ONLINE);


	for ( ; x < NUM_ELEM_STATUS_ARR(arr_status); x++)
			YSM_PrintSlaves(YSMSlavesList, arr_status[x], Fstring);


	PRINTF(YSM_VERBOSE_BASE, "\n");

	return;
}

/*		Let me explain the idea of Filtering (in YSM_PrintSlaves) */
/*		Since PrintSlaves is usually called from PrintOrganizedSlaves*/
/*		function, YSM_PrintSlaves will always filter and only print */
/*		those slaves with status equal to FilterStatus, UNLESS */
/*		-1 (YSM_OFFLINE) is specified. Which means 'PRINT THEM ALL' */
/*		without worring about any order */

/* 		Fstring (FilterString) when specified will make PrintSlaves */
/*		only display those slaves that start with the */
/*		String specified. */

void
YSM_PrintSlaves ( YSM_SLAVE *YSMSlavesList, int FilterStatus, char *Fstring)
{

	int x;
	char SlaveStatus[MAX_STATUS_LEN];

	YSMSlavesList = YSMSlaves_First;


	for(x=0;x<AmountSlaves;x++)
	{


		if( Fstring != NULL)
		{
			if( memcmp(YSMSlavesList->NickName, Fstring,
							strlen(Fstring)) != 0)
			{
			    	if(YSMSlavesList->next != 0)
				{
               				YSMSlavesList = YSMSlavesList->next;
					continue;
				}	
			
				else
					return;
			}

		}

		YSM_WriteStatus(YSMSlavesList->Status,SlaveStatus);

		if (YSMSlavesList->Status == FilterStatus)
		{
			PRINTF(YSM_VERBOSE_BASE, "%s [%s%s%s]  %s\n",
				YSMSlavesList->NickName,
				WHITE,SlaveStatus,NORMAL,
				YSMSlavesList->LogFlag ? "- <Log ON>" : "" );
		}

        	if(YSMSlavesList->next != 0)
               		YSMSlavesList = YSMSlavesList->next;	
			
		else break;
	}
	return;

}
	

/* 	The fl parameter is a DownloadedFlag, which if TRUE tells the contact
	being added right now was downloaded from the srv. 	*/
	
int YSM_AddSlavetoList (YSM_SLAVE **SlavesList, char *Nick, int Uin, int fl)
{
	YSM_SLAVE *new, *res;
	int x;
	char StringUIN[MAX_UIN_LEN+1];
	

	(*SlavesList) = YSMSlaves_First;	

	for (x=0;x<strlen(Nick);x++)
		Nick[x] = tolower(Nick[x]);

	memset(StringUIN,0,MAX_UIN_LEN+1);
	snprintf(StringUIN,MAX_UIN_LEN,"%d",Uin);

	/* First Seek if theres another Slave with the same UIN (Duh!) */

	if((res = YSM_FindSlaveinList(*SlavesList, Nick, Uin, TRUE)) != NULL)
	{
			/* Set it as downloaded ! */
			res->DownloadedFlag = TRUE;	
			return FALSE;
	}

	/* Now with the same nick (Conflict!) */
	if(YSM_FindSlaveinList(*SlavesList, Nick, Uin, FALSE) != NULL)
		Nick = &StringUIN[0];
	

	new = (YSM_SLAVE *) malloc(sizeof(YSM_SLAVE));		

	memset(new,'\0',sizeof(YSM_SLAVE));

	new->Uin = Uin;
	strncpy(new->NickName,Nick,MAX_SLAVE_NICK);
	new->Status = -1L;
	new->LogFlag = 0;
	new->DownloadedFlag = fl;

	/* el nuevo nodo apunta a lo que era el primer nodo */
	new->next = *SlavesList;

	/* Cambiamos el puntero back del siguiente para que apunte a este */
	new->next->back = new;

	/* ahora el primer nodo es el nuevo nodo */
	*SlavesList = new;

	YSMSlaves_First = *SlavesList;

	return TRUE;
}


void YSM_DeleteSlavefromList (YSM_SLAVE **SlavesList, char *Nick, int Uin)
{
	YSM_SLAVE *new, *res;
	int x;

	(*SlavesList) = YSMSlaves_First;

	for (x=0;x<strlen(Nick);x++)
		Nick[x] = tolower(Nick[x]);

	/* Pretty important. (for the a and r commands specially) */

	if(YSMSlaves_LastSent != NULL)
	{
		if(!strcmp(YSMSlaves_LastSent->NickName,Nick))
					YSMSlaves_LastSent = NULL;
	}

	if(YSMSlaves_LastRead != NULL)
	{
		if(!strcmp(YSMSlaves_LastRead->NickName,Nick))
					YSMSlaves_LastSent = NULL;
	}

			
	res = YSM_FindSlaveinList(*SlavesList, Nick, Uin, TRUE);

	if(res != NULL)	
	{

		if(res != YSMSlaves_First)
		{

		/* Hacemos que nuestro nodo sea el siguiente de
						quien queremos eliminar. */
			new = res->next;
			res->back->next = new;

			/* Eliminamos el primero */

			free(res);

		}

		else
		{
			new = res->next;
		
			free(res);

			res = new;

			YSMSlaves_First = res;
		}

	}

	
	return;
}

/*	if fl is TRUE, Find will do a find by UIN. 
	if fl is FALSE, Find will do a find by Nick.	*/

YSM_SLAVE *
YSM_FindSlaveinList (YSM_SLAVE *SlavesList, char *Nick, int Uin, int fl)
{
	int i;

	

	for (i=1 ; SlavesList->next != 0; i++)
	{
			if(fl)
			{
				if(SlavesList->Uin == Uin)
						return SlavesList;
			}
			else
			{
				if(!strcmp(SlavesList->NickName,Nick))
						return SlavesList;
			}

		SlavesList = SlavesList->next;
	}

	return NULL;
}

int YSM_ParseSlave (char *name)
{
        char *token, *obuf;
        int size,x,y=0;

        size = strlen(name);
        obuf = malloc(size+1);
        memset(obuf,'\0',size+1);
        token = strtok(name," ");

        while(token)
        {
                strncat(obuf,token,size);
                token = strtok(NULL," ");
        }

        memset(name,'\0',size);

        for (x=0;x<size;x++)
        {
                if(isalnum(obuf[x]))
                {
                        name[y] = obuf[x];
                        y++;
                }
        }

        free(obuf);

        return y;
}

YSM_SLAVE *	YSM_SlaveCompletition	(char *Name)
{
	int i;
	YSM_SLAVE *node;

	node = YSMSlaves_First;

	for (i=1 ; node->next != 0; i++)
	{
		if(!memcmp(node->NickName,Name,strlen(Name)))
				return node;

		node = node->next;
	}

	return NULL;

}
