/*	$Id: YSM_ToolBox.c,v 1.11 2002/04/07 23:45:00 rad2k Exp $	*/
/*
-======================== You Sick Me v7 ===========================-

                                   |                                           
           - ----------------------                                          
    _      |                       |             _________________/_     _    
   _\____________   ______         _ __________  |               /             
     \           | _)    /                     \ |              /              
      \          |_\_  _/_______________/_      \|            _/               
                 |) /______________    /         \            |pix.imp         
                   /   \         )/___/         \  /          |                
  _    _\______   /    /__  ____/       - -------\/___________|               
         ` |  /__/        \/                                                   
           |          _      _           _                  __ ________ _      
           |                  )) y( O u  (s(i  C k    m.( E))                  
           |                                                                  
          -- ---------------- ---- -----                                     
                                  |                                            
                                  |                                            
-======================== YSM_ToolBox.c ============================-


YSM (YouSickMe) ICQ Client. An Original Multi-Platform ICQ client.
Copyright (C) 2002 rad2k Argentina.

YSM is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

For Contact information read the AUTHORS file.

*/

#include "YSM.h"
/* International Languages Charset Convertion! */
#include "YSM_Iconv.h"


static struct timeval tv;
static fd_set readfds;
static int max_fd;

extern char *YSM_GroupID_List;
extern char *YSM_GroupID_Users;

extern UBYTE YSM_ConfigDir[MAX_PATH];

void YSM_Error(int LEVEL) {
	
	switch(LEVEL) {

		case ERROR_CODE:
			PRINTF(YSM_VERBOSE_BASE, "%s",ERROR_CODE_M);
			exit(-1);
			break;

		case ERROR_NETWORK:
			PRINTF(YSM_VERBOSE_BASE, "%s",ERROR_NETWORK_M);
			exit(-1);
			break;

		case ERROR_CRITICAL:
			PRINTF(YSM_VERBOSE_BASE, "%s",ERROR_CRITICAL_M);
			exit(-1);
			break;
	}

}



void DumpFLAP (FLAP_Head *incoming)
{
        FILE *archivo;

                PRINTF(YSM_VERBOSE_BASE, "\n- about to write log dump - ");

                archivo = fopen(YSM_DUMP_FILE,"a");

                fprintf(archivo,"Command Start: %d\n",incoming->cmd);
                fprintf(archivo,"Channel ID: %d\n",incoming->channelID);
                fprintf(archivo,"Sequence Number: %d\n", Chars_2_Word(incoming->seq));
                fprintf(archivo,"Data Length: %d\n", Chars_2_Wordb(incoming->dlen));
                PRINTF(YSM_VERBOSE_BASE, "- Dump Complete -");
                fclose(archivo);

        return;
}


void DumpSNAC (SNAC_Head incoming)
{
        FILE *archivo;

                archivo = fopen(YSM_DUMP_FILE,"a");

                fprintf(archivo,"Family ID: %.2x\n",Chars_2_Wordb(incoming.familyID));
                fprintf(archivo,"SubType ID: %.2x\n",Chars_2_Wordb(incoming.SubTypeID));
                fprintf(archivo,"Flags A: %.2x\n",incoming.Flags_a);
                fprintf(archivo,"Flags B: %.2x\n",incoming.Flags_b);
                fprintf(archivo,"Req ID: %x\n",incoming.ReqID);
                PRINTF(YSM_VERBOSE_BASE, "- Dump Complete -\n");
                fclose(archivo);

        return;
}

int InsertTLV (void *string, int type, void *memplace, int len)
{
	TLV thetlv;
	int ret;

		Word_2_Charsb(thetlv.type,type);
		Word_2_Charsb(thetlv.len,len);

		memcpy(memplace,&thetlv,sizeof(thetlv));
		memcpy((char *)memplace+sizeof(thetlv),string,len);

		ret = sizeof(thetlv) + len;

		return ret;
}


int YSM_LookupStatus (char *name)
{
	int x;

	for(x=0;x<strlen(name);x++)
		name[x] = toupper(name[x]);

	if(!strcmp(name,"ONLINE")) return YSM_ONLINE;
	if(!strcmp(name,"OFFLINE")) return YSM_OFFLINE;
	if(!strcmp(name,"INVISIBLE")) return YSM_INVISIBLE;
	if(!strcmp(name,"NA")) return YSM_NA;
	if(!strcmp(name,"DND")) return YSM_DND;
	if(!strcmp(name,"OCCUPIED")) return YSM_OCCUPIED;
	if(!strcmp(name,"FREECHAT")) return YSM_FREE_CHAT;
	if(!strcmp(name,"AWAY")) return YSM_AWAY;

	return -1;
}


void YSM_WriteFingerPrint(int client, char *buf)
{

	switch(client)
	{
		case FINGERPRINT_YSM_CLIENT:
			strncpy(buf," YSM client.", MAX_CMD_LEN-1);
			break;
		
		case FINGERPRINT_YSM_WIN32_CLIENT:
			strncpy(buf," YSM Windows client.", MAX_CMD_LEN-1);
			break;
		
		case FINGERPRINT_MIRANDA_CLIENT:
			strncpy(buf," Miranda client.", MAX_CMD_LEN-1);
			break;

		case FINGERPRINT_TRILLIAN_CLIENT:
			strncpy(buf," Trillian client.", MAX_CMD_LEN-1);
			break;

		case FINGERPRINT_CENTERICQ_CLIENT:
			strncpy(buf," centerICQ client.", MAX_CMD_LEN-1);
			break;

		case FINGERPRINT_MISC_CLIENT:
			strncpy(buf, " Mirabilis or Unknown client.\nPossibly because the slave hasn't messaged you.", MAX_CMD_LEN-1);
			break;
			
		default:
			break;
	}



	return;
}

void YSM_WriteStatus(int STATUS,char *buf)
{

	switch(STATUS)
	{
		case YSM_ONLINE :
			strncpy(buf,"ONLINE",MAX_STATUS_LEN);
			break;

		case YSM_OFFLINE :
			strncpy(buf,"OFFLINE",MAX_STATUS_LEN);
			break;

		case YSM_INVISIBLE :
			strncpy(buf,"INVISIBLE",MAX_STATUS_LEN);
			break;

		case YSM_NA :
			strncpy(buf,"NA",MAX_STATUS_LEN);
			break;

		case YSM_DND :
			strncpy(buf,"DND",MAX_STATUS_LEN);
			break;

		case YSM_OCCUPIED :
			strncpy(buf,"OCCUPIED",MAX_STATUS_LEN);
			break;

		case YSM_FREE_CHAT :
			strncpy(buf,"FREE4CHAT",MAX_STATUS_LEN);
			break;

		case YSM_AWAY :
			strncpy(buf,"AWAY",MAX_STATUS_LEN);
			break;

		default:
			strncpy(buf,"UNK",MAX_STATUS_LEN);
			break;

	}

	return;
}

int YSM_DumpLogFile (char *fname,char *data)
{
	FILE *log;
	int size=0;
	char *slavelog;

		/* 1 byte for / and another for the ending 0! */
		size = strlen(fname)+strlen(YSM_ConfigDir)+2;
		slavelog = malloc(size);
		memset(slavelog,'\0',size);
		snprintf(slavelog,size,"%s/%s",YSM_ConfigDir,fname);

		if ( (log = fopen(slavelog,"a")) == NULL)
			return -1;

		fprintf(log,"%s",data);

		fclose(log);
		free(slavelog);

	return 0;
}

#ifndef WIN32 

void YSM_CheckSecurity (void)
{
#ifndef BEOS /* Non-BeOS only, 
BeOS is a single user system currently and local Security is not in place */
	if (!getuid())
	{
		PRINTF(YSM_VERBOSE_BASE, "%sHOLD IT!%s I'm sorry, but i WONT let you run YSM\n",
							RED,NORMAL);
		PRINTF(YSM_VERBOSE_BASE, "with uid 0. Don't run Ysm as root!. ..fag.\n");
		exit (-1);
	}
#endif /* End Non-BeOS */
	return;
}

#endif


/* Thanks a lot to mICQ for these convertion Functions. 
		I made some Big Endian ones out of them */

UDWORD Chars_2_DW (UBYTE * buf)
{
    UDWORD i;

    i = buf[3];
    i <<= 8;
    i += buf[2];
    i <<= 8;
    i += buf[1];
    i <<= 8;
    i += buf[0];

    return i;
}

UWORD Chars_2_Word (UBYTE * buf)
{
    UWORD i;

    i = buf[1];
    i <<= 8;
    i += buf[0];

    return i;
}

/* nuevo big endian */
UWORD Chars_2_Wordb (UBYTE * buf)
{
    UWORD i;

    i = buf[0];
    i <<= 8;
    i += buf[1];

    return i;
}

void DW_2_Chars (UBYTE * buf, UDWORD num)
{
    buf[3] = (UBYTE) ((num) >> 24) & 0x000000FF;
    buf[2] = (UBYTE) ((num) >> 16) & 0x000000FF;
    buf[1] = (UBYTE) ((num) >> 8) & 0x000000FF;
    buf[0] = (UBYTE) (num) & 0x000000FF;
}

/* intel little endian */
void Word_2_Chars (UBYTE * buf, UWORD num)
{
    buf[1] = (UBYTE) (((unsigned) num) >> 8) & 0x00FF;
    buf[0] = (UBYTE) ((unsigned) num) & 0x00FF;
}

/* big endian code */
void Word_2_Charsb (UBYTE * buf, UWORD num)
{
    buf[0] = (UBYTE) (((unsigned) num) >> 8) & 0x00FF;
    buf[1] = (UBYTE) ((unsigned) num) & 0x00FF;
}


void EncryptPassword (char *Password, char *output)
{

	int x;
	static const UBYTE tablilla[] = 
	{
    		0xF3, 0x26, 0x81, 0xC4, 0x39, 0x86, 0xDB, 0x92, 0x71, 0xA3, 0xB9, 0xE6,
    		0x53, 0x7A, 0x95, 0x7C,
	};

	for(x=0;x<strlen(Password);x++)
		*(output+x) =  Password[x] ^ tablilla[x];

	return;
}

void YSM_FDSelect_init (void)
{
    FD_ZERO (&readfds);
    max_fd = 0;
}

void YSM_FDSet_timeout (UDWORD sec, UDWORD usec)
{
    tv.tv_sec = sec;
    tv.tv_usec = usec;
}

void YSM_FDAdd_rsocket (int sok)
{
    FD_SET (sok, &readfds);
    if (sok > max_fd)
        max_fd = sok;
}

int YSM_FDIs_Set (int sok)
{
    return (FD_ISSET(sok, &readfds));
}

int YSM_FDSelect (void)
{
    int res;

    /* don't care about writefds and exceptfds: */
    res = select (max_fd + 1, &readfds, NULL, NULL, &tv);
    if (res == -1)
        FD_ZERO (&readfds);
    return res;
}

#ifdef YSM_USE_ICONV

int
YSM_Iconv (char *charset_from, char *charset_to, char *buf_from, char **buf_to, size_t maxlen)
{
       char *inptr   = buf_from;
       char *outptr  = 0;

       size_t bytes_in;
       size_t bytes_out;
       size_t bytes_res;

       iconv_t conv_d;

       PRINTF(YSM_VERBOSE_DEBUG_4, "DEBUG: FROM CHARSET: %s\n", charset_from);
       PRINTF(YSM_VERBOSE_DEBUG_4, "DEBUG: TO CHARSET: %s\n",   charset_to);

       if (!charset_from || !charset_to || !buf_from || !buf_to) return -1;


       if (strlen(charset_from) <= 1)
		return -1;


       if (strlen(charset_to) <= 1)
		return -1;

       if (!(*buf_to = calloc(1, maxlen)))
               return -1;

       outptr    = *buf_to;
       bytes_in  = strlen(buf_from) + 1;
       bytes_out = maxlen - 1;
       conv_d    = iconv_open(charset_to, charset_from);
       bytes_res = iconv(conv_d, &inptr, &bytes_in, &outptr, &bytes_out);
       iconv_close(conv_d);
       return 0;
}

#endif

/* Get Time in MicroSeconds, and if value is smaller than the MicroSeconds
 * at the very moment, then return -1  
 */

#if !defined(WIN32) && !defined(BEOS)	
long
YSM_GetMicroTime (long input)
{

struct timeval rtimeout;

	if(!gettimeofday (&rtimeout, NULL))
	{
		if(!input || rtimeout.tv_usec < input)
			return rtimeout.tv_usec;
	}
	return -1;
}
#endif

void
YSM_Destructor (void)
{
	if(YSM_GroupID_List != NULL) free (YSM_GroupID_List);
	if(YSM_GroupID_Users != NULL) free(YSM_GroupID_Users); 

	return;
}
