/*	$Id: YSM_Win32.c,v 1.18 2002/04/07 23:36:58 rad2k Exp $	*/
/*
-======================== You Sick Me v7 ===========================-

                                   |                                           
           - ----------------------                                          
    _      |                       |             _________________/_     _    
   _\____________   ______         _ __________  |               /             
     \           | _)    /                     \ |              /              
      \          |_\_  _/_______________/_      \|            _/               
                 |) /______________    /         \            |pix.imp         
                   /   \         )/___/         \  /          |                
  _    _\______   /    /__  ____/       - -------\/___________|               
         ` |  /__/        \/                                                   
           |          _      _           _                  __ ________ _      
           |                  )) y( O u  (s(i  C k    m.( E))                  
           |                                                                  
          -- ---------------- ---- -----                                     
                                  |                                            
                                  |                                            
-========================== YSM_Win32.c ============================-


YSM (YouSickMe) ICQ Client. An Original Multi-Platform ICQ client.
Copyright (C) 2002 rad2k Argentina.

YSM is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

For Contact information read the AUTHORS file.

*/

#ifndef WIN32	/* UNIX */

#include <sys/types.h>
#include <sys/ioctl.h>
#include <errno.h>
#include <stdarg.h>
#include <stdlib.h>
#include <string.h>
#include <termios.h>
#include <unistd.h>

#else		/* WINDOWS */

#include <sys/types.h>
#include <errno.h>
#include <stdarg.h>
#include <string.h>
#include <conio.h> 

#endif	/* WIN32 */

#include "YSM.h"

#ifdef BEOS /* BeOS */
#define _getch getchar
//Make up for lack of usleep
int usleep(int x) {
	//Should really be somthing here...
	return 0;
}
#endif /* BeOS */

extern UWORD YSM_SETTING_VERBOSE;

#if defined (WIN32)	/* WINDOWS */
int
getkey()
{
	static HANDLE handle;
	int read;
	INPUT_RECORD r;
			
	if (!handle)
		handle = GetStdHandle(STD_INPUT_HANDLE);

	do {
		if (!GetNumberOfConsoleInputEvents(handle, &read) || !read)
			return (0);
		if (!ReadConsoleInput(handle,&r,1,&read) || !read)
			return (0);
	} while (r.EventType != KEY_EVENT || !r.Event.KeyEvent.bKeyDown);


	return (r.Event.KeyEvent.uChar.AsciiChar);
}


int
getxy(int *x, int *y)
{
	/* XXX sorry, no getxy() on windoze yet */
	return (0);
}


void
do_backspace()
{
	putchar(0x08);
	putchar(0x20);
	putch(0x08);
}


char *
YSM_fgets(char *str, int size)
{
	/* XXX sorry, no cool fgets on windoze yet */
	return (fgets(str, size, stdin));
}


int
PRINTF(int verbose_level, char *fmt,...)
{
	static HANDLE handle;
	int written;
	char ibuf[4096], *p, *q;
	va_list argptr;

	if ( verbose_level > YSM_SETTING_VERBOSE ) 
			return -1;

	if (!handle)
		handle = GetStdHandle(STD_OUTPUT_HANDLE);

	va_start(argptr, fmt);
	vsprintf(ibuf, fmt, argptr);
	va_end(argptr);

	p = ibuf;
	while ((q = strchr(p, 0x1b)) != NULL) {
		WriteConsole(handle, p, q-p, &written, 0);
		p = q;
		while (*p && *p != ';')
			p++;
		if (*p) {
			int color;
			p++;
			color = atoi(p);
			while (*p && *p != 'm')
				p++;
			if (*p)
				p++;

			switch (color) {
			case 30:
				color = 0;
				break;
			case 31:
				color = FOREGROUND_RED | FOREGROUND_INTENSITY;
				break;
			case 32:
				color = FOREGROUND_GREEN;
				break;
			case 33:
				color = FOREGROUND_RED | FOREGROUND_GREEN;
				break;
			case 34:
				color = FOREGROUND_RED | FOREGROUND_GREEN;
				break;
			case 35:
				color = FOREGROUND_RED | FOREGROUND_BLUE;
				break;
			case 36:
				color = FOREGROUND_GREEN | FOREGROUND_BLUE |
				    FOREGROUND_INTENSITY;
				break;
			case 37:
			default:
				color = FOREGROUND_RED | FOREGROUND_GREEN |
				    FOREGROUND_BLUE | FOREGROUND_INTENSITY;
				break;
			}
			SetConsoleTextAttribute(handle, color);
		}
	}

	if (*p)
		WriteConsole(handle, p, strlen(p), &written, 0);

	return 0;
}

#else		/* UNIX */

int
getkey()
{
	unsigned char c;

	if (read(STDIN_FILENO, &c, sizeof(unsigned char)) <= 0) {
		fprintf(stderr, "Can't read: %s.\n", strerror(errno));
		YSM_Error(ERROR_CRITICAL);
		/* NOTREACHED */
	}
	return ((int)c);
}


int
putch(int c)
{
	putchar(c);
	fflush(stdout);
	return (0);
}


int
getxy(int *x, int *y)
{
	char buf[20], *p, *q;
	ssize_t r, i;

	fprintf(stdout, "\x1B[6n");
	fflush(stdout);

	usleep(50000);
	if ((r = read(STDIN_FILENO, buf, sizeof(buf) - 1)) < 0)
		return (0);

	buf[r] = '\0';

	for (--r, i = 0; i < r && buf[i] != '\x1B' && buf[i+1] != '['; i++);
	if (i >= r)
		return (0);

	for (p = &buf[i]; *p != '\0' && *p != 'R'; p++);
	for (q = &buf[i]; *q != '\0' && *q != ';'; q++);
	if (*p == '\0' || *q == '\0')
		return (0);

	*p = '\0';
	*q = '\0';
	*x = atoi(q + 1);
	*y = atoi(&buf[i+2]);

	return (1);
}


void
do_backspace()
{
	struct winsize w;
	int x, y, x2, y2;
	char *p;

	p = "\x1B[1D\x1B[K";

	if (ioctl(STDOUT_FILENO, TIOCGWINSZ, &w) != -1 && getxy(&x, &y)) {
		if (x == w.ws_col) {
			putchar(0x20);
			if (getxy(&x2, &y2)) {
				if (x2 == x)
					x--;

				if (y2 == y && x > x2 && x == w.ws_col)
					y--;

				fprintf(stdout, "\x1B[%d;%df\x1B[K", y, x);
				p = "";

			} else
				p = "\x1B[2D\x1B[K";

		} else if (x == 1) {
			if (y > 1) {
				y--;
				x = w.ws_col;
			}

			fprintf(stdout, "\x1B[%d;%df", y, x);
			p = "";
		}
	}

	if (*p != '\0')
		fprintf(stdout, p);

	fflush(stdout);
}


char *
YSM_fgets(char *str, int size)
{
	unsigned char c;
	int i;

	if (size <= 0) {
		errno = EINVAL;
		return (NULL);
	}

	i = 0;
	str[i] = '\0';
	while (i < size) {
		c = getkey();
		switch (c) {
		case 0x08:
		case 0x7F:
			if (i) {
				str[--i] = '\0';
				do_backspace();
			}
			break;

		case '\n':
			putch(c);
			str[i++] = '\n';

		case '\0':
			str[i] = '\0';
			return (str);

		default:
			str[i++] = c;
			str[i] = '\0';
			putch(c);
		}
	}

	return (str);
}


int
PRINTF(int verbose_level, char *fmt, ...)
{
	va_list argptr;
	int st;

	if ( verbose_level > YSM_SETTING_VERBOSE ) 
		return -1;

	va_start(argptr, fmt);
	st = vprintf(fmt, argptr);
	va_end(argptr);

	fflush(stdout);

	return (st);
}

#endif	/* WIN32 */


/*
 * port for the getpass(3) function used in *nix.
 */

#if defined (WIN32) || defined (BEOS)

char *
getpass (const char *prompt)
{

static char password[MAX_PWD_LEN+1];
int n = 0;

	memset(password,'\0',sizeof(password));

	fputs(prompt, stderr);

	while ( ((password[n] = _getch()) != '\r') && n <= MAX_PWD_LEN )
	{
		if( password[n] >= ' ' && password[n] <= '~' )
		{
			n++;
			PRINTF (YSM_VERBOSE_BASE,"*");
		}
		else
		{
			if( (password[n] == 0x08) && (n > 0) )
			{
				do_backspace();
				n--;
			}
	
			else
			{
				PRINTF (YSM_VERBOSE_BASE,"\n");
				fputs(prompt, stderr);
				n = 0;
			}
		}
	}

	if( password[n] == '\r' || password[n] == '\n' ) password[n] = '\0';
	password[n+1] = '\0';

	PRINTF(YSM_VERBOSE_BASE,"\n");

	return (char *) &password;
}

#endif /* WIN32 || BEOS */
